Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:02 2012
FILE NAME: rad_SL09.f90
PROGRAM NAME: rad_sl09
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   174  opt  (1592): Outer loop unrolled inside inner loop.
   174  vec  (   4): Vectorized array expression.
   174  vec  (   4): Vectorized array expression.
   185  vec  (   3): Unvectorized loop.
   185  vec  (  13): Overhead of loop division is too large.
   185  vec  (   3): Unvectorized loop.
   185  vec  (  13): Overhead of loop division is too large.
   186  opt  (1592): Outer loop unrolled inside inner loop.
   186  vec  (   4): Vectorized array expression.
   186  vec  (   4): Vectorized array expression.
   189  vec  (   1): Vectorized loop.
   189  vec  (   1): Vectorized loop.
   195  opt  (1592): Outer loop unrolled inside inner loop.
   200  opt  (1592): Outer loop unrolled inside inner loop.
   200  vec  (   4): Vectorized array expression.
   200  vec  (   4): Vectorized array expression.
   215  opt  (1592): Outer loop unrolled inside inner loop.
   215  vec  (   4): Vectorized array expression.
   215  vec  (   4): Vectorized array expression.
   230  warn (  82): Name "k" is not used.
   316  opt  (  11): Fused array assignments. :line 316 - 317
   316  vec  (   4): Vectorized array expression.
   316  vec  (   4): Vectorized array expression.
   317  opt  (1592): Outer loop unrolled inside inner loop.
   323  vec  (   3): Unvectorized loop.
   323  vec  (  13): Overhead of loop division is too large.
   324  opt  (1592): Outer loop unrolled inside inner loop.
   324  vec  (   4): Vectorized array expression.
   324  vec  (   4): Vectorized array expression.
   330  opt  (1592): Outer loop unrolled inside inner loop.
   330  vec  (   4): Vectorized array expression.
   330  vec  (   4): Vectorized array expression.
   332  vec  (   3): Unvectorized loop.
   332  vec  (  13): Overhead of loop division is too large.
   333  opt  (1037): Feedback of array elements.
   333  opt  (1592): Outer loop unrolled inside inner loop.
   333  vec  (   4): Vectorized array expression.
   333  vec  (   4): Vectorized array expression.
   337  vec  (   3): Unvectorized loop.
   337  vec  (  13): Overhead of loop division is too large.
   338  opt  (1036): Potential feedback - use directive if OK.
   338  opt  (1592): Outer loop unrolled inside inner loop.
   338  vec  (   4): Vectorized array expression.
   338  vec  (   4): Vectorized array expression.
   349  opt  (  11): Fused array assignments. :line 349 - 350
   349  vec  (   4): Vectorized array expression.
   349  vec  (   4): Vectorized array expression.
   350  opt  (1592): Outer loop unrolled inside inner loop.
   356  vec  (   3): Unvectorized loop.
   356  vec  (  13): Overhead of loop division is too large.
   357  opt  (1592): Outer loop unrolled inside inner loop.
   357  vec  (   4): Vectorized array expression.
   357  vec  (   4): Vectorized array expression.
   368  opt  (1592): Outer loop unrolled inside inner loop.
   368  vec  (   4): Vectorized array expression.
   368  vec  (   4): Vectorized array expression.
   372  opt  (1592): Outer loop unrolled inside inner loop.
   372  vec  (   4): Vectorized array expression.
   372  vec  (   4): Vectorized array expression.
   374  vec  (   3): Unvectorized loop.
   374  vec  (  13): Overhead of loop division is too large.
   375  opt  (1592): Outer loop unrolled inside inner loop.
   375  vec  (   4): Vectorized array expression.
   375  vec  (   4): Vectorized array expression.
   382  opt  (1592): Outer loop unrolled inside inner loop.
   382  vec  (   4): Vectorized array expression.
   382  vec  (   4): Vectorized array expression.
   388  vec  (   3): Unvectorized loop.
   388  vec  (  13): Overhead of loop division is too large.
   389  opt  (  11): Fused array assignments. :line 389 - 391
   389  vec  (   4): Vectorized array expression.
   389  vec  (   4): Vectorized array expression.
   391  opt  (1592): Outer loop unrolled inside inner loop.
   426  opt  (1593): Loop nest collapsed into one loop.
   426  vec  (   1): Vectorized loop.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:02 2012
FILE NAME: rad_SL09.f90
PROGRAM NAME: rad_sl09
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != Schneider and Liu (2009) ͥǥ
     2  !
     3  != Radiation model by Schneider and Liu (2009)
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: rad_SL09.f90,v 1.5 2012-09-17 10:59:31 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  module rad_SL09
    12    !
    13    != Schneider and Liu (2009) ͥǥ
    14    !
    15    != Radiation model by Schneider and Liu (2009)
    16    !
    17    ! <b>Note that Japanese and English are described in parallel.</b>
    18    !
    19    !
    20    !
    21    ! This is a radiation model described by Schneider and Liu (2009).
    22    !
    23    !== References
    24    !
    25    !  Schneider, T. and J. Liu,
    26    !    Formation of jets and equatorial superrotation on Jupiter,
    27    !    J. Atmos. Sci., 69, 579, 2009.
    28    !
    29    !== Procedures List
    30    !
    31  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    32  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    33  !!$  ! RadiationFluxOutput     :: ͥեåν
    34  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    35  !!$  ! ------------            :: ------------
    36  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    37  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    38  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    39  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    40    !
    41    !== NAMELIST
    42    !
    43    ! NAMELIST#rad_SL09_nml
    44    !
    45  
    46    ! USE statements
    47    !
    48  
    49    !
    50    ! Kind type parameter
    51    !
    52    use dc_types, only: DP, &      ! Double precision.
    53      &                 STRING, &  ! Strings.
    54      &                 TOKEN      ! Keywords.
    55  
    56    ! ʻ
    57    ! Grid points settings
    58    !
    59    use gridset, only: imax, & ! ٳʻ.
    60                               ! Number of grid points in longitude
    61      &                jmax, & ! ٳʻ.
    62                               ! Number of grid points in latitude
    63      &                kmax    ! ľؿ.
    64                               ! Number of vertical level
    65  
    66    implicit none
    67  
    68    private
    69  
    70  
    71    ! Private variables
    72    !
    73    real(DP), save :: SWOptDepAtRefPress
    74    real(DP), save :: SWRefPress
    75    real(DP), save :: SWOrd
    76    real(DP), save :: LWOptDepAtRefPress
    77    real(DP), save :: LWRefPress
    78    real(DP), save :: LWOrd
    79    real(DP), save :: SolarConst
    80  
    81  
    82    ! ѿ
    83    ! Public variables
    84    !
    85    logical, save, public:: rad_SL09_inited = .false.
    86                                ! ե饰.
    87                                ! Initialization flag
    88  
    89    public :: RadSL09Init
    90    public :: RadSL09Flux
    91  
    92    character(*), parameter:: module_name = 'rad_SL09'
    93                                ! ⥸塼̾.
    94                                ! Module name
    95    character(*), parameter:: version = &
    96      & '$Name: dcpam5-20120921 $' // &
    97      & '$Id: rad_SL09.f90,v 1.5 2012-09-17 10:59:31 yot Exp $'
    98                                ! ⥸塼ΥС
    99                                ! Module version
   100  
   101    !--------------------------------------------------------------------------------------
   102  
   103  contains
   104  
   105    !--------------------------------------------------------------------------------------
   106  
   107    subroutine RadSL09Flux(                           &
   108      & xyr_Press, xyz_Temp,                          &
   109      & xyr_RadSFlux, xyr_RadLFlux, xyra_DelRadLFlux  &
   110      & )
   111  
   112  
   113      ! USE statements
   114      !
   115  
   116      ! å
   117      ! Message output
   118      !
   119      use dc_message, only: MessageNotify
   120  
   121      ! ʪ
   122      ! Physical and mathematical constants settings
   123      !
   124      use constants0, only: &
   125        & PI                    ! $ \pi $ .
   126                                ! ߼Ψ.  Circular constant
   127  
   128      ! ɸǡ
   129      ! Axes data settings
   130      !
   131      use axesset, only : y_Lat
   132  
   133      !
   134      ! Solve radiative transfer equation in two stream approximation
   135      !
   136      use rad_rte_two_stream_app, only: OLD_RadRTETwoStreamAppHomogAtm
   137  
   138      real(DP), intent(in ) :: xyr_Press    ( 0:imax-1, 1:jmax, 0:kmax )
   139      real(DP), intent(in ) :: xyz_Temp     ( 0:imax-1, 1:jmax, 1:kmax )
   140      real(DP), intent(out) :: xyr_RadSFlux ( 0:imax-1, 1:jmax, 0:kmax )
   141      real(DP), intent(out) :: xyr_RadLFlux    (0:imax-1, 1:jmax, 0:kmax)
   142      real(DP), intent(out) :: xyra_DelRadLFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   143  
   144  
   145      ! Work variables
   146      !
   147      real(DP) :: SolarFluxTOA
   148  !!$    real(DP) :: QeRatio
   149  !!$    real(DP) :: xyz_SSA      (0:imax-1, 1:jmax, 1:kmax)
   150  !!$    real(DP) :: xyz_AF       (0:imax-1, 1:jmax, 1:kmax)
   151      real(DP) :: xy_SurfAlbedo(0:imax-1, 1:jmax)
   152      real(DP) :: xy_InAngle   (0:imax-1, 1:jmax)
   153      real(DP) :: xy_CosSZA    (0:imax-1, 1:jmax)
   154      real(DP) :: xyr_OptDep   (0:imax-1, 1:jmax, 0:kmax)
   155  
   156      real(DP) :: SSA
   157      real(DP) :: AF
   158  
   159      integer  :: i
   160      integer  :: j
   161      integer  :: k
   162  
   163  
   164      ! 
   165      ! Initialization
   166      !
   167      if ( .not. rad_SL09_inited ) then
   168        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   169      end if
   170  
   171  
   172      ! Short wave radiation
   173      !
   174      xyr_OptDep = SWOptDepAtRefPress * ( xyr_Press / SWRefPress )**SWOrd
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t213 = 1, J1                                                
     .              D1 = 1.D0/swrefpress                                        
     .  !CDIR       NODEP                                                       
     .              do t215 = 1, imax                                           
     .                 xyr_optdep(t215-1,t213,t211) = swoptdepatrefpress*(      
     .       1            xyr_press(t215-1,t213,t211)*D1)**sword                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t213 = J1 + 1, jmax, 4                                      
     .              D2 = 1.D0/swrefpress                                        
     .              D3 = 1.D0/swrefpress                                        
     .              D4 = 1.D0/swrefpress                                        
     .              D5 = 1.D0/swrefpress                                        
     .  !CDIR       NODEP                                                       
     .              do t215 = 1, imax                                           
     .                 xyr_optdep(t215-1,t213,t211) = swoptdepatrefpress*(      
     .       1            xyr_press(t215-1,t213,t211)*D2)**sword                
     .                 xyr_optdep(t215-1,t213+1,t211) = swoptdepatrefpress*(    
     .       1            xyr_press(t215-1,t213+1,t211)*D3)**sword              
     .                 xyr_optdep(t215-1,t213+2,t211) = swoptdepatrefpress*(    
     .       1            xyr_press(t215-1,t213+2,t211)*D4)**sword              
     .                 xyr_optdep(t215-1,t213+3,t211) = swoptdepatrefpress*(    
     .       1            xyr_press(t215-1,t213+3,t211)*D5)**sword              
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   175  
   176      SolarFluxTOA  = SolarConst / PI
   177  
   178  
   179      SSA = 0.8_DP
   180      AF  = 0.204_DP
   181      !   Af = 0 may be much better than 0.204 when Eddington approximation is used.
   182  !!$    AF         = 0.0_DP
   183  
   184  
   185      do j = 1, jmax
   186        xy_CosSZA(:,j) = cos( y_Lat(j) )
   187      end do
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .           do j = 1, J2                                                   
     .  !CDIR       NODEP                                                       
     .              do t223 = 1, xy_cossza.DSC.U1 + 1                           
     .                 xy_cossza(t223-1,j) = dcos(y_lat(j))                     
     .              end do                                                      
     .           end do                                                         
     .           do j = J2 + 1, jmax, 4                                         
     .  !CDIR       NODEP                                                       
     .              do t223 = 1, xy_cossza.DSC.U1 + 1                           
     .                 xy_cossza(t223-1,j) = dcos(y_lat(j))                     
     .                 xy_cossza(t223-1,j+1) = dcos(y_lat(j+1))                 
     .                 xy_cossza(t223-1,j+2) = dcos(y_lat(j+2))                 
     .                 xy_cossza(t223-1,j+3) = dcos(y_lat(j+3))                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   188      do j = 1, jmax
   189        do i = 0, imax-1
   190          if ( xy_CosSZA(i,j) > 0.0_DP ) then
   191            xy_InAngle(i,j) = 1.0_DP / xy_CosSZA(i,j)
   192          else
   193            xy_InAngle(i,j) = 0.0_DP
   194          end if
   195        end do
   196      end do
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,1)                                               
     .           do j = 1, J3                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xy_cossza(i-1,j) .gt. 0.0000000000000000e+000) then  
     .                    xy_inangle(i-1,j) = 1.00000000000000e+000/xy_cossza(i-
     .       1               1,j)                                               
     .                 else                                                     
     .                    xy_inangle(i-1,j) = 0.0000000000000000e+000           
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J3 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xy_cossza(i-1,j) .gt. 0.0000000000000000e+000) then  
     .                    xy_inangle(i-1,j) = 1.00000000000000e+000/xy_cossza(i-
     .       1               1,j)                                               
     .                 else                                                     
     .                    xy_inangle(i-1,j) = 0.0000000000000000e+000           
     .                 endif                                                    
     .                 if (xy_cossza(i-1,j+1) .gt. 0.0000000000000000e+000) then
     .                    xy_inangle(i-1,j+1) = 1.00000000000000e+000/xy_cossza(
     .       1               i-1,j+1)                                           
     .                 else                                                     
     .                    xy_inangle(i-1,j+1) = 0.0000000000000000e+000         
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   197  
   198      !   Unused variable but this is required as an argument
   199      !
   200      xy_SurfAlbedo = 1.0d100
     .        if (xy_surfalbedo.DSC.U2 .gt. 0) then                             
     .           J4 = and(xy_surfalbedo.DSC.U2,3)                               
     .  !CDIR    NODEP                                                          
     .           do t226 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t228 = 1, xy_surfalbedo.DSC.U1 + 1                       
     .                 xy_surfalbedo(t228-1,t226) = 1.00000000000000e+100       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t226 = J4 + 1, xy_surfalbedo.DSC.U2, 4                      
     .  !CDIR       NODEP                                                       
     .              do t228 = 1, xy_surfalbedo.DSC.U1 + 1                       
     .                 xy_surfalbedo(t228-1,t226) = 1.00000000000000e+100       
     .                 xy_surfalbedo(t228-1,t226+1) = 1.00000000000000e+100     
     .                 xy_surfalbedo(t228-1,t226+2) = 1.00000000000000e+100     
     .                 xy_surfalbedo(t228-1,t226+3) = 1.00000000000000e+100     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   201  
   202      call OLD_RadRTETwoStreamAppHomogAtm(                                   &
   203        & xy_SurfAlbedo, SolarFluxTOA, xy_InAngle, SSA, AF, xyr_OptDep,  & ! (in )
   204        & xyr_RadSFlux,                                                  & ! (out)
   205        & FlagSemiInfAtm = .true., FlagSL09 = .true.                     & ! (in ) optional
   206        & )
   207  
   208  
   209  
   210      ! Long wave radiation
   211      !
   212  
   213      !   Although the surface temperature and surface emissivity are set, but are not used.
   214      !
   215      xyr_OptDep = LWOptDepAtRefPress * ( xyr_Press / LWRefPress )**LWOrd
     .        if (jmax .gt. 0) then                                             
     .           J5 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t234 = 1, J5                                                
     .              D6 = 1.D0/lwrefpress                                        
     .  !CDIR       NODEP                                                       
     .              do t236 = 1, imax                                           
     .                 xyr_optdep(t236-1,t234,t232) = lwoptdepatrefpress*(      
     .       1            xyr_press(t236-1,t234,t232)*D6)**lword                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t234 = J5 + 1, jmax, 4                                      
     .              D7 = 1.D0/lwrefpress                                        
     .              D8 = 1.D0/lwrefpress                                        
     .              D9 = 1.D0/lwrefpress                                        
     .              D10 = 1.D0/lwrefpress                                       
     .  !CDIR       NODEP                                                       
     .              do t236 = 1, imax                                           
     .                 xyr_optdep(t236-1,t234,t232) = lwoptdepatrefpress*(      
     .       1            xyr_press(t236-1,t234,t232)*D7)**lword                
     .                 xyr_optdep(t236-1,t234+1,t232) = lwoptdepatrefpress*(    
     .       1            xyr_press(t236-1,t234+1,t232)*D8)**lword              
     .                 xyr_optdep(t236-1,t234+2,t232) = lwoptdepatrefpress*(    
     .       1            xyr_press(t236-1,t234+2,t232)*D9)**lword              
     .                 xyr_optdep(t236-1,t234+3,t232) = lwoptdepatrefpress*(    
     .       1            xyr_press(t236-1,t234+3,t232)*D10)**lword             
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   216  
   217  
   218  !!$    call RadiationRTEQNonScat(                    &
   219  !!$      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyr_OptDep, & ! (in )
   220  !!$      & xyr_RadLFlux, xyra_DelRadLFlux,                 & ! (out)
   221  !!$      & xy_SurfUpRadLFluxBase = xyr_RadSFlux(:,:,0)     & ! (in ) optional
   222  !!$      & )
   223      call RadSL09LWFlux(                           &
   224        & xyz_Temp, xyr_OptDep,                     & ! (in )
   225        & xyr_RadSFlux(:,:,0),                      & ! (in )
   226        & xyr_RadLFlux, xyra_DelRadLFlux            & ! (out)
   227        & )
   228  
   229  
   230    end subroutine RadSL09Flux
   231  
   232    !--------------------------------------------------------------------------------------
   233  
   234    subroutine RadSL09LWFlux(                           &
   235      & xyz_Temp, xyr_OptDep,                           & ! (in )
   236      & xy_SurfUpRadLFluxBase,                          & ! (in )
   237      & xyr_RadLFlux, xyra_DelRadLFlux                  & ! (out)
   238      & )
   239      !
   240      ! ʤξãη׻
   241      !
   242      ! Integrate radiative transfer equation without scattering
   243      !
   244  
   245      ! ⥸塼 ; USE statements
   246      !
   247  
   248      ! å
   249      ! Message output
   250      !
   251      use dc_message, only: MessageNotify
   252  
   253      ! ʪ
   254      ! Physical and mathematical constants settings
   255      !
   256      use constants0, only: &
   257        & PI, &
   258                                ! $ \pi $ .
   259                                ! ߼Ψ.  Circular constant
   260        & StB
   261                                ! $ \sigma_{SB} $ .
   262                                ! ƥեܥĥޥ.
   263                                ! Stefan-Boltzmann constant
   264  
   265      ! ʸ ; Declaration statements
   266      !
   267  
   268      real(DP), intent(in ) :: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   269                                ! $ T $ .     . Temperature
   270      real(DP), intent(in ) :: xyr_OptDep  (0:imax-1, 1:jmax, 0:kmax)
   271                                ! Optical depth
   272      real(DP), intent(in ) :: xy_SurfUpRadLFluxBase(0:imax-1, 1:jmax)
   273      real(DP), intent(out) :: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   274                                ! Ĺȥեå.
   275                                ! Longwave flux
   276      real(DP), intent(out) :: xyra_DelRadLFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   277                                ! ĹɽѲ.
   278                                ! Surface temperature tendency with longwave
   279  
   280  
   281      ! ѿ
   282      ! Work variables
   283      !
   284      real(DP), parameter :: DiffFact = 1.66_DP
   285  
   286      real(DP):: xyr_RadLDoFlux (0:imax-1, 1:jmax, 0:kmax)
   287      real(DP):: xyr_RadLUpFlux (0:imax-1, 1:jmax, 0:kmax)
   288  
   289      real(DP):: xyz_DelTrans (0:imax-1, 1:jmax, 1:kmax)
   290      real(DP):: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   291                                ! Ʃ᷸.
   292                                ! Transmission coefficient
   293      real(DP):: xyz_IntPF        (0:imax-1, 1:jmax, 1:kmax)
   294                                ! Integrated Planck function
   295      real(DP):: xyz_IntDPFDT     (0:imax-1, 1:jmax, 1:kmax)
   296                                ! Integrated temperature derivative of Planck function
   297  
   298      real(DP):: xy_SurfUpRadLFlux(0:imax-1, 1:jmax)
   299  
   300      integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   301                                ! Work variables for DO loop in vertical direction
   302  
   303      ! ¹ʸ ; Executable statement
   304      !
   305  
   306      ! 
   307      ! Initialization
   308      !
   309      if ( .not. rad_SL09_inited ) then
   310        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   311      end if
   312  
   313  
   314      ! Case for grey atmosphere
   315      !
   316      xyz_IntPF       = StB * xyz_Temp**4
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t409 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t411 = 1, imax                                           
     .                 xyz_intpf(t411-1,t409,t407+1) = 5.66999999999999e-008*   
     .       1            xyz_temp(t411-1,t409,t407+1)**4                       
     .                 xyz_intdpfdt(t411-1,t409,t407+1) = 2.26799999999999e-007*
     .       1            xyz_temp(t411-1,t409,t407+1)**3                       
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t409 = J1 + 1, jmax, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t411 = 1, imax                                           
     .                 xyz_intpf(t411-1,t409,t407+1) = 5.66999999999999e-008*   
     .       1            xyz_temp(t411-1,t409,t407+1)**4                       
     .                 xyz_intpf(t411-1,t409+1,t407+1) = 5.66999999999999e-008* 
     .       1            xyz_temp(t411-1,t409+1,t407+1)**4                     
     .                 xyz_intdpfdt(t411-1,t409,t407+1) = 2.26799999999999e-007*
     .       1            xyz_temp(t411-1,t409,t407+1)**3                       
     .                 xyz_intdpfdt(t411-1,t409+1,t407+1) =                     
     .       1            2.26799999999999e-007*xyz_temp(t411-1,t409+1,t407+1)**
     .       2            3                                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   317      xyz_IntDPFDT    = 4.0_DP * StB * xyz_Temp**3
   318  
   319  
   320      ! Ʃؿ׻
   321      ! Calculate transmission functions
   322      !
   323      do k = 1, kmax
   324        xyz_DelTrans(:,:,k) = &
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t425 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t427 = 1, imax                                           
     .                 xyz_deltrans(t427-1,t425,k) = dexp((-                    
     .       1            1.65999999999999e+000*(xyr_optdep(t427-1,t425,k-1)-   
     .       2            xyr_optdep(t427-1,t425,k))))                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t425 = J2 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t427 = 1, imax                                           
     .                 xyz_deltrans(t427-1,t425,k) = dexp((-                    
     .       1            1.65999999999999e+000*(xyr_optdep(t427-1,t425,k-1)-   
     .       2            xyr_optdep(t427-1,t425,k))))                          
     .                 xyz_deltrans(t427-1,t425+1,k) = dexp((-                  
     .       1            1.65999999999999e+000*(xyr_optdep(t427-1,t425+1,k-1)- 
     .       2            xyr_optdep(t427-1,t425+1,k))))                        
     .                 xyz_deltrans(t427-1,t425+2,k) = dexp((-                  
     .       1            1.65999999999999e+000*(xyr_optdep(t427-1,t425+2,k-1)- 
     .       2            xyr_optdep(t427-1,t425+2,k))))                        
     .                 xyz_deltrans(t427-1,t425+3,k) = dexp((-                  
     .       1            1.65999999999999e+000*(xyr_optdep(t427-1,t425+3,k-1)- 
     .       2            xyr_optdep(t427-1,t425+3,k))))                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   325          & exp( - DiffFact * ( xyr_OptDep(:,:,k-1) - xyr_OptDep(:,:,k) ) )
   326      end do
   327      !
   328      do k = 0, kmax
   329        do kk = k, k
   330          xyrr_Trans(:,:,k,kk) = 1.0_DP
   331        end do
     .        if (xyrr_trans.DSC.U2 .gt. 0) then                                
     .           J3 = and(xyrr_trans.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t435 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t437 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t437-1,t435,k,k) = 1.00000000000000e+000      
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t435 = J3 + 1, xyrr_trans.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t437 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t437-1,t435,k,k) = 1.00000000000000e+000      
     .                 xyrr_trans(t437-1,t435+1,k,k) = 1.00000000000000e+000    
     .                 xyrr_trans(t437-1,t435+2,k,k) = 1.00000000000000e+000    
     .                 xyrr_trans(t437-1,t435+3,k,k) = 1.00000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   332        do kk = k+1, kmax
   333          xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
     .        if (xyrr_trans.DSC.U2 .gt. 0) then                                
     .           J4 = and(xyrr_trans.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t441 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t443 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t443-1,t441,k,kk) = xyrr_trans(t443-1,t441,k, 
     .       1            kk-1)*xyz_deltrans(t443-1,t441,kk)                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t441 = J4 + 1, xyrr_trans.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t443 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t443-1,t441,k,kk) = xyrr_trans(t443-1,t441,k, 
     .       1            kk-1)*xyz_deltrans(t443-1,t441,kk)                    
     .                 xyrr_trans(t443-1,t441+1,k,kk) = xyrr_trans(t443-1,t441+1
     .       1            ,k,kk-1)*xyz_deltrans(t443-1,t441+1,kk)               
     .                 xyrr_trans(t443-1,t441+2,k,kk) = xyrr_trans(t443-1,t441+2
     .       1            ,k,kk-1)*xyz_deltrans(t443-1,t441+2,kk)               
     .                 xyrr_trans(t443-1,t441+3,k,kk) = xyrr_trans(t443-1,t441+3
     .       1            ,k,kk-1)*xyz_deltrans(t443-1,t441+3,kk)               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   334        end do
   335      end do
   336      do k = 0, kmax
   337        do kk = 0, k-1
   338          xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
     .        if (xyrr_trans.DSC.U2 .gt. 0) then                                
     .           J5 = and(xyrr_trans.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t451 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t453 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t453-1,t451,k,kk) = xyrr_trans(t453-1,t451,kk,
     .       1            k)                                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t451 = J5 + 1, xyrr_trans.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t453 = 1, xyrr_trans.DSC.U1 + 1                          
     .                 xyrr_trans(t453-1,t451,k,kk) = xyrr_trans(t453-1,t451,kk,
     .       1            k)                                                    
     .                 xyrr_trans(t453-1,t451+1,k,kk) = xyrr_trans(t453-1,t451+1
     .       1            ,kk,k)                                                
     .                 xyrr_trans(t453-1,t451+2,k,kk) = xyrr_trans(t453-1,t451+2
     .       1            ,kk,k)                                                
     .                 xyrr_trans(t453-1,t451+3,k,kk) = xyrr_trans(t453-1,t451+3
     .       1            ,kk,k)                                                
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   339        end do
   340      end do
   341  
   342  
   343      ! ͥեå׻
   344      ! Calculate radiation flux
   345      !
   346  
   347      !   Initialization
   348      !
   349      xyr_RadLDoFlux = 0.0_DP
     .        if (xyr_radldoflux.DSC.U2 .gt. 0) then                            
     .           J6 = and(xyr_radldoflux.DSC.U2,1)                              
     .  !CDIR    NODEP                                                          
     .           do t461 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t463 = 1, xyr_radldoflux.DSC.U1 + 1                      
     .                 xyr_radldoflux(t463-1,t461,t459) =                       
     .       1            0.0000000000000000e+000                               
     .                 xyr_radlupflux(t463-1,t461,t459) =                       
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t461 = J6 + 1, xyr_radldoflux.DSC.U2, 2                     
     .  !CDIR       NODEP                                                       
     .              do t463 = 1, xyr_radldoflux.DSC.U1 + 1                      
     .                 xyr_radldoflux(t463-1,t461,t459) =                       
     .       1            0.0000000000000000e+000                               
     .                 xyr_radldoflux(t463-1,t461+1,t459) =                     
     .       1            0.0000000000000000e+000                               
     .                 xyr_radlupflux(t463-1,t461,t459) =                       
     .       1            0.0000000000000000e+000                               
     .                 xyr_radlupflux(t463-1,t461+1,t459) =                     
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   350      xyr_RadLUpFlux = 0.0_DP
   351      !
   352      !   Downward flux
   353      !
   354      do k = kmax, 0, -1
   355  
   356        do kk = kmax, k+1, -1
   357          xyr_RadLDoFlux(:,:,k) = xyr_RadLDoFlux(:,:,k)          &
     .        if (xyr_radldoflux.DSC.U2 .gt. 0) then                            
     .           J7 = and(xyr_radldoflux.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t471 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t473 = 1, xyr_radldoflux.DSC.U1 + 1                      
     .                 xyr_radldoflux(t473-1,t471,k) = xyr_radldoflux(t473-1,   
     .       1            t471,k) + xyz_intpf(t473-1,t471,kk)*(xyrr_trans(t473-1
     .       2            ,t471,k,kk-1)-xyrr_trans(t473-1,t471,k,kk))           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t471 = J7 + 1, xyr_radldoflux.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t473 = 1, xyr_radldoflux.DSC.U1 + 1                      
     .                 xyr_radldoflux(t473-1,t471,k) = xyr_radldoflux(t473-1,   
     .       1            t471,k) + xyz_intpf(t473-1,t471,kk)*(xyrr_trans(t473-1
     .       2            ,t471,k,kk-1)-xyrr_trans(t473-1,t471,k,kk))           
     .                 xyr_radldoflux(t473-1,t471+1,k) = xyr_radldoflux(t473-1, 
     .       1            t471+1,k) + xyz_intpf(t473-1,t471+1,kk)*(xyrr_trans(  
     .       2            t473-1,t471+1,k,kk-1)-xyrr_trans(t473-1,t471+1,k,kk)) 
     .                 xyr_radldoflux(t473-1,t471+2,k) = xyr_radldoflux(t473-1, 
     .       1            t471+2,k) + xyz_intpf(t473-1,t471+2,kk)*(xyrr_trans(  
     .       2            t473-1,t471+2,k,kk-1)-xyrr_trans(t473-1,t471+2,k,kk)) 
     .                 xyr_radldoflux(t473-1,t471+3,k) = xyr_radldoflux(t473-1, 
     .       1            t471+3,k) + xyz_intpf(t473-1,t471+3,kk)*(xyrr_trans(  
     .       2            t473-1,t471+3,k,kk-1)-xyrr_trans(t473-1,t471+3,k,kk)) 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   358            & + xyz_IntPF(:,:,kk)                                &
   359            & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   360        end do
   361  
   362      end do
   363      !
   364      !   Upward flux
   365      !
   366      !     Set upward flux
   367      !
   368      xy_SurfUpRadLFlux = xyr_RadLDoFlux(:,:,0) - xy_SurfUpRadLFluxBase
     .        if (xyr_radldoflux.DSC.U2 .gt. 0) then                            
     .           J8 = and(xyr_radldoflux.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t485 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t487 = 1, xyr_radldoflux.DSC.U1 + 1                      
     .                 xy_surfupradlflux(t487-1,t485) = xyr_radldoflux(t487-1,  
     .       1            t485,0) - xy_surfupradlfluxbase(t487-1,t485)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t485 = J8 + 1, xyr_radldoflux.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t487 = 1, xyr_radldoflux.DSC.U1 + 1                      
     .                 xy_surfupradlflux(t487-1,t485) = xyr_radldoflux(t487-1,  
     .       1            t485,0) - xy_surfupradlfluxbase(t487-1,t485)          
     .                 xy_surfupradlflux(t487-1,t485+1) = xyr_radldoflux(t487-1,
     .       1            t485+1,0) - xy_surfupradlfluxbase(t487-1,t485+1)      
     .                 xy_surfupradlflux(t487-1,t485+2) = xyr_radldoflux(t487-1,
     .       1            t485+2,0) - xy_surfupradlfluxbase(t487-1,t485+2)      
     .                 xy_surfupradlflux(t487-1,t485+3) = xyr_radldoflux(t487-1,
     .       1            t485+3,0) - xy_surfupradlfluxbase(t487-1,t485+3)      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   369      !
   370      do k = 0, kmax
   371  
   372        xyr_RadLUpFlux(:,:,k) = xy_SurfUpRadLFlux * xyrr_Trans(:,:,k,0)
     .        if (xy_surfupradlflux.DSC.U2 .gt. 0) then                         
     .           J9 = and(xy_surfupradlflux.DSC.U2,3)                           
     .  !CDIR    NODEP                                                          
     .           do t495 = 1, J9                                                
     .  !CDIR       NODEP                                                       
     .              do t497 = 1, xy_surfupradlflux.DSC.U1 + 1                   
     .                 xyr_radlupflux(t497-1,t495,k) = xy_surfupradlflux(t497-1,
     .       1            t495)*xyrr_trans(t497-1,t495,k,0)                     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t495 = J9 + 1, xy_surfupradlflux.DSC.U2, 4                  
     .  !CDIR       NODEP                                                       
     .              do t497 = 1, xy_surfupradlflux.DSC.U1 + 1                   
     .                 xyr_radlupflux(t497-1,t495,k) = xy_surfupradlflux(t497-1,
     .       1            t495)*xyrr_trans(t497-1,t495,k,0)                     
     .                 xyr_radlupflux(t497-1,t495+1,k) = xy_surfupradlflux(t497-
     .       1            1,t495+1)*xyrr_trans(t497-1,t495+1,k,0)               
     .                 xyr_radlupflux(t497-1,t495+2,k) = xy_surfupradlflux(t497-
     .       1            1,t495+2)*xyrr_trans(t497-1,t495+2,k,0)               
     .                 xyr_radlupflux(t497-1,t495+3,k) = xy_surfupradlflux(t497-
     .       1            1,t495+3)*xyrr_trans(t497-1,t495+3,k,0)               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   373  
   374        do kk = 1, k
   375          xyr_RadLUpFlux(:,:,k) = xyr_RadLUpFlux(:,:,k)          &
     .        if (xyr_radlupflux.DSC.U2 .gt. 0) then                            
     .           J10 = and(xyr_radlupflux.DSC.U2,3)                             
     .  !CDIR    NODEP                                                          
     .           do t505 = 1, J10                                               
     .  !CDIR       NODEP                                                       
     .              do t507 = 1, xyr_radlupflux.DSC.U1 + 1                      
     .                 xyr_radlupflux(t507-1,t505,k) = xyr_radlupflux(t507-1,   
     .       1            t505,k) - xyz_intpf(t507-1,t505,kk)*(xyrr_trans(t507-1
     .       2            ,t505,k,kk-1)-xyrr_trans(t507-1,t505,k,kk))           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t505 = J10 + 1, xyr_radlupflux.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t507 = 1, xyr_radlupflux.DSC.U1 + 1                      
     .                 xyr_radlupflux(t507-1,t505,k) = xyr_radlupflux(t507-1,   
     .       1            t505,k) - xyz_intpf(t507-1,t505,kk)*(xyrr_trans(t507-1
     .       2            ,t505,k,kk-1)-xyrr_trans(t507-1,t505,k,kk))           
     .                 xyr_radlupflux(t507-1,t505+1,k) = xyr_radlupflux(t507-1, 
     .       1            t505+1,k) - xyz_intpf(t507-1,t505+1,kk)*(xyrr_trans(  
     .       2            t507-1,t505+1,k,kk-1)-xyrr_trans(t507-1,t505+1,k,kk)) 
     .                 xyr_radlupflux(t507-1,t505+2,k) = xyr_radlupflux(t507-1, 
     .       1            t505+2,k) - xyz_intpf(t507-1,t505+2,kk)*(xyrr_trans(  
     .       2            t507-1,t505+2,k,kk-1)-xyrr_trans(t507-1,t505+2,k,kk)) 
     .                 xyr_radlupflux(t507-1,t505+3,k) = xyr_radlupflux(t507-1, 
     .       1            t505+3,k) - xyz_intpf(t507-1,t505+3,kk)*(xyrr_trans(  
     .       2            t507-1,t505+3,k,kk-1)-xyrr_trans(t507-1,t505+3,k,kk)) 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   376            & - xyz_IntPF(:,:,kk)                                &
   377            & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   378        end do
   379  
   380      end do
   381  
   382      xyr_RadLFlux = xyr_RadLUpFlux - xyr_RadLDoFlux
     .        if (xyr_radlupflux.DSC.U2 .gt. 0) then                            
     .           J11 = and(xyr_radlupflux.DSC.U2,3)                             
     .  !CDIR    NODEP                                                          
     .           do t521 = 1, J11                                               
     .  !CDIR       NODEP                                                       
     .              do t523 = 1, xyr_radlupflux.DSC.U1 + 1                      
     .                 xyr_radlflux(t523-1,t521,t519) = xyr_radlupflux(t523-1,  
     .       1            t521,t519) - xyr_radldoflux(t523-1,t521,t519)         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t521 = J11 + 1, xyr_radlupflux.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t523 = 1, xyr_radlupflux.DSC.U1 + 1                      
     .                 xyr_radlflux(t523-1,t521,t519) = xyr_radlupflux(t523-1,  
     .       1            t521,t519) - xyr_radldoflux(t523-1,t521,t519)         
     .                 xyr_radlflux(t523-1,t521+1,t519) = xyr_radlupflux(t523-1,
     .       1            t521+1,t519) - xyr_radldoflux(t523-1,t521+1,t519)     
     .                 xyr_radlflux(t523-1,t521+2,t519) = xyr_radlupflux(t523-1,
     .       1            t521+2,t519) - xyr_radldoflux(t523-1,t521+2,t519)     
     .                 xyr_radlflux(t523-1,t521+3,t519) = xyr_radlupflux(t523-1,
     .       1            t521+3,t519) - xyr_radldoflux(t523-1,t521+3,t519)     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   383  
   384  
   385      ! ͥեåѲΨη׻
   386      ! Calculate rate of change of radiative flux
   387      !
   388      do k = 0, kmax
   389        xyra_DelRadLFlux(:,:,k,0) = 0.0_DP
     .        if (jmax .gt. 0) then                                             
     .           J12 = and(jmax,1)                                              
     .  !CDIR    NODEP                                                          
     .           do t534 = 1, J12                                               
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, imax                                           
     .                 xyra_delradlflux(t536-1,t534,k,0) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyra_delradlflux(t536-1,t534,k,1) = -xyz_intdpfdt(t536-1,
     .       1            t534,1)*(xyrr_trans(t536-1,t534,k,0)-xyrr_trans(t536-1
     .       2            ,t534,k,1))                                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t534 = J12 + 1, jmax, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, imax                                           
     .                 xyra_delradlflux(t536-1,t534,k,0) =                      
     .       1            0.0000000000000000e+000                               
     .                 xyra_delradlflux(t536-1,t534+1,k,0) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyra_delradlflux(t536-1,t534,k,1) = -xyz_intdpfdt(t536-1,
     .       1            t534,1)*(xyrr_trans(t536-1,t534,k,0)-xyrr_trans(t536-1
     .       2            ,t534,k,1))                                           
     .                 xyra_delradlflux(t536-1,t534+1,k,1) = -xyz_intdpfdt(t536-
     .       1            1,t534+1,1)*(xyrr_trans(t536-1,t534+1,k,0)-xyrr_trans(
     .       2            t536-1,t534+1,k,1))                                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   390  
   391        xyra_DelRadLFlux(:,:,k,1) =                           &
   392          & - xyz_IntDPFDT(:,:,1)                             &
   393          &   * ( xyrr_Trans(:,:,k,0) - xyrr_Trans(:,:,k,1) )
   394      end do
   395  
   396    end subroutine RadSL09LWFlux
   397  
   398    !--------------------------------------------------------------------------------------
   399  
   400    subroutine RadSL09SWFlux(                                     &
   401      & SolarFluxTOA, xy_CosSZA, SSA, AF, xyr_OptDep,             &
   402      & xyr_RadSFlux                                              &
   403      & )
   404  
   405      real(DP), intent(in ) :: SolarFluxTOA
   406      real(DP), intent(in ) :: xy_CosSZA(0:imax-1, 1:jmax)
   407      real(DP), intent(in ) :: SSA
   408      real(DP), intent(in ) :: AF
   409      real(DP), intent(in ) :: xyr_OptDep   ( 0:imax-1, 1:jmax, 0:kmax )
   410      real(DP), intent(out) :: xyr_RadSFlux ( 0:imax-1, 1:jmax, 0:kmax )
   411  
   412      ! Work variables
   413      !
   414      real(DP) :: BondAlbedo
   415      real(DP) :: Gamma
   416      integer  :: j, k
   417  
   418  
   419      BondAlbedo = &
   420        &   ( sqrt( 1.0_DP - SSA * AF ) - sqrt( 1.0_DP - SSA ) ) &
   421        & / ( sqrt( 1.0_DP - SSA * AF ) + sqrt( 1.0_DP - SSA ) )
   422  
   423      Gamma = 2.0_DP * sqrt( 1.0_DP - SSA ) * sqrt( 1.0_DP - SSA * AF )
   424  
   425      do k = 0, kmax
   426        do j = 1, jmax
   427          xyr_RadSFlux(:,j,k) =                   &
   428            & - SolarFluxTOA * xy_CosSZA(:,j) &
   429            & * ( 1.0_DP - BondAlbedo ) * exp( -Gamma * xyr_OptDep(:,j,k) )
   430        end do
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do j = 1, jmax*imax                                               
     .           xyr_radsflux(j-1,1,k) = -solarfluxtoa*xy_cossza(j-1,1)*(       
     .       1      1.00000000000000e+000 - bondalbedo)*dexp((-gamma*xyr_optdep(
     .       2      j-1,1,k)))                                                  
     .        end do                                                            
   431      end do
   432  
   433  
   434    end subroutine RadSL09SWFlux
   435  
   436    !--------------------------------------------------------------------------------------
   437  
   438    subroutine RadSL09Init
   439  
   440      ! ե
   441      ! File I/O support
   442      !
   443      use dc_iounit, only: FileOpen
   444  
   445      ! NAMELIST եϤ˴ؤ桼ƥƥ
   446      ! Utilities for NAMELIST file input
   447      !
   448      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   449  
   450      ! å
   451      ! Message output
   452      !
   453      use dc_message, only: MessageNotify
   454  
   455      !
   456      ! Solve radiative transfer equation in two stream approximation
   457      !
   458      use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   459  
   460  
   461      ! ʸ ; Declaration statements
   462      !
   463  
   464      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   465                                ! Unit number for NAMELIST file open
   466      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   467                                ! IOSTAT of NAMELIST read
   468  
   469      ! NAMELIST ѿ
   470      ! NAMELIST group name
   471      !
   472      namelist /rad_SL09_nml/ &
   473        & SWOptDepAtRefPress, SWRefPress, SWOrd, &
   474        & LWOptDepAtRefPress, LWRefPress, LWOrd, &
   475        & SolarConst
   476            !
   477            ! ǥեͤˤĤƤϽ³ "rad_SL09#RadSL09Init"
   478            ! Υɤ򻲾ȤΤ.
   479            !
   480            ! Refer to source codes in the initialization procedure
   481            ! "rad_SL09#RadSL09Init" for the default values.
   482            !
   483  
   484  
   485      if ( rad_SL09_inited ) return
   486  
   487  
   488      ! ǥեͤ
   489      ! Default values settings
   490      !
   491      SWOptDepAtRefPress =  3.0_DP
   492      SWRefPress         =  3.0d5
   493      SWOrd              =  1.0_DP
   494  
   495      LWOptDepAtRefPress = 80.0_DP
   496      LWRefPress         =  3.0d5
   497      LWOrd              =  2.0_DP
   498  
   499      SolarConst         = 50.7_DP
   500  
   501  
   502  
   503  
   504      ! NAMELIST ɤ߹
   505      ! NAMELIST is input
   506      !
   507      if ( trim(namelist_filename) /= '' ) then
   508        call FileOpen( unit_nml, &          ! (out)
   509          & namelist_filename, mode = 'r' ) ! (in)
   510  
   511        rewind( unit_nml )
   512        read( unit_nml,                     & ! (in)
   513          & nml = rad_SL09_nml,             & ! (out)
   514          & iostat = iostat_nml )             ! (out)
   515        close( unit_nml )
   516  
   517        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   518      end if
   519  
   520  
   521      ! Initialization of modules used in this module
   522      !
   523  
   524      !
   525      ! Solve radiative transfer equation in two stream approximation
   526      !
   527      call RadRTETwoStreamAppInit
   528  
   529  
   530      !  ; Print
   531      !
   532      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   533      call MessageNotify( 'M', module_name, 'SWOptDepAtRefPress = %f', d = (/ SWOptDepAtRefPress /) )
   534      call MessageNotify( 'M', module_name, 'SWRefPress         = %f', d = (/ SWRefPress /) )
   535      call MessageNotify( 'M', module_name, 'SWOrd              = %f', d = (/ SWOrd /) )
   536      call MessageNotify( 'M', module_name, 'LWOptDepAtRefPress = %f', d = (/ LWOptDepAtRefPress /) )
   537      call MessageNotify( 'M', module_name, 'LWRefPress         = %f', d = (/ LWRefPress /) )
   538      call MessageNotify( 'M', module_name, 'LWOrd              = %f', d = (/ LWOrd /) )
   539      call MessageNotify( 'M', module_name, 'SolarConst         = %f', d = (/ SolarConst /) )
   540      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   541  
   542  
   543      rad_SL09_inited = .true.
   544  
   545    end subroutine RadSL09Init
   546  
   547    !--------------------------------------------------------------------------------------
   548  
   549  end module rad_SL09
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:51:02 2012
FILE NAME: rad_SL09.f90
PROGRAM NAME: rad_sl09
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != Schneider and Liu (2009) ͥǥ
     2:            !
     3:            != Radiation model by Schneider and Liu (2009)
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: rad_SL09.f90,v 1.5 2012-09-17 10:59:31 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            module rad_SL09
    12:              !
    13:              != Schneider and Liu (2009) ͥǥ
    14:              !
    15:              != Radiation model by Schneider and Liu (2009)
    16:              !
    17:              ! <b>Note that Japanese and English are described in parallel.</b>
    18:              !
    19:              ! 
    20:              !
    21:              ! This is a radiation model described by Schneider and Liu (2009). 
    22:              !
    23:              !== References
    24:              !
    25:              !  Schneider, T. and J. Liu, 
    26:              !    Formation of jets and equatorial superrotation on Jupiter, 
    27:              !    J. Atmos. Sci., 69, 579, 2009.
    28:              !
    29:              !== Procedures List
    30:              !
    31:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    32:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    33:            !!$  ! RadiationFluxOutput     :: ͥեåν
    34:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    35:            !!$  ! ------------            :: ------------
    36:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    37:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    38:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    39:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    40:              !
    41:              !== NAMELIST
    42:              !
    43:              ! NAMELIST#rad_SL09_nml
    44:              !
    45:            
    46:              ! USE statements
    47:              !
    48:            
    49:              !
    50:              ! Kind type parameter
    51:              !
    52:              use dc_types, only: DP, &      ! Double precision.
    53:                &                 STRING, &  ! Strings.
    54:                &                 TOKEN      ! Keywords.
    55:            
    56:              ! ʻ
    57:              ! Grid points settings
    58:              !
    59:              use gridset, only: imax, & ! ٳʻ.
    60:                                         ! Number of grid points in longitude
    61:                &                jmax, & ! ٳʻ.
    62:                                         ! Number of grid points in latitude
    63:                &                kmax    ! ľؿ.
    64:                                         ! Number of vertical level
    65:            
    66:              implicit none
    67:            
    68:              private
    69:            
    70:            
    71:              ! Private variables
    72:              !
    73:              real(DP), save :: SWOptDepAtRefPress
    74:              real(DP), save :: SWRefPress
    75:              real(DP), save :: SWOrd
    76:              real(DP), save :: LWOptDepAtRefPress
    77:              real(DP), save :: LWRefPress
    78:              real(DP), save :: LWOrd
    79:              real(DP), save :: SolarConst
    80:            
    81:            
    82:              ! ѿ
    83:              ! Public variables
    84:              !
    85:              logical, save, public:: rad_SL09_inited = .false.
    86:                                          ! ե饰.
    87:                                          ! Initialization flag
    88:            
    89:              public :: RadSL09Init
    90:              public :: RadSL09Flux
    91:            
    92:              character(*), parameter:: module_name = 'rad_SL09'
    93:                                          ! ⥸塼̾.
    94:                                          ! Module name
    95:              character(*), parameter:: version = &
    96:                & '$Name: dcpam5-20120921 $' // &
    97:                & '$Id: rad_SL09.f90,v 1.5 2012-09-17 10:59:31 yot Exp $'
    98:                                          ! ⥸塼ΥС
    99:                                          ! Module version
   100:            
   101:              !--------------------------------------------------------------------------------------
   102:            
   103:            contains
   104:            
   105:              !--------------------------------------------------------------------------------------
   106:            
   107:              subroutine RadSL09Flux(                           &
   108:                & xyr_Press, xyz_Temp,                          &
   109:                & xyr_RadSFlux, xyr_RadLFlux, xyra_DelRadLFlux  &
   110:                & )
   111:            
   112:            
   113:                ! USE statements
   114:                !
   115:            
   116:                ! å
   117:                ! Message output
   118:                !
   119:                use dc_message, only: MessageNotify
   120:            
   121:                ! ʪ
   122:                ! Physical and mathematical constants settings
   123:                !
   124:                use constants0, only: &
   125:                  & PI                    ! $ \pi $ .
   126:                                          ! ߼Ψ.  Circular constant
   127:            
   128:                ! ɸǡ
   129:                ! Axes data settings
   130:                !
   131:                use axesset, only : y_Lat
   132:            
   133:                !
   134:                ! Solve radiative transfer equation in two stream approximation
   135:                !
   136:                use rad_rte_two_stream_app, only: OLD_RadRTETwoStreamAppHomogAtm
   137:            
   138:                real(DP), intent(in ) :: xyr_Press    ( 0:imax-1, 1:jmax, 0:kmax )
   139:                real(DP), intent(in ) :: xyz_Temp     ( 0:imax-1, 1:jmax, 1:kmax )
   140:                real(DP), intent(out) :: xyr_RadSFlux ( 0:imax-1, 1:jmax, 0:kmax )
   141:                real(DP), intent(out) :: xyr_RadLFlux    (0:imax-1, 1:jmax, 0:kmax)
   142:                real(DP), intent(out) :: xyra_DelRadLFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   143:            
   144:            
   145:                ! Work variables
   146:                !
   147:                real(DP) :: SolarFluxTOA
   148:            !!$    real(DP) :: QeRatio
   149:            !!$    real(DP) :: xyz_SSA      (0:imax-1, 1:jmax, 1:kmax)
   150:            !!$    real(DP) :: xyz_AF       (0:imax-1, 1:jmax, 1:kmax)
   151:                real(DP) :: xy_SurfAlbedo(0:imax-1, 1:jmax)
   152:                real(DP) :: xy_InAngle   (0:imax-1, 1:jmax)
   153:                real(DP) :: xy_CosSZA    (0:imax-1, 1:jmax)
   154:                real(DP) :: xyr_OptDep   (0:imax-1, 1:jmax, 0:kmax)
   155:            
   156:                real(DP) :: SSA
   157:                real(DP) :: AF
   158:            
   159:                integer  :: i
   160:                integer  :: j
   161:                integer  :: k
   162:            
   163:            
   164:                ! 
   165:                ! Initialization
   166:                !
   167:                if ( .not. rad_SL09_inited ) then
   168:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   169:                end if
   170:            
   171:            
   172:                ! Short wave radiation
   173:                !
   174: ++V====        xyr_OptDep = SWOptDepAtRefPress * ( xyr_Press / SWRefPress )**SWOrd
   175:            
   176:                SolarFluxTOA  = SolarConst / PI
   177:            
   178:            
   179:                SSA = 0.8_DP
   180:                AF  = 0.204_DP
   181:                !   Af = 0 may be much better than 0.204 when Eddington approximation is used.
   182:            !!$    AF         = 0.0_DP
   183:            
   184:            
   185: +------>       do j = 1, jmax
   186: |V=====          xy_CosSZA(:,j) = cos( y_Lat(j) )
   187: +------        end do
   188: +------>       do j = 1, jmax
   189: |V----->         do i = 0, imax-1
   190: ||                 if ( xy_CosSZA(i,j) > 0.0_DP ) then
   191: ||                   xy_InAngle(i,j) = 1.0_DP / xy_CosSZA(i,j)
   192: ||                 else
   193: ||                   xy_InAngle(i,j) = 0.0_DP
   194: ||                 end if
   195: |V-----          end do
   196: +------        end do
   197:            
   198:                !   Unused variable but this is required as an argument
   199:                !
   200: +V=====        xy_SurfAlbedo = 1.0d100
   201:            
   202:                call OLD_RadRTETwoStreamAppHomogAtm(                                   &
   203:                  & xy_SurfAlbedo, SolarFluxTOA, xy_InAngle, SSA, AF, xyr_OptDep,  & ! (in )
   204:                  & xyr_RadSFlux,                                                  & ! (out)
   205:                  & FlagSemiInfAtm = .true., FlagSL09 = .true.                     & ! (in ) optional
   206:                  & )
   207:            
   208:            
   209:            
   210:                ! Long wave radiation
   211:                !
   212:            
   213:                !   Although the surface temperature and surface emissivity are set, but are not used.
   214:                !
   215: ++V====        xyr_OptDep = LWOptDepAtRefPress * ( xyr_Press / LWRefPress )**LWOrd
   216:            
   217:            
   218:            !!$    call RadiationRTEQNonScat(                    &
   219:            !!$      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyr_OptDep, & ! (in )
   220:            !!$      & xyr_RadLFlux, xyra_DelRadLFlux,                 & ! (out)
   221:            !!$      & xy_SurfUpRadLFluxBase = xyr_RadSFlux(:,:,0)     & ! (in ) optional
   222:            !!$      & )
   223:                call RadSL09LWFlux(                           &
   224:                  & xyz_Temp, xyr_OptDep,                     & ! (in )
   225:                  & xyr_RadSFlux(:,:,0),                      & ! (in )
   226:                  & xyr_RadLFlux, xyra_DelRadLFlux            & ! (out)
   227:                  & )
   228:            
   229:            
   230:              end subroutine RadSL09Flux
   231:            
   232:              !--------------------------------------------------------------------------------------
   233:            
   234:              subroutine RadSL09LWFlux(                           &
   235:                & xyz_Temp, xyr_OptDep,                           & ! (in )
   236:                & xy_SurfUpRadLFluxBase,                          & ! (in )
   237:                & xyr_RadLFlux, xyra_DelRadLFlux                  & ! (out)
   238:                & )
   239:                !
   240:                ! ʤξãη׻
   241:                !
   242:                ! Integrate radiative transfer equation without scattering
   243:                !
   244:            
   245:                ! ⥸塼 ; USE statements
   246:                !
   247:            
   248:                ! å
   249:                ! Message output
   250:                !
   251:                use dc_message, only: MessageNotify
   252:            
   253:                ! ʪ
   254:                ! Physical and mathematical constants settings
   255:                !
   256:                use constants0, only: &
   257:                  & PI, &
   258:                                          ! $ \pi $ .
   259:                                          ! ߼Ψ.  Circular constant
   260:                  & StB
   261:                                          ! $ \sigma_{SB} $ .
   262:                                          ! ƥեܥĥޥ.
   263:                                          ! Stefan-Boltzmann constant
   264:            
   265:                ! ʸ ; Declaration statements
   266:                !
   267:            
   268:                real(DP), intent(in ) :: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   269:                                          ! $ T $ .     . Temperature
   270:                real(DP), intent(in ) :: xyr_OptDep  (0:imax-1, 1:jmax, 0:kmax)
   271:                                          ! Optical depth
   272:                real(DP), intent(in ) :: xy_SurfUpRadLFluxBase(0:imax-1, 1:jmax)
   273:                real(DP), intent(out) :: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   274:                                          ! Ĺȥեå. 
   275:                                          ! Longwave flux
   276:                real(DP), intent(out) :: xyra_DelRadLFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   277:                                          ! ĹɽѲ. 
   278:                                          ! Surface temperature tendency with longwave
   279:            
   280:            
   281:                ! ѿ
   282:                ! Work variables
   283:                !
   284:                real(DP), parameter :: DiffFact = 1.66_DP
   285:            
   286:                real(DP):: xyr_RadLDoFlux (0:imax-1, 1:jmax, 0:kmax)
   287:                real(DP):: xyr_RadLUpFlux (0:imax-1, 1:jmax, 0:kmax)
   288:            
   289:                real(DP):: xyz_DelTrans (0:imax-1, 1:jmax, 1:kmax)
   290:                real(DP):: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   291:                                          ! Ʃ᷸. 
   292:                                          ! Transmission coefficient
   293:                real(DP):: xyz_IntPF        (0:imax-1, 1:jmax, 1:kmax)
   294:                                          ! Integrated Planck function
   295:                real(DP):: xyz_IntDPFDT     (0:imax-1, 1:jmax, 1:kmax)
   296:                                          ! Integrated temperature derivative of Planck function
   297:            
   298:                real(DP):: xy_SurfUpRadLFlux(0:imax-1, 1:jmax)
   299:            
   300:                integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   301:                                          ! Work variables for DO loop in vertical direction
   302:            
   303:                ! ¹ʸ ; Executable statement
   304:                !
   305:            
   306:                ! 
   307:                ! Initialization
   308:                !
   309:                if ( .not. rad_SL09_inited ) then
   310:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   311:                end if
   312:            
   313:            
   314:                ! Case for grey atmosphere
   315:                !
   316: **V---->       xyz_IntPF       = StB * xyz_Temp**4
   317: **V----        xyz_IntDPFDT    = 4.0_DP * StB * xyz_Temp**3
   318:            
   319:            
   320:                ! Ʃؿ׻
   321:                ! Calculate transmission functions
   322:                !
   323: +------>       do k = 1, kmax
   324: |+V====          xyz_DelTrans(:,:,k) = &
   325: |                  & exp( - DiffFact * ( xyr_OptDep(:,:,k-1) - xyr_OptDep(:,:,k) ) )
   326: +------        end do
   327:                !
   328: +------>       do k = 0, kmax
   329: |+----->         do kk = k, k
   330: ||+V===            xyrr_Trans(:,:,k,kk) = 1.0_DP
   331: |+-----          end do
   332: |+----->         do kk = k+1, kmax
   333: ||+V===            xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   334: |+-----          end do
   335: +------        end do
   336: +------>       do k = 0, kmax
   337: |+----->         do kk = 0, k-1
   338: ||+V===            xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   339: |+-----          end do
   340: +------        end do
   341:            
   342:            
   343:                ! ͥեå׻
   344:                ! Calculate radiation flux
   345:                !
   346:            
   347:                !   Initialization
   348:                !
   349: **V---->       xyr_RadLDoFlux = 0.0_DP
   350: **V----        xyr_RadLUpFlux = 0.0_DP
   351:                !
   352:                !   Downward flux
   353:                !
   354: +------>       do k = kmax, 0, -1
   355: |          
   356: |+----->         do kk = kmax, k+1, -1
   357: ||+V===            xyr_RadLDoFlux(:,:,k) = xyr_RadLDoFlux(:,:,k)          &
   358: ||                   & + xyz_IntPF(:,:,kk)                                &
   359: ||                   & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   360: |+-----          end do
   361: |          
   362: +------        end do
   363:                !
   364:                !   Upward flux
   365:                !
   366:                !     Set upward flux
   367:                !
   368: +V=====        xy_SurfUpRadLFlux = xyr_RadLDoFlux(:,:,0) - xy_SurfUpRadLFluxBase
   369:                !
   370: +------>       do k = 0, kmax
   371: |          
   372: |+V====          xyr_RadLUpFlux(:,:,k) = xy_SurfUpRadLFlux * xyrr_Trans(:,:,k,0)
   373: |          
   374: |+----->         do kk = 1, k
   375: ||+V===            xyr_RadLUpFlux(:,:,k) = xyr_RadLUpFlux(:,:,k)          &
   376: ||                   & - xyz_IntPF(:,:,kk)                                &
   377: ||                   & * ( xyrr_Trans(:,:,k,kk-1) - xyrr_Trans(:,:,k,kk) )
   378: |+-----          end do
   379: |          
   380: +------        end do
   381:            
   382: ++V====        xyr_RadLFlux = xyr_RadLUpFlux - xyr_RadLDoFlux
   383:            
   384:            
   385:                ! ͥեåѲΨη׻
   386:                ! Calculate rate of change of radiative flux
   387:                !
   388: +------>       do k = 0, kmax
   389: |*V---->         xyra_DelRadLFlux(:,:,k,0) = 0.0_DP
   390: |||        
   391: |*V----          xyra_DelRadLFlux(:,:,k,1) =                           &
   392: |                  & - xyz_IntDPFDT(:,:,1)                             &
   393: |                  &   * ( xyrr_Trans(:,:,k,0) - xyrr_Trans(:,:,k,1) )
   394: +------        end do
   395:            
   396:              end subroutine RadSL09LWFlux
   397:            
   398:              !--------------------------------------------------------------------------------------
   399:            
   400:              subroutine RadSL09SWFlux(                                     &
   401:                & SolarFluxTOA, xy_CosSZA, SSA, AF, xyr_OptDep,             &
   402:                & xyr_RadSFlux                                              &
   403:                & )
   404:            
   405:                real(DP), intent(in ) :: SolarFluxTOA
   406:                real(DP), intent(in ) :: xy_CosSZA(0:imax-1, 1:jmax)
   407:                real(DP), intent(in ) :: SSA
   408:                real(DP), intent(in ) :: AF
   409:                real(DP), intent(in ) :: xyr_OptDep   ( 0:imax-1, 1:jmax, 0:kmax )
   410:                real(DP), intent(out) :: xyr_RadSFlux ( 0:imax-1, 1:jmax, 0:kmax )
   411:            
   412:                ! Work variables
   413:                !
   414:                real(DP) :: BondAlbedo
   415:                real(DP) :: Gamma
   416:                integer  :: j, k
   417:            
   418:            
   419:                BondAlbedo = &
   420:                  &   ( sqrt( 1.0_DP - SSA * AF ) - sqrt( 1.0_DP - SSA ) ) &
   421:                  & / ( sqrt( 1.0_DP - SSA * AF ) + sqrt( 1.0_DP - SSA ) )
   422:            
   423:                Gamma = 2.0_DP * sqrt( 1.0_DP - SSA ) * sqrt( 1.0_DP - SSA * AF )
   424:            
   425: +------>       do k = 0, kmax
   426: |W----->         do j = 1, jmax
   427: ||*====            xyr_RadSFlux(:,j,k) =                   &
   428: ||                   & - SolarFluxTOA * xy_CosSZA(:,j) &
   429: ||                   & * ( 1.0_DP - BondAlbedo ) * exp( -Gamma * xyr_OptDep(:,j,k) )
   430: |W-----          end do
   431: +------        end do
   432:            
   433:            
   434:              end subroutine RadSL09SWFlux
   435:            
   436:              !--------------------------------------------------------------------------------------
   437:            
   438:              subroutine RadSL09Init
   439:            
   440:                ! ե
   441:                ! File I/O support
   442:                !
   443:                use dc_iounit, only: FileOpen
   444:            
   445:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   446:                ! Utilities for NAMELIST file input
   447:                !
   448:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   449:            
   450:                ! å
   451:                ! Message output
   452:                !
   453:                use dc_message, only: MessageNotify
   454:            
   455:                !
   456:                ! Solve radiative transfer equation in two stream approximation
   457:                !
   458:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   459:            
   460:            
   461:                ! ʸ ; Declaration statements
   462:                !
   463:            
   464:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   465:                                          ! Unit number for NAMELIST file open
   466:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   467:                                          ! IOSTAT of NAMELIST read
   468:            
   469:                ! NAMELIST ѿ
   470:                ! NAMELIST group name
   471:                !
   472:                namelist /rad_SL09_nml/ &
   473:                  & SWOptDepAtRefPress, SWRefPress, SWOrd, &
   474:                  & LWOptDepAtRefPress, LWRefPress, LWOrd, &
   475:                  & SolarConst
   476:                      !
   477:                      ! ǥեͤˤĤƤϽ³ "rad_SL09#RadSL09Init"
   478:                      ! Υɤ򻲾ȤΤ.
   479:                      !
   480:                      ! Refer to source codes in the initialization procedure
   481:                      ! "rad_SL09#RadSL09Init" for the default values.
   482:                      !
   483:            
   484:            
   485:                if ( rad_SL09_inited ) return
   486:            
   487:            
   488:                ! ǥեͤ
   489:                ! Default values settings
   490:                !
   491:                SWOptDepAtRefPress =  3.0_DP
   492:                SWRefPress         =  3.0d5
   493:                SWOrd              =  1.0_DP
   494:            
   495:                LWOptDepAtRefPress = 80.0_DP
   496:                LWRefPress         =  3.0d5
   497:                LWOrd              =  2.0_DP
   498:            
   499:                SolarConst         = 50.7_DP
   500:            
   501:            
   502:            
   503:            
   504:                ! NAMELIST ɤ߹
   505:                ! NAMELIST is input
   506:                !
   507:                if ( trim(namelist_filename) /= '' ) then
   508:                  call FileOpen( unit_nml, &          ! (out)
   509:                    & namelist_filename, mode = 'r' ) ! (in)
   510:            
   511:                  rewind( unit_nml )
   512:                  read( unit_nml,                     & ! (in)
   513:                    & nml = rad_SL09_nml,             & ! (out)
   514:                    & iostat = iostat_nml )             ! (out)
   515:                  close( unit_nml )
   516:            
   517:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   518:                end if
   519:            
   520:            
   521:                ! Initialization of modules used in this module
   522:                !
   523:            
   524:                !
   525:                ! Solve radiative transfer equation in two stream approximation
   526:                !
   527:                call RadRTETwoStreamAppInit
   528:            
   529:            
   530:                !  ; Print
   531:                !
   532:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   533:                call MessageNotify( 'M', module_name, 'SWOptDepAtRefPress = %f', d = (/ SWOptDepAtRefPress /) )
   534:                call MessageNotify( 'M', module_name, 'SWRefPress         = %f', d = (/ SWRefPress /) )
   535:                call MessageNotify( 'M', module_name, 'SWOrd              = %f', d = (/ SWOrd /) )
   536:                call MessageNotify( 'M', module_name, 'LWOptDepAtRefPress = %f', d = (/ LWOptDepAtRefPress /) )
   537:                call MessageNotify( 'M', module_name, 'LWRefPress         = %f', d = (/ LWRefPress /) )
   538:                call MessageNotify( 'M', module_name, 'LWOrd              = %f', d = (/ LWOrd /) )
   539:                call MessageNotify( 'M', module_name, 'SolarConst         = %f', d = (/ SolarConst /) )
   540:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   541:            
   542:            
   543:                rad_SL09_inited = .true.
   544:            
   545:              end subroutine RadSL09Init
   546:            
   547:              !--------------------------------------------------------------------------------------
   548:            
   549:            end module rad_SL09
