Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:20 2012
FILE NAME: mass_fixer.f90
PROGRAM NAME: mass_fixer
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   241  vec  (   3): Unvectorized loop.
   241  vec  (  13): Overhead of loop division is too large.
   242  opt  (1592): Outer loop unrolled inside inner loop.
   242  vec  (   4): Vectorized array expression.
   242  vec  (   4): Vectorized array expression.
   246  vec  (   3): Unvectorized loop.
   246  vec  (  13): Overhead of loop division is too large.
   247  opt  (1592): Outer loop unrolled inside inner loop.
   247  vec  (   4): Vectorized array expression.
   247  vec  (   4): Vectorized array expression.
   257  opt  (1592): Outer loop unrolled inside inner loop.
   257  vec  (   4): Vectorized array expression.
   257  vec  (   4): Vectorized array expression.
   260  opt  (1592): Outer loop unrolled inside inner loop.
   260  vec  (   4): Vectorized array expression.
   260  vec  (   4): Vectorized array expression.
   262  opt  (1592): Outer loop unrolled inside inner loop.
   262  vec  (   4): Vectorized array expression.
   262  vec  (   4): Vectorized array expression.
   265  opt  (1592): Outer loop unrolled inside inner loop.
   265  vec  (   4): Vectorized array expression.
   265  vec  (   4): Vectorized array expression.
   274  vec  (   1): Vectorized loop.
   274  vec  (   1): Vectorized loop.
   275  opt  (1037): Feedback of array elements.
   280  opt  (1592): Outer loop unrolled inside inner loop.
   286  vec  (   1): Vectorized loop.
   286  vec  (   1): Vectorized loop.
   290  opt  (1592): Outer loop unrolled inside inner loop.
   299  opt  (  11): Fused array assignments. :line 299 - 300
   299  vec  (   4): Vectorized array expression.
   299  vec  (   4): Vectorized array expression.
   300  opt  (1592): Outer loop unrolled inside inner loop.
   301  vec  (   3): Unvectorized loop.
   301  vec  (  13): Overhead of loop division is too large.
   302  opt  (  11): Fused array assignments. :line 302 - 303
   302  vec  (   4): Vectorized array expression.
   302  vec  (   4): Vectorized array expression.
   303  opt  (1592): Outer loop unrolled inside inner loop.
   310  opt  (1017): Subroutine call prevents optimization.
   317  opt  (1592): Outer loop unrolled inside inner loop.
   317  vec  (   4): Vectorized array expression.
   317  vec  (   4): Vectorized array expression.
   319  opt  (1592): Outer loop unrolled inside inner loop.
   319  vec  (   4): Vectorized array expression.
   319  vec  (   4): Vectorized array expression.
   322  opt  (1592): Outer loop unrolled inside inner loop.
   322  vec  (   4): Vectorized array expression.
   322  vec  (   4): Vectorized array expression.
   328  warn (  80): Dummy argument "xyzf_dqmixdt" with INTENT(OUT) attribute may be referenced before it is defined.
   328  opt  (1592): Outer loop unrolled inside inner loop.
   328  vec  (   4): Vectorized array expression.
   328  vec  (   4): Vectorized array expression.
   339  opt  (1593): Loop nest collapsed into one loop.
   339  vec  (   4): Vectorized array expression.
   349  vec  (   3): Unvectorized loop.
   349  vec  (  13): Overhead of loop division is too large.
   351  opt  (1017): Subroutine call prevents optimization.
   351  vec  (  17): Unvectorizable statement.
   353  vec  (  22): Dependency unknown. Unvectorizable dependency is assumed.:i
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:20 2012
FILE NAME: mass_fixer.f90
PROGRAM NAME: mass_fixer
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != ̤
     2  !
     3  != Mass fixer
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6  ! Version::   $Id: mass_fixer.f90,v 1.8 2012-02-20 09:29:57 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  
    12  module mass_fixer
    13    !
    14    != ̤
    15    !
    16    != Mass fixer
    17    !
    18    ! <b>Note that Japanese and English are described in parallel.</b>
    19    !
    20    ! ̤ޤ.
    21    !
    22    ! Fix masses
    23    !
    24    !== Procedures List
    25    !
    26    ! MassFixer   :: ̤
    27    ! ----------  :: ---------------
    28    ! MassFixer   :: Fix masses
    29    !
    30    !--
    31    !== NAMELIST
    32    !
    33    ! NAMELIST#mass_fixer_nml
    34    !++
    35  
    36    ! ⥸塼 ; USE statements
    37    !
    38  
    39    ! ʻ
    40    ! Grid points settings
    41    !
    42    use gridset, only: imax, & ! ٳʻ.
    43                               ! Number of grid points in longitude
    44      &                jmax, & ! ٳʻ.
    45                               ! Number of grid points in latitude
    46      &                kmax    ! ľؿ.
    47                               ! Number of vertical level
    48  
    49    ! ˴ؤ
    50    ! Settings of array for atmospheric composition
    51    !
    52    use composition, only: &
    53      &                    ncmax
    54                                ! ʬο
    55                                ! Number of composition
    56  
    57    ! ̷ѥ᥿
    58    ! Kind type parameter
    59    !
    60    use dc_types, only: DP, &      ! ټ¿. Double precision.
    61      &                 STRING     ! ʸ.       Strings.
    62  
    63    ! å
    64    ! Message output
    65    !
    66    use dc_message, only: MessageNotify
    67  
    68    ! ʸ ; Declaration statements
    69    !
    70    implicit none
    71    private
    72  
    73    ! ³
    74    ! Public procedure
    75    !
    76    public :: MassFixer
    77    public :: MassFixerInit
    78  
    79    ! ѿ
    80    ! Public variables
    81    !
    82  
    83    ! ѿ
    84    ! Private variables
    85    !
    86    logical, save :: mass_fixer_inited = .false.
    87                                ! ե饰.
    88                                ! Initialization flag
    89  
    90    character(*), parameter:: module_name = 'mass_fixer'
    91                                ! ⥸塼̾.
    92                                ! Module name
    93    character(*), parameter:: version = &
    94      & '$Name: dcpam5-20120921 $' // &
    95      & '$Id: mass_fixer.f90,v 1.8 2012-02-20 09:29:57 yot Exp $'
    96                                ! ⥸塼ΥС
    97                                ! Module version
    98  
    99  contains
   100  
   101    !--------------------------------------------------------------------------------------
   102  
   103    subroutine MassFixer(           &
   104      & xyr_Press,                  & ! (in)
   105      & xyzf_QMix,                  & ! (inout)
   106      & xyr_PressRef,               & ! (in) optional
   107      & xyzf_QMixRef,               & ! (in) optional
   108      & xyzf_DQMixDt                & ! (out) optional
   109      & )
   110      !
   111      ! ʬμ̤ޤ.
   112      ! *xyzf_QMixRef* Ϳ줿ˤ, ʬͤ *xyzf_QMixRef* Τ
   113      ! Ʊˤʤ褦ޤ.
   114      ! *xyzf_QMixRef* Ϳʤˤ, ʬͤΤ
   115      ! Ʊˤʤ褦ޤ.
   116      ! *xyzf_DQMixDt* ˤ *xyz_QMix* Ѳ̤֤ޤ.
   117      !
   118      ! Fix masses of constituents
   119      ! If *xyzf_QMixRef* is given, the mass is fixed to match its global integrated
   120      ! value is the same as that of *xyzf_QMixRef*.
   121      ! If *xyzf_QMixRef* is not given, the mass is fixed to match its global integrated
   122      ! value is the same as that of pre-fixed value.
   123      ! Variation of *xyzf_QMix* is returned to *xyz_DQMixDt*.
   124      !
   125  
   126      ! ⥸塼 ; USE statements
   127      !
   128  
   129      ! ʪ
   130      ! Physical constants settings
   131      !
   132      use constants, only: Grav ! $ g $ [m s-2].
   133                                ! ϲ®.
   134                                ! Gravitational acceleration
   135  
   136      ! ʬʿѤ
   137      ! Operation for integral and average
   138      !
   139      use intavr_operate, only: IntLonLat_xy
   140  
   141      ! 
   142      ! Time control
   143      !
   144      use timeset, only: DelTime, &  ! $ \Delta t $
   145        & TimesetClockStart, TimesetClockStop
   146  
   147      ! ˴ؤ
   148      ! Settings of array for atmospheric composition
   149      !
   150      use composition, only: CompositionInqFlagMassFix
   151  
   152  
   153      ! ʸ ; Declaration statements
   154      !
   155      implicit none
   156      real(DP), intent(in   )          :: xyr_Press   (0:imax-1, 1:jmax, 0:kmax)
   157                                ! $ \hat{p} $ .  (Ⱦ٥).
   158                                ! Air pressure (half level)
   159      real(DP), intent(inout)          :: xyzf_QMix   (0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   160                                ! $ q $ .     漾. Specific humidity
   161      real(DP), intent(in   ), optional:: xyr_PressRef(0:imax-1, 1:jmax, 0:kmax)
   162                                ! $ \hat{p} $ .  (Ⱦ٥).
   163                                ! Air pressure (half level)
   164      real(DP), intent(in   ), optional:: xyzf_QMixRef(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   165                                ! $ q \Delta p / g $ . ʬͤ碌ʬμ.
   166                                ! Reference specific mass of constituent in a layer
   167      real(DP), intent(out  ), optional:: xyzf_DQMixDt(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   168                                ! $ \DP{q}{t} $ .  漾Ψ.
   169                                ! Specific humidity correction
   170  
   171      ! ѿ
   172      ! Work variables
   173      !
   174      real(DP):: xyz_QMixBefCor    (0:imax-1, 1:jmax, 1:kmax)
   175                                ! 漾.
   176                                ! Specific humidity before correction.
   177      real(DP):: xyz_DelMass       (0:imax-1, 1:jmax, 1:kmax)
   178                                ! $ \Delta p / g $
   179                                !
   180      real(DP):: xyz_DelMassRef    (0:imax-1, 1:jmax, 1:kmax)
   181                                ! $ \Delta p / g $ of reference
   182                                !
   183      real(DP):: xyz_DelConsMass   (0:imax-1, 1:jmax, 1:kmax)
   184                                ! ʬμ.
   185                                ! Mass of constituents in a layer.
   186      real(DP):: xyz_DelConsMassRef(0:imax-1, 1:jmax, 1:kmax)
   187                                ! ʬͤ碌ʬμ.
   188                                ! Reference mass of constituents.
   189      real(DP):: xy_ConsMass          (0:imax-1, 1:jmax)
   190                                ! ʬΥ.
   191                                ! Mass of constituents in a layer.
   192      real(DP):: xy_ConsMassRef       (0:imax-1, 1:jmax)
   193                                ! ʬͤ碌ʬΥ.
   194                                ! Reference mass of constituents in a layer.
   195      real(DP):: ConsMass
   196                                ! γʬμ
   197                                ! Total mass of constituents
   198      real(DP):: ConsMassRef
   199                                ! ʬͤ碌γʬμ
   200                                ! Reference total mass of constituents.
   201                                !
   202  
   203      integer:: i               ! ˲ DO 롼Ѻѿ
   204                                ! Work variables for DO loop in longitudinal direction
   205      integer:: j               ! ˲ DO 롼Ѻѿ
   206                                ! Work variables for DO loop in latitudinal direction
   207      integer:: k               ! ľ˲ DO 롼Ѻѿ
   208                                ! Work variables for DO loop in vertical direction
   209      integer:: n               ! ˲ DO 롼Ѻѿ
   210                                ! Work variables for DO loop in dimension of constituents
   211  
   212      ! ¹ʸ ; Executable statement
   213      !
   214  
   215      ! ǧ
   216      ! Initialization check
   217      !
   218      if ( .not. mass_fixer_inited ) then
   219        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   220      end if
   221  
   222  
   223      ! ׻ַ¬
   224      ! Start measurement of computation time
   225      !
   226      call TimesetClockStart( module_name )
   227  
   228  
   229      ! Check arguments
   230      !
   231      if ( present( xyr_PressRef ) .or. present( xyzf_QMixRef ) ) then
   232        if ( .not. ( present( xyr_PressRef ) .and. present( xyzf_QMixRef ) ) ) then
   233          call MessageNotify( 'E', module_name, 'If xyr_PressRef or xyzf_QMixRef is given, both have to be given.' )
   234        end if
   235      end if
   236  
   237  
   238      ! $ \Delta p / g $ η׻
   239      ! Calculate $ \Delta p / g $
   240      !
   241      do k = 1, kmax
   242        xyz_DelMass(:,:,k) = ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
     .        if (jmax .gt. 0) then                                             
     .           J1 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t498 = 1, J1                                                
     .              D1 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t500 = 1, imax                                           
     .                 xyz_delmass(t500-1,t498,k) = (xyr_press(t500-1,t498,k-1)-
     .       1            xyr_press(t500-1,t498,k))*D1                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t498 = J1 + 1, jmax, 4                                      
     .              D2 = 1.D0/grav                                              
     .              D3 = 1.D0/grav                                              
     .              D4 = 1.D0/grav                                              
     .              D5 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t500 = 1, imax                                           
     .                 xyz_delmass(t500-1,t498,k) = (xyr_press(t500-1,t498,k-1)-
     .       1            xyr_press(t500-1,t498,k))*D2                          
     .                 xyz_delmass(t500-1,t498+1,k) = (xyr_press(t500-1,t498+1,k
     .       1            -1)-xyr_press(t500-1,t498+1,k))*D3                    
     .                 xyz_delmass(t500-1,t498+2,k) = (xyr_press(t500-1,t498+2,k
     .       1            -1)-xyr_press(t500-1,t498+2,k))*D4                    
     .                 xyz_delmass(t500-1,t498+3,k) = (xyr_press(t500-1,t498+3,k
     .       1            -1)-xyr_press(t500-1,t498+3,k))*D5                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   243      end do
   244  
   245      if ( present( xyr_PressRef ) ) then
   246        do k = 1, kmax
   247          xyz_DelMassRef(:,:,k) = ( xyr_PressRef(:,:,k-1) - xyr_PressRef(:,:,k) ) / Grav
     .        if (jmax .gt. 0) then                                             
     .           J2 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t649 = 1, J2                                                
     .              D6 = 1.D0/grav                                              
     .  !CDIR       NODEP                                                       
     .              do t651 = 1, imax                                           
     .                 xyz_delmassref(t651-1,t649,k) = (xyr_pressref(t651-1,t649
     .       1            ,k-1)-xyr_pressref(t651-1,t649,k))*D6                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t649 = J2 + 1, jmax, 4                                      
     .              D7 = 1.D0/grav                                              
     .              D8 = 1.D0/grav                                              
     .              D9 = 1.D0/grav                                              
     .              D10 = 1.D0/grav                                             
     .  !CDIR       NODEP                                                       
     .              do t651 = 1, imax                                           
     .                 xyz_delmassref(t651-1,t649,k) = (xyr_pressref(t651-1,t649
     .       1            ,k-1)-xyr_pressref(t651-1,t649,k))*D7                 
     .                 xyz_delmassref(t651-1,t649+1,k) = (xyr_pressref(t651-1,  
     .       1            t649+1,k-1)-xyr_pressref(t651-1,t649+1,k))*D8         
     .                 xyz_delmassref(t651-1,t649+2,k) = (xyr_pressref(t651-1,  
     .       1            t649+2,k-1)-xyr_pressref(t651-1,t649+2,k))*D9         
     .                 xyz_delmassref(t651-1,t649+3,k) = (xyr_pressref(t651-1,  
     .       1            t649+3,k-1)-xyr_pressref(t651-1,t649+3,k))*D10        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   248        end do
   249      end if
   250  
   251      do n = 1, ncmax
   252  
   253        if ( CompositionInqFlagMassFix( n ) ) then
   254  
   255          ! Calculate mass of constituents
   256          !
   257          xyz_DelConsMass = xyzf_QMix(:,:,:,n) * xyz_DelMass
     .        if (jmax .gt. 0) then                                             
     .           J3 = and(jmax,3)                                               
     .  !CDIR    NODEP                                                          
     .           do t519 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t521 = 1, imax                                           
     .                 xyz_delconsmass(t521-1,t519,t517+1) = xyzf_qmix(t521-1,  
     .       1            t519,t517+1,n)*xyz_delmass(t521-1,t519,t517+1)        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t519 = J3 + 1, jmax, 4                                      
     .  !CDIR       NODEP                                                       
     .              do t521 = 1, imax                                           
     .                 xyz_delconsmass(t521-1,t519,t517+1) = xyzf_qmix(t521-1,  
     .       1            t519,t517+1,n)*xyz_delmass(t521-1,t519,t517+1)        
     .                 xyz_delconsmass(t521-1,t519+1,t517+1) = xyzf_qmix(t521-1,
     .       1            t519+1,t517+1,n)*xyz_delmass(t521-1,t519+1,t517+1)    
     .                 xyz_delconsmass(t521-1,t519+2,t517+1) = xyzf_qmix(t521-1,
     .       1            t519+2,t517+1,n)*xyz_delmass(t521-1,t519+2,t517+1)    
     .                 xyz_delconsmass(t521-1,t519+3,t517+1) = xyzf_qmix(t521-1,
     .       1            t519+3,t517+1,n)*xyz_delmass(t521-1,t519+3,t517+1)    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   258  
   259          if ( present( xyzf_QMixRef ) ) then
   260            xyz_DelConsMassRef = xyzf_QMixRef(:,:,:,n) * xyz_DelMassRef
     .        if (1 + jmax - min0(1,jmax) .gt. 0) then                          
     .           J4 = and(1 + jmax - min0(1,jmax),3)                            
     .  !CDIR    NODEP                                                          
     .           do t636 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t638 = 1, imax + 1 - min0(1,imax)                        
     .                 xyz_delconsmassref(t638-1,t636,t634+1) = xyzf_qmixref(   
     .       1            t638-1,t636,t634+1,n)*xyz_delmassref(t638-1,t636,t634+
     .       2            1)                                                    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t636 = J4 + 1, 1 + jmax - min0(1,jmax), 4                   
     .  !CDIR       NODEP                                                       
     .              do t638 = 1, imax + 1 - min0(1,imax)                        
     .                 xyz_delconsmassref(t638-1,t636,t634+1) = xyzf_qmixref(   
     .       1            t638-1,t636,t634+1,n)*xyz_delmassref(t638-1,t636,t634+
     .       2            1)                                                    
     .                 xyz_delconsmassref(t638-1,t636+1,t634+1) = xyzf_qmixref( 
     .       1            t638-1,t636+1,t634+1,n)*xyz_delmassref(t638-1,t636+1, 
     .       2            t634+1)                                               
     .                 xyz_delconsmassref(t638-1,t636+2,t634+1) = xyzf_qmixref( 
     .       1            t638-1,t636+2,t634+1,n)*xyz_delmassref(t638-1,t636+2, 
     .       2            t634+1)                                               
     .                 xyz_delconsmassref(t638-1,t636+3,t634+1) = xyzf_qmixref( 
     .       1            t638-1,t636+3,t634+1,n)*xyz_delmassref(t638-1,t636+3, 
     .       2            t634+1)                                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   261          else
   262            xyz_DelConsMassRef = xyz_DelConsMass
     .        if (xyz_delconsmassref.DSC.U2 .gt. 0) then                        
     .           J5 = and(xyz_delconsmassref.DSC.U2,3)                          
     .  !CDIR    NODEP                                                          
     .           do t534 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, xyz_delconsmassref.DSC.U1 + 1                  
     .                 xyz_delconsmassref(t536-1,t534,t532+1) = xyz_delconsmass(
     .       1            t536-1,t534,t532+1)                                   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t534 = J5 + 1, xyz_delconsmassref.DSC.U2, 4                 
     .  !CDIR       NODEP                                                       
     .              do t536 = 1, xyz_delconsmassref.DSC.U1 + 1                  
     .                 xyz_delconsmassref(t536-1,t534,t532+1) = xyz_delconsmass(
     .       1            t536-1,t534,t532+1)                                   
     .                 xyz_delconsmassref(t536-1,t534+1,t532+1) =               
     .       1            xyz_delconsmass(t536-1,t534+1,t532+1)                 
     .                 xyz_delconsmassref(t536-1,t534+2,t532+1) =               
     .       1            xyz_delconsmass(t536-1,t534+2,t532+1)                 
     .                 xyz_delconsmassref(t536-1,t534+3,t532+1) =               
     .       1            xyz_delconsmass(t536-1,t534+3,t532+1)                 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   263          end if
   264          if ( present( xyzf_DQMixDt ) ) then
   265            xyz_QMixBefCor = xyzf_QMix(:,:,:,n)
     .        if (xyz_qmixbefcor.DSC.U2 .gt. 0) then                            
     .           J6 = and(xyz_qmixbefcor.DSC.U2,3)                              
     .  !CDIR    NODEP                                                          
     .           do t624 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t626 = 1, xyz_qmixbefcor.DSC.U1 + 1                      
     .                 xyz_qmixbefcor(t626-1,t624,t622+1) = xyzf_qmix(t626-1,   
     .       1            t624,t622+1,n)                                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t624 = J6 + 1, xyz_qmixbefcor.DSC.U2, 4                     
     .  !CDIR       NODEP                                                       
     .              do t626 = 1, xyz_qmixbefcor.DSC.U1 + 1                      
     .                 xyz_qmixbefcor(t626-1,t624,t622+1) = xyzf_qmix(t626-1,   
     .       1            t624,t622+1,n)                                        
     .                 xyz_qmixbefcor(t626-1,t624+1,t622+1) = xyzf_qmix(t626-1, 
     .       1            t624+1,t622+1,n)                                      
     .                 xyz_qmixbefcor(t626-1,t624+2,t622+1) = xyzf_qmix(t626-1, 
     .       1            t624+2,t622+1,n)                                      
     .                 xyz_qmixbefcor(t626-1,t624+3,t622+1) = xyzf_qmix(t626-1, 
     .       1            t624+3,t622+1,n)                                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   266          end if
   267  
   268  
   269          ! μ̤ľؤμ̤碌.
   270          ! Negative mass is removed by filling it with the mass in a layer just below.
   271          !
   272          do k = kmax, 2, -1
   273            do j = 1, jmax
   274              do i = 0, imax-1
   275                if ( xyz_DelConsMass(i,j,k) < 0.0_DP ) then
   276                  xyz_DelConsMass(i,j,k-1) = xyz_DelConsMass(i,j,k-1) &
   277                    & + xyz_DelConsMass(i,j,k)
   278                  xyz_DelConsMass(i,j,k  ) = 0.0_DP
   279                end if
   280              end do
   281            end do
     .        if (jmax .gt. 0) then                                             
     .           J7 = and(jmax,1)                                               
     .           do j = 1, J7                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_delconsmass(i-1,j,k) .lt. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xyz_delconsmass(i-1,j,k-1) = xyz_delconsmass(i-1,j,k-1
     .       1               ) + xyz_delconsmass(i-1,j,k)                       
     .                    xyz_delconsmass(i-1,j,k) = 0.0000000000000000e+000    
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J7 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_delconsmass(i-1,j,k) .lt. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xyz_delconsmass(i-1,j,k-1) = xyz_delconsmass(i-1,j,k-1
     .       1               ) + xyz_delconsmass(i-1,j,k)                       
     .                    xyz_delconsmass(i-1,j,k) = 0.0000000000000000e+000    
     .                 endif                                                    
     .                 if (xyz_delconsmass(i-1,j+1,k) .lt.                      
     .       1            0.0000000000000000e+000) then                         
     .                    xyz_delconsmass(i-1,j+1,k-1) = xyz_delconsmass(i-1,j+1
     .       1               ,k-1) + xyz_delconsmass(i-1,j+1,k)                 
     .                    xyz_delconsmass(i-1,j+1,k) = 0.0000000000000000e+000  
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   282          end do
   283  
   284          k = 1
   285          do j = 1, jmax
   286            do i = 0, imax-1
   287              if ( xyz_DelConsMass(i,j,k) < 0.0_DP ) then
   288                xyz_DelConsMass(i,j,k) = 0.0_DP
   289              end if
   290            end do
   291          end do
     .        if (jmax .gt. 0) then                                             
     .           J8 = and(jmax,1)                                               
     .           do j = 1, J8                                                   
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_delconsmass(i-1,j,1) .lt. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xyz_delconsmass(i-1,j,1) = 0.0000000000000000e+000    
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .           do j = J8 + 1, jmax, 2                                         
     .  !CDIR       NODEP                                                       
     .              do i = 1, imax                                              
     .                 if (xyz_delconsmass(i-1,j,1) .lt. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xyz_delconsmass(i-1,j,1) = 0.0000000000000000e+000    
     .                 endif                                                    
     .                 if (xyz_delconsmass(i-1,j+1,1) .lt.                      
     .       1            0.0000000000000000e+000) then                         
     .                    xyz_delconsmass(i-1,j+1,1) = 0.0000000000000000e+000  
     .                 endif                                                    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   292  
   293  
   294          ! Ǥ
   295          ! Correction in globe
   296          !   ¸ΤΤμ̤򸺾.
   297          !   Total mass is decreased to conserve mass.
   298          !
   299          xy_ConsMass    = 0.0d0
     .        if (xy_consmass.DSC.U2 .gt. 0) then                               
     .           J9 = and(xy_consmass.DSC.U2,1)                                 
     .  !CDIR    NODEP                                                          
     .           do t544 = 1, J9                                                
     .  !CDIR       NODEP                                                       
     .              do t546 = 1, xy_consmass.DSC.U1 + 1                         
     .                 xy_consmass(t546-1,t544) = 0.0000000000000000e+000       
     .                 xy_consmassref(t546-1,t544) = 0.0000000000000000e+000    
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t544 = J9 + 1, xy_consmass.DSC.U2, 2                        
     .  !CDIR       NODEP                                                       
     .              do t546 = 1, xy_consmass.DSC.U1 + 1                         
     .                 xy_consmass(t546-1,t544) = 0.0000000000000000e+000       
     .                 xy_consmass(t546-1,t544+1) = 0.0000000000000000e+000     
     .                 xy_consmassref(t546-1,t544) = 0.0000000000000000e+000    
     .                 xy_consmassref(t546-1,t544+1) = 0.0000000000000000e+000  
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   300          xy_ConsMassRef = 0.0d0
   301          do k = kmax, 1, -1
   302            xy_ConsMass    = xy_ConsMass    + xyz_DelConsMass   (:,:,k)
     .        if (xy_consmass.DSC.U2 .gt. 0) then                               
     .           J10 = and(xy_consmass.DSC.U2,1)                                
     .  !CDIR    NODEP                                                          
     .           do t552 = 1, J10                                               
     .  !CDIR       NODEP                                                       
     .              do t554 = 1, xy_consmass.DSC.U1 + 1                         
     .                 xy_consmass(t554-1,t552) = xy_consmass(t554-1,t552) +    
     .       1            xyz_delconsmass(t554-1,t552,k)                        
     .                 xy_consmassref(t554-1,t552) = xy_consmassref(t554-1,t552)
     .       1             + xyz_delconsmassref(t554-1,t552,k)                  
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t552 = J10 + 1, xy_consmass.DSC.U2, 2                       
     .  !CDIR       NODEP                                                       
     .              do t554 = 1, xy_consmass.DSC.U1 + 1                         
     .                 xy_consmass(t554-1,t552) = xy_consmass(t554-1,t552) +    
     .       1            xyz_delconsmass(t554-1,t552,k)                        
     .                 xy_consmass(t554-1,t552+1) = xy_consmass(t554-1,t552+1)  
     .       1             + xyz_delconsmass(t554-1,t552+1,k)                   
     .                 xy_consmassref(t554-1,t552) = xy_consmassref(t554-1,t552)
     .       1             + xyz_delconsmassref(t554-1,t552,k)                  
     .                 xy_consmassref(t554-1,t552+1) = xy_consmassref(t554-1,   
     .       1            t552+1) + xyz_delconsmassref(t554-1,t552+1,k)         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   303            xy_ConsMassRef = xy_ConsMassRef + xyz_DelConsMassRef(:,:,k)
   304          end do
   305          ConsMass    = IntLonLat_xy( xy_ConsMass    )
   306          ConsMassRef = IntLonLat_xy( xy_ConsMassRef )
   307  
   308  
   309          if ( ConsMassRef < 0.0_DP ) then
   310            call MessageNotify( 'M', module_name, 'ConsMassRef is negative. ' &
   311              & // 'ConsMassRef is reset to zero, n = %d, ConsMassRef = %f.', &
   312              & i = (/ n /), d = (/ ConsMassRef /) )
   313            ConsMassRef = 0.0_DP
   314  !!$        call MessageNotify( 'E', module_name, 'ConsMassRef is negative, n = %d.', i = (/ n /) )
   315          end if
   316          if ( ConsMass /= 0.0_DP ) then
   317            xyz_DelConsMass = ConsMassRef / ConsMass * xyz_DelConsMass
     .        if (1 + xyz_delconsmass.DSC.U2 - min0(1,xyz_delconsmass.DSC.U2)   
     .       1    .gt. 0) then                                                  
     .           J11 = and(1 + xyz_delconsmass.DSC.U2 - min0(1,                 
     .       1      xyz_delconsmass.DSC.U2),3)                                  
     .  !CDIR    NODEP                                                          
     .           do t612 = 1, J11                                               
     .  !CDIR       NODEP                                                       
     .              do t614 = 1, xyz_delconsmass.DSC.U1 + 2 - min0(1,           
     .       1         xyz_delconsmass.DSC.U1 + 1)                              
     .                 xyz_delconsmass(t614-1,t612,t610+1) = consmassref/       
     .       1            consmass*xyz_delconsmass(t614-1,t612,t610+1)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t612 = J11 + 1, 1 + xyz_delconsmass.DSC.U2 - min0(1,        
     .       1      xyz_delconsmass.DSC.U2), 4                                  
     .  !CDIR       NODEP                                                       
     .              do t614 = 1, xyz_delconsmass.DSC.U1 + 2 - min0(1,           
     .       1         xyz_delconsmass.DSC.U1 + 1)                              
     .                 xyz_delconsmass(t614-1,t612,t610+1) = (consmassref/      
     .       1            consmass)*xyz_delconsmass(t614-1,t612,t610+1)         
     .                 xyz_delconsmass(t614-1,t612+1,t610+1) = (consmassref/    
     .       1            consmass)*xyz_delconsmass(t614-1,t612+1,t610+1)       
     .                 xyz_delconsmass(t614-1,t612+2,t610+1) = (consmassref/    
     .       1            consmass)*xyz_delconsmass(t614-1,t612+2,t610+1)       
     .                 xyz_delconsmass(t614-1,t612+3,t610+1) = (consmassref/    
     .       1            consmass)*xyz_delconsmass(t614-1,t612+3,t610+1)       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   318          else
   319            xyz_DelConsMass = 0.0_DP
     .        if (xyz_delconsmass.DSC.U2 .gt. 0) then                           
     .           J12 = and(xyz_delconsmass.DSC.U2,3)                            
     .  !CDIR    NODEP                                                          
     .           do t570 = 1, J12                                               
     .  !CDIR       NODEP                                                       
     .              do t572 = 1, xyz_delconsmass.DSC.U1 + 1                     
     .                 xyz_delconsmass(t572-1,t570,t568+1) =                    
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t570 = J12 + 1, xyz_delconsmass.DSC.U2, 4                   
     .  !CDIR       NODEP                                                       
     .              do t572 = 1, xyz_delconsmass.DSC.U1 + 1                     
     .                 xyz_delconsmass(t572-1,t570,t568+1) =                    
     .       1            0.0000000000000000e+000                               
     .                 xyz_delconsmass(t572-1,t570+1,t568+1) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_delconsmass(t572-1,t570+2,t568+1) =                  
     .       1            0.0000000000000000e+000                               
     .                 xyz_delconsmass(t572-1,t570+3,t568+1) =                  
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   320          end if
   321  
   322          xyzf_QMix(:,:,:,n) = xyz_DelConsMass / xyz_DelMass
     .        if (xyz_delconsmass.DSC.U2 .gt. 0) then                           
     .           J13 = and(xyz_delconsmass.DSC.U2,3)                            
     .  !CDIR    NODEP                                                          
     .           do t579 = 1, J13                                               
     .  !CDIR       NODEP                                                       
     .              do t581 = 1, xyz_delconsmass.DSC.U1 + 1                     
     .                 xyzf_qmix(t581-1,t579,t577+1,n) = xyz_delconsmass(t581-1,
     .       1            t579,t577+1)/xyz_delmass(t581-1,t579,t577+1)          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t579 = J13 + 1, xyz_delconsmass.DSC.U2, 4                   
     .  !CDIR       NODEP                                                       
     .              do t581 = 1, xyz_delconsmass.DSC.U1 + 1                     
     .                 xyzf_qmix(t581-1,t579,t577+1,n) = xyz_delconsmass(t581-1,
     .       1            t579,t577+1)/xyz_delmass(t581-1,t579,t577+1)          
     .                 xyzf_qmix(t581-1,t579+1,t577+1,n) = xyz_delconsmass(t581-
     .       1            1,t579+1,t577+1)/xyz_delmass(t581-1,t579+1,t577+1)    
     .                 xyzf_qmix(t581-1,t579+2,t577+1,n) = xyz_delconsmass(t581-
     .       1            1,t579+2,t577+1)/xyz_delmass(t581-1,t579+2,t577+1)    
     .                 xyzf_qmix(t581-1,t579+3,t577+1,n) = xyz_delconsmass(t581-
     .       1            1,t579+3,t577+1)/xyz_delmass(t581-1,t579+3,t577+1)    
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   323  
   324          ! 漾Ѳλ
   325          ! Calculate specific humidity variance
   326          !
   327          if ( present( xyzf_DQMixDt ) ) then
   328            xyzf_DQMixDt(:,:,:,n) =     &
     .        if (1 + jmax - min0(1,jmax) .gt. 0) then                          
     .           J14 = and(1 + jmax - min0(1,jmax),3)                           
     .  !CDIR    NODEP                                                          
     .           do t594 = 1, J14                                               
     .              D11 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t596 = 1, imax + 1 - min0(1,imax)                        
     .                 xyzf_dqmixdt(t596-1,t594,t592+1,n) = xyzf_dqmixdt(t596-1,
     .       1            t594,t592+1,n) + (xyzf_qmix(t596-1,t594,t592+1,n)-    
     .       2            xyz_qmixbefcor(t596-1,t594,t592+1))*D11               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t594 = J14 + 1, 1 + jmax - min0(1,jmax), 4                  
     .              D12 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D13 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D14 = 1.D0/(2.00000000000000e+000*deltime)                  
     .              D15 = 1.D0/(2.00000000000000e+000*deltime)                  
     .  !CDIR       NODEP                                                       
     .              do t596 = 1, imax + 1 - min0(1,imax)                        
     .                 xyzf_dqmixdt(t596-1,t594,t592+1,n) = xyzf_dqmixdt(t596-1,
     .       1            t594,t592+1,n) + (xyzf_qmix(t596-1,t594,t592+1,n)-    
     .       2            xyz_qmixbefcor(t596-1,t594,t592+1))*D12               
     .                 xyzf_dqmixdt(t596-1,t594+1,t592+1,n) = xyzf_dqmixdt(t596-
     .       1            1,t594+1,t592+1,n) + (xyzf_qmix(t596-1,t594+1,t592+1,n
     .       2            )-xyz_qmixbefcor(t596-1,t594+1,t592+1))*D13           
     .                 xyzf_dqmixdt(t596-1,t594+2,t592+1,n) = xyzf_dqmixdt(t596-
     .       1            1,t594+2,t592+1,n) + (xyzf_qmix(t596-1,t594+2,t592+1,n
     .       2            )-xyz_qmixbefcor(t596-1,t594+2,t592+1))*D14           
     .                 xyzf_dqmixdt(t596-1,t594+3,t592+1,n) = xyzf_dqmixdt(t596-
     .       1            1,t594+3,t592+1,n) + (xyzf_qmix(t596-1,t594+3,t592+1,n
     .       2            )-xyz_qmixbefcor(t596-1,t594+3,t592+1))*D15           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   329              &   xyzf_DQMixDt(:,:,:,n) &
   330              & + ( xyzf_QMix(:,:,:,n) - xyz_QMixBefCor ) / ( 2.0_DP * DelTime )
   331          end if
   332  
   333        else
   334  
   335          ! 漾Ѳλ
   336          ! Calculate specific humidity variance
   337          !
   338          if ( present( xyzf_DQMixDt ) ) then
   339            xyzf_DQMixDt(:,:,:,n) = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t508 = 1, kmax*jmax*imax                                       
     .           xyzf_dqmixdt(t508-1,1,1,n) = 0.0000000000000000e+000           
     .        end do                                                            
   340          end if
   341  
   342        end if
   343  
   344      end do
   345  
   346  
   347      do k = 1, kmax
   348        do j = 1, jmax
   349          do i = 0, imax-1
   350            if ( xyzf_QMix(i,j,k,1) < 0.0_DP ) then
   351              write( 6, * ) 'NEGATIVE: ', i, j, k, xyzf_QMix(i,j,k,1)
   352            end if
   353          end do
   354        end do
   355      end do
   356  
   357  
   358      ! ׻ַ¬
   359      ! Pause measurement of computation time
   360      !
   361      call TimesetClockStop( module_name )
   362  
   363    end subroutine MassFixer
   364  
   365    !--------------------------------------------------------------------------------------
   366  
   367    subroutine MassFixerInit
   368      !
   369      ! mass_fixer ⥸塼νԤޤ.
   370      ! NAMELIST#mass_fixer_nml ɤ߹ߤϤμ³ǹԤޤ.
   371      !
   372      ! "mass_fixer" module is initialized.
   373      ! "NAMELIST#mass_fixer_nml" is loaded in this procedure.
   374      !
   375  
   376      ! ⥸塼 ; USE statements
   377      !
   378  
   379      ! NAMELIST եϤ˴ؤ桼ƥƥ
   380      ! Utilities for NAMELIST file input
   381      !
   382      use namelist_util, only: namelist_filename, NmlutilMsg
   383  
   384      ! ե
   385      ! File I/O support
   386      !
   387      use dc_iounit, only: FileOpen
   388  
   389      ! ̷ѥ᥿
   390      ! Kind type parameter
   391      !
   392      use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   393  
   394      ! ʸ
   395      ! Character handling
   396      !
   397      use dc_string, only: StoA
   398  
   399      ! ʸ ; Declaration statements
   400      !
   401      implicit none
   402  
   403  !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   404  !!$                              ! Unit number for NAMELIST file open
   405  !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   406  !!$                              ! IOSTAT of NAMELIST read
   407  
   408      ! NAMELIST ѿ
   409      ! NAMELIST group name
   410      !
   411  !!$    namelist /mass_fixer_nml/
   412            !
   413            ! ǥեͤˤĤƤϽ³ "mass_fixer#MassFixerInit"
   414            ! Υɤ򻲾ȤΤ.
   415            !
   416            ! Refer to source codes in the initialization procedure
   417            ! "mass_fixer#MassFixerInit" for the default values.
   418            !
   419  
   420      ! ¹ʸ ; Executable statement
   421      !
   422  
   423      if ( mass_fixer_inited ) return
   424  
   425  
   426      ! ǥեͤ
   427      ! Default values settings
   428      !
   429  
   430  !!$    ! NAMELIST ɤ߹
   431  !!$    ! NAMELIST is input
   432  !!$    !
   433  !!$    if ( trim(namelist_filename) /= '' ) then
   434  !!$      call FileOpen( unit_nml, &          ! (out)
   435  !!$        & namelist_filename, mode = 'r' ) ! (in)
   436  !!$
   437  !!$      rewind( unit_nml )
   438  !!$      read( unit_nml, &           ! (in)
   439  !!$        & nml = mass_fixer_nml, &  ! (out)
   440  !!$        & iostat = iostat_nml )   ! (out)
   441  !!$      close( unit_nml )
   442  !!$
   443  !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   444  !!$    end if
   445  
   446      !  ; Print
   447      !
   448      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   449      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   450  
   451      mass_fixer_inited = .true.
   452  
   453    end subroutine MassFixerInit
   454  
   455    !--------------------------------------------------------------------------------------
   456  
   457  end module mass_fixer
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:49:20 2012
FILE NAME: mass_fixer.f90
PROGRAM NAME: mass_fixer
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != ̤
     2:            !
     3:            != Mass fixer
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi, Yasuhiro MORIKAWA, Yukiko YAMADA
     6:            ! Version::   $Id: mass_fixer.f90,v 1.8 2012-02-20 09:29:57 yot Exp $ 
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            
    12:            module mass_fixer
    13:              !
    14:              != ̤
    15:              !
    16:              != Mass fixer
    17:              !
    18:              ! <b>Note that Japanese and English are described in parallel.</b>
    19:              !
    20:              ! ̤ޤ.
    21:              !
    22:              ! Fix masses
    23:              !
    24:              !== Procedures List
    25:              !
    26:              ! MassFixer   :: ̤
    27:              ! ----------  :: ---------------
    28:              ! MassFixer   :: Fix masses
    29:              !
    30:              !--
    31:              !== NAMELIST
    32:              !
    33:              ! NAMELIST#mass_fixer_nml
    34:              !++
    35:            
    36:              ! ⥸塼 ; USE statements
    37:              !
    38:            
    39:              ! ʻ
    40:              ! Grid points settings
    41:              !
    42:              use gridset, only: imax, & ! ٳʻ. 
    43:                                         ! Number of grid points in longitude
    44:                &                jmax, & ! ٳʻ. 
    45:                                         ! Number of grid points in latitude
    46:                &                kmax    ! ľؿ. 
    47:                                         ! Number of vertical level
    48:            
    49:              ! ˴ؤ
    50:              ! Settings of array for atmospheric composition
    51:              !
    52:              use composition, only: &
    53:                &                    ncmax
    54:                                          ! ʬο
    55:                                          ! Number of composition
    56:            
    57:              ! ̷ѥ᥿
    58:              ! Kind type parameter
    59:              !
    60:              use dc_types, only: DP, &      ! ټ¿. Double precision. 
    61:                &                 STRING     ! ʸ.       Strings. 
    62:            
    63:              ! å
    64:              ! Message output
    65:              !
    66:              use dc_message, only: MessageNotify
    67:            
    68:              ! ʸ ; Declaration statements
    69:              !
    70:              implicit none
    71:              private
    72:            
    73:              ! ³
    74:              ! Public procedure
    75:              !
    76:              public :: MassFixer
    77:              public :: MassFixerInit
    78:            
    79:              ! ѿ
    80:              ! Public variables
    81:              !
    82:            
    83:              ! ѿ
    84:              ! Private variables
    85:              !
    86:              logical, save :: mass_fixer_inited = .false.
    87:                                          ! ե饰. 
    88:                                          ! Initialization flag
    89:            
    90:              character(*), parameter:: module_name = 'mass_fixer'
    91:                                          ! ⥸塼̾. 
    92:                                          ! Module name
    93:              character(*), parameter:: version = &
    94:                & '$Name: dcpam5-20120921 $' // &
    95:                & '$Id: mass_fixer.f90,v 1.8 2012-02-20 09:29:57 yot Exp $'
    96:                                          ! ⥸塼ΥС
    97:                                          ! Module version
    98:            
    99:            contains
   100:            
   101:              !--------------------------------------------------------------------------------------
   102:            
   103:              subroutine MassFixer(           &
   104:                & xyr_Press,                  & ! (in)
   105:                & xyzf_QMix,                  & ! (inout)
   106:                & xyr_PressRef,               & ! (in) optional
   107:                & xyzf_QMixRef,               & ! (in) optional
   108:                & xyzf_DQMixDt                & ! (out) optional
   109:                & )
   110:                !
   111:                ! ʬμ̤ޤ. 
   112:                ! *xyzf_QMixRef* Ϳ줿ˤ, ʬͤ *xyzf_QMixRef* Τ
   113:                ! Ʊˤʤ褦ޤ. 
   114:                ! *xyzf_QMixRef* Ϳʤˤ, ʬͤΤ
   115:                ! Ʊˤʤ褦ޤ. 
   116:                ! *xyzf_DQMixDt* ˤ *xyz_QMix* Ѳ̤֤ޤ. 
   117:                !
   118:                ! Fix masses of constituents
   119:                ! If *xyzf_QMixRef* is given, the mass is fixed to match its global integrated 
   120:                ! value is the same as that of *xyzf_QMixRef*.
   121:                ! If *xyzf_QMixRef* is not given, the mass is fixed to match its global integrated 
   122:                ! value is the same as that of pre-fixed value. 
   123:                ! Variation of *xyzf_QMix* is returned to *xyz_DQMixDt*. 
   124:                !
   125:            
   126:                ! ⥸塼 ; USE statements
   127:                !
   128:            
   129:                ! ʪ
   130:                ! Physical constants settings
   131:                !
   132:                use constants, only: Grav ! $ g $ [m s-2].
   133:                                          ! ϲ®.
   134:                                          ! Gravitational acceleration
   135:            
   136:                ! ʬʿѤ
   137:                ! Operation for integral and average
   138:                !
   139:                use intavr_operate, only: IntLonLat_xy
   140:            
   141:                ! 
   142:                ! Time control
   143:                !
   144:                use timeset, only: DelTime, &  ! $ \Delta t $
   145:                  & TimesetClockStart, TimesetClockStop
   146:            
   147:                ! ˴ؤ
   148:                ! Settings of array for atmospheric composition
   149:                !
   150:                use composition, only: CompositionInqFlagMassFix
   151:            
   152:            
   153:                ! ʸ ; Declaration statements
   154:                !
   155:                implicit none
   156:                real(DP), intent(in   )          :: xyr_Press   (0:imax-1, 1:jmax, 0:kmax)
   157:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   158:                                          ! Air pressure (half level)
   159:                real(DP), intent(inout)          :: xyzf_QMix   (0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   160:                                          ! $ q $ .     漾. Specific humidity
   161:                real(DP), intent(in   ), optional:: xyr_PressRef(0:imax-1, 1:jmax, 0:kmax)
   162:                                          ! $ \hat{p} $ .  (Ⱦ٥). 
   163:                                          ! Air pressure (half level)
   164:                real(DP), intent(in   ), optional:: xyzf_QMixRef(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   165:                                          ! $ q \Delta p / g $ . ʬͤ碌ʬμ. 
   166:                                          ! Reference specific mass of constituent in a layer
   167:                real(DP), intent(out  ), optional:: xyzf_DQMixDt(0:imax-1, 1:jmax, 1:kmax, 1:ncmax)
   168:                                          ! $ \DP{q}{t} $ .  漾Ψ. 
   169:                                          ! Specific humidity correction
   170:            
   171:                ! ѿ
   172:                ! Work variables
   173:                !
   174:                real(DP):: xyz_QMixBefCor    (0:imax-1, 1:jmax, 1:kmax)
   175:                                          ! 漾.
   176:                                          ! Specific humidity before correction. 
   177:                real(DP):: xyz_DelMass       (0:imax-1, 1:jmax, 1:kmax)
   178:                                          ! $ \Delta p / g $
   179:                                          ! 
   180:                real(DP):: xyz_DelMassRef    (0:imax-1, 1:jmax, 1:kmax)
   181:                                          ! $ \Delta p / g $ of reference
   182:                                          ! 
   183:                real(DP):: xyz_DelConsMass   (0:imax-1, 1:jmax, 1:kmax)
   184:                                          ! ʬμ.
   185:                                          ! Mass of constituents in a layer.
   186:                real(DP):: xyz_DelConsMassRef(0:imax-1, 1:jmax, 1:kmax)
   187:                                          ! ʬͤ碌ʬμ.
   188:                                          ! Reference mass of constituents.
   189:                real(DP):: xy_ConsMass          (0:imax-1, 1:jmax)
   190:                                          ! ʬΥ.
   191:                                          ! Mass of constituents in a layer.
   192:                real(DP):: xy_ConsMassRef       (0:imax-1, 1:jmax)
   193:                                          ! ʬͤ碌ʬΥ.
   194:                                          ! Reference mass of constituents in a layer.
   195:                real(DP):: ConsMass
   196:                                          ! γʬμ
   197:                                          ! Total mass of constituents
   198:                real(DP):: ConsMassRef
   199:                                          ! ʬͤ碌γʬμ
   200:                                          ! Reference total mass of constituents.
   201:                                          !
   202:            
   203:                integer:: i               ! ˲ DO 롼Ѻѿ
   204:                                          ! Work variables for DO loop in longitudinal direction
   205:                integer:: j               ! ˲ DO 롼Ѻѿ
   206:                                          ! Work variables for DO loop in latitudinal direction
   207:                integer:: k               ! ľ˲ DO 롼Ѻѿ
   208:                                          ! Work variables for DO loop in vertical direction
   209:                integer:: n               ! ˲ DO 롼Ѻѿ
   210:                                          ! Work variables for DO loop in dimension of constituents
   211:            
   212:                ! ¹ʸ ; Executable statement
   213:                !
   214:            
   215:                ! ǧ
   216:                ! Initialization check
   217:                !
   218:                if ( .not. mass_fixer_inited ) then
   219:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   220:                end if
   221:            
   222:            
   223:                ! ׻ַ¬
   224:                ! Start measurement of computation time
   225:                !
   226:                call TimesetClockStart( module_name )
   227:            
   228:            
   229:                ! Check arguments
   230:                !
   231:                if ( present( xyr_PressRef ) .or. present( xyzf_QMixRef ) ) then
   232:                  if ( .not. ( present( xyr_PressRef ) .and. present( xyzf_QMixRef ) ) ) then
   233:                    call MessageNotify( 'E', module_name, 'If xyr_PressRef or xyzf_QMixRef is given, both have to be given.' )
   234:                  end if
   235:                end if
   236:            
   237:            
   238:                ! $ \Delta p / g $ η׻
   239:                ! Calculate $ \Delta p / g $
   240:                !
   241: +------>       do k = 1, kmax
   242: |+V====          xyz_DelMass(:,:,k) = ( xyr_Press(:,:,k-1) - xyr_Press(:,:,k) ) / Grav
   243: +------        end do
   244:            
   245:                if ( present( xyr_PressRef ) ) then
   246: +------>         do k = 1, kmax
   247: |+V====            xyz_DelMassRef(:,:,k) = ( xyr_PressRef(:,:,k-1) - xyr_PressRef(:,:,k) ) / Grav
   248: +------          end do
   249:                end if
   250:            
   251: +------>       do n = 1, ncmax
   252: |          
   253: |                if ( CompositionInqFlagMassFix( n ) ) then
   254: |          
   255: |                  ! Calculate mass of constituents
   256: |                  !
   257: |++V===            xyz_DelConsMass = xyzf_QMix(:,:,:,n) * xyz_DelMass
   258: |          
   259: |                  if ( present( xyzf_QMixRef ) ) then
   260: |++V===              xyz_DelConsMassRef = xyzf_QMixRef(:,:,:,n) * xyz_DelMassRef
   261: |                  else
   262: |++V===              xyz_DelConsMassRef = xyz_DelConsMass
   263: |                  end if
   264: |                  if ( present( xyzf_DQMixDt ) ) then
   265: |++V===              xyz_QMixBefCor = xyzf_QMix(:,:,:,n)
   266: |                  end if
   267: |          
   268: |          
   269: |                  ! μ̤ľؤμ̤碌.
   270: |                  ! Negative mass is removed by filling it with the mass in a layer just below.
   271: |                  !
   272: |+----->           do k = kmax, 2, -1
   273: ||+---->             do j = 1, jmax
   274: |||V--->               do i = 0, imax-1
   275: ||||                     if ( xyz_DelConsMass(i,j,k) < 0.0_DP ) then
   276: ||||                       xyz_DelConsMass(i,j,k-1) = xyz_DelConsMass(i,j,k-1) &
   277: ||||                         & + xyz_DelConsMass(i,j,k)
   278: ||||                       xyz_DelConsMass(i,j,k  ) = 0.0_DP
   279: ||||                     end if
   280: |||V---                end do
   281: ||+----              end do
   282: |+-----            end do
   283: |          
   284: |                  k = 1
   285: |+----->           do j = 1, jmax
   286: ||V---->             do i = 0, imax-1
   287: |||                    if ( xyz_DelConsMass(i,j,k) < 0.0_DP ) then
   288: |||                      xyz_DelConsMass(i,j,k) = 0.0_DP
   289: |||                    end if
   290: ||V----              end do
   291: |+-----            end do
   292: |          
   293: |          
   294: |                  ! Ǥ
   295: |                  ! Correction in globe
   296: |                  !   ¸ΤΤμ̤򸺾.
   297: |                  !   Total mass is decreased to conserve mass. 
   298: |                  !
   299: |*V---->           xy_ConsMass    = 0.0d0
   300: |*V----            xy_ConsMassRef = 0.0d0
   301: |+----->           do k = kmax, 1, -1
   302: ||*V--->             xy_ConsMass    = xy_ConsMass    + xyz_DelConsMass   (:,:,k)
   303: ||*V---              xy_ConsMassRef = xy_ConsMassRef + xyz_DelConsMassRef(:,:,k)
   304: |+-----            end do
   305: |                  ConsMass    = IntLonLat_xy( xy_ConsMass    )
   306: |                  ConsMassRef = IntLonLat_xy( xy_ConsMassRef )
   307: |          
   308: |          
   309: |                  if ( ConsMassRef < 0.0_DP ) then 
   310: |                    call MessageNotify( 'M', module_name, 'ConsMassRef is negative. ' &
   311: |                      & // 'ConsMassRef is reset to zero, n = %d, ConsMassRef = %f.', &
   312: |                      & i = (/ n /), d = (/ ConsMassRef /) )
   313: |                    ConsMassRef = 0.0_DP
   314: |          !!$        call MessageNotify( 'E', module_name, 'ConsMassRef is negative, n = %d.', i = (/ n /) )
   315: |                  end if
   316: |                  if ( ConsMass /= 0.0_DP ) then 
   317: |++V===              xyz_DelConsMass = ConsMassRef / ConsMass * xyz_DelConsMass
   318: |                  else
   319: |++V===              xyz_DelConsMass = 0.0_DP
   320: |                  end if
   321: |          
   322: |++V===            xyzf_QMix(:,:,:,n) = xyz_DelConsMass / xyz_DelMass
   323: |          
   324: |                  ! 漾Ѳλ
   325: |                  ! Calculate specific humidity variance
   326: |                  !
   327: |                  if ( present( xyzf_DQMixDt ) ) then
   328: |++V===              xyzf_DQMixDt(:,:,:,n) =     &
   329: |                      &   xyzf_DQMixDt(:,:,:,n) &
   330: |                      & + ( xyzf_QMix(:,:,:,n) - xyz_QMixBefCor ) / ( 2.0_DP * DelTime )
   331: |                  end if
   332: |          
   333: |                else
   334: |          
   335: |                  ! 漾Ѳλ
   336: |                  ! Calculate specific humidity variance
   337: |                  !
   338: |                  if ( present( xyzf_DQMixDt ) ) then
   339: |W**===              xyzf_DQMixDt(:,:,:,n) = 0.0_DP
   340: |                  end if
   341: |          
   342: |                end if
   343: |          
   344: +------        end do
   345:            
   346:            
   347: +------>       do k = 1, kmax
   348: |+----->         do j = 1, jmax
   349: ||+---->           do i = 0, imax-1
   350: |||                  if ( xyzf_QMix(i,j,k,1) < 0.0_DP ) then
   351: |||                    write( 6, * ) 'NEGATIVE: ', i, j, k, xyzf_QMix(i,j,k,1)
   352: |||                  end if
   353: ||+----            end do
   354: |+-----          end do
   355: +------        end do
   356:            
   357:            
   358:                ! ׻ַ¬
   359:                ! Pause measurement of computation time
   360:                !
   361:                call TimesetClockStop( module_name )
   362:            
   363:              end subroutine MassFixer
   364:            
   365:              !--------------------------------------------------------------------------------------
   366:            
   367:              subroutine MassFixerInit
   368:                !
   369:                ! mass_fixer ⥸塼νԤޤ. 
   370:                ! NAMELIST#mass_fixer_nml ɤ߹ߤϤμ³ǹԤޤ. 
   371:                !
   372:                ! "mass_fixer" module is initialized. 
   373:                ! "NAMELIST#mass_fixer_nml" is loaded in this procedure. 
   374:                !
   375:            
   376:                ! ⥸塼 ; USE statements
   377:                !
   378:            
   379:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   380:                ! Utilities for NAMELIST file input
   381:                !
   382:                use namelist_util, only: namelist_filename, NmlutilMsg
   383:            
   384:                ! ե
   385:                ! File I/O support
   386:                !
   387:                use dc_iounit, only: FileOpen
   388:            
   389:                ! ̷ѥ᥿
   390:                ! Kind type parameter
   391:                !
   392:                use dc_types, only: STDOUT ! ɸϤֹ. Unit number of standard output
   393:            
   394:                ! ʸ
   395:                ! Character handling
   396:                !
   397:                use dc_string, only: StoA
   398:            
   399:                ! ʸ ; Declaration statements
   400:                !
   401:                implicit none
   402:            
   403:            !!$    integer:: unit_nml        ! NAMELIST ե륪ץֹ. 
   404:            !!$                              ! Unit number for NAMELIST file open
   405:            !!$    integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT. 
   406:            !!$                              ! IOSTAT of NAMELIST read
   407:            
   408:                ! NAMELIST ѿ
   409:                ! NAMELIST group name
   410:                !
   411:            !!$    namelist /mass_fixer_nml/
   412:                      !
   413:                      ! ǥեͤˤĤƤϽ³ "mass_fixer#MassFixerInit" 
   414:                      ! Υɤ򻲾ȤΤ. 
   415:                      !
   416:                      ! Refer to source codes in the initialization procedure
   417:                      ! "mass_fixer#MassFixerInit" for the default values. 
   418:                      !
   419:            
   420:                ! ¹ʸ ; Executable statement
   421:                !
   422:            
   423:                if ( mass_fixer_inited ) return
   424:            
   425:            
   426:                ! ǥեͤ
   427:                ! Default values settings
   428:                !
   429:            
   430:            !!$    ! NAMELIST ɤ߹
   431:            !!$    ! NAMELIST is input
   432:            !!$    !
   433:            !!$    if ( trim(namelist_filename) /= '' ) then
   434:            !!$      call FileOpen( unit_nml, &          ! (out)
   435:            !!$        & namelist_filename, mode = 'r' ) ! (in)
   436:            !!$
   437:            !!$      rewind( unit_nml )
   438:            !!$      read( unit_nml, &           ! (in)
   439:            !!$        & nml = mass_fixer_nml, &  ! (out)
   440:            !!$        & iostat = iostat_nml )   ! (out)
   441:            !!$      close( unit_nml )
   442:            !!$
   443:            !!$      call NmlutilMsg( iostat_nml, module_name ) ! (in)
   444:            !!$    end if
   445:            
   446:                !  ; Print
   447:                !
   448:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   449:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   450:            
   451:                mass_fixer_inited = .true.
   452:            
   453:              end subroutine MassFixerInit
   454:            
   455:              !--------------------------------------------------------------------------------------
   456:            
   457:            end module mass_fixer
