Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:59 2012
FILE NAME: rad_Mars_V1.f90
PROGRAM NAME: rad_mars_v1
DIAGNOSTIC LIST

  LINE  LEVEL( NO.): DIAGNOSTIC MESSAGE

   351  opt  (1592): Outer loop unrolled inside inner loop.
   351  vec  (   4): Vectorized array expression.
   351  vec  (   4): Vectorized array expression.
   353  opt  (  11): Fused array assignments. :line 353 - 354
   353  opt  (1593): Loop nest collapsed into one loop.
   353  vec  (   4): Vectorized array expression.
   355  opt  (  11): Fused array assignments. :line 355 - 356
   355  opt  (1772): Loop nest fused with following nest(s).
   355  opt  (1593): Loop nest collapsed into one loop.
   355  vec  (   4): Vectorized array expression.
   361  opt  (1592): Outer loop unrolled inside inner loop.
   361  vec  (   4): Vectorized array expression.
   361  vec  (   4): Vectorized array expression.
   370  vec  (   1): Vectorized loop.
   396  opt  (  11): Fused array assignments. :line 396 - 397
   396  vec  (   4): Vectorized array expression.
   396  vec  (   4): Vectorized array expression.
   397  opt  (1592): Outer loop unrolled inside inner loop.
   399  opt  (1592): Outer loop unrolled inside inner loop.
   399  vec  (   4): Vectorized array expression.
   399  vec  (   4): Vectorized array expression.
   471  opt  (1592): Outer loop unrolled inside inner loop.
   471  vec  (   4): Vectorized array expression.
   471  vec  (   4): Vectorized array expression.
   472  opt  (  11): Fused array assignments. :line 472 - 474
   472  vec  (   4): Vectorized array expression.
   472  vec  (   4): Vectorized array expression.
   474  opt  (1592): Outer loop unrolled inside inner loop.
   501  opt  (  11): Fused array assignments. :line 501 - 502
   501  vec  (   4): Vectorized array expression.
   501  vec  (   4): Vectorized array expression.
   502  opt  (1592): Outer loop unrolled inside inner loop.
   503  opt  (  11): Fused array assignments. :line 503 - 504
   503  opt  (1772): Loop nest fused with following nest(s).
   503  vec  (   4): Vectorized array expression.
   519  opt  (1592): Outer loop unrolled inside inner loop.
   519  vec  (   4): Vectorized array expression.
   519  vec  (   4): Vectorized array expression.
   520  opt  (1772): Loop nest fused with following nest(s).
   520  opt  (1592): Outer loop unrolled inside inner loop.
   520  vec  (   4): Vectorized array expression.
   520  vec  (   4): Vectorized array expression.
   522  opt  (  11): Fused array assignments. :line 522 - 523
   522  vec  (   4): Vectorized array expression.
   522  vec  (   4): Vectorized array expression.
   523  opt  (1592): Outer loop unrolled inside inner loop.
   524  opt  (  11): Fused array assignments. :line 524 - 525
   524  opt  (1772): Loop nest fused with following nest(s).
   524  vec  (   4): Vectorized array expression.
   537  opt  (  11): Fused array assignments. :line 537 - 538
   537  vec  (   4): Vectorized array expression.
   537  vec  (   4): Vectorized array expression.
   538  opt  (1592): Outer loop unrolled inside inner loop.
   540  opt  (1592): Outer loop unrolled inside inner loop.
   540  vec  (   4): Vectorized array expression.
   540  vec  (   4): Vectorized array expression.
   598  opt  (1592): Outer loop unrolled inside inner loop.
   598  vec  (   4): Vectorized array expression.
   598  vec  (   4): Vectorized array expression.
   599  opt  (  11): Fused array assignments. :line 599 - 601
   599  vec  (   4): Vectorized array expression.
   599  vec  (   4): Vectorized array expression.
   601  opt  (1592): Outer loop unrolled inside inner loop.
   614  opt  (  11): Fused array assignments. :line 614 - 615
   614  vec  (   4): Vectorized array expression.
   614  vec  (   4): Vectorized array expression.
   615  opt  (1592): Outer loop unrolled inside inner loop.
   616  opt  (  11): Fused array assignments. :line 616 - 617
   616  opt  (1772): Loop nest fused with following nest(s).
   616  vec  (   4): Vectorized array expression.
   624  vec  (   3): Unvectorized loop.
   624  vec  (  13): Overhead of loop division is too large.
   625  opt  (1592): Outer loop unrolled inside inner loop.
   625  vec  (   4): Vectorized array expression.
   625  vec  (   4): Vectorized array expression.
   633  warn (  82): Name "kk" is not used.
   633  warn (  82): Name "xyz_deltrans" is not used.
   633  warn (  82): Name "xyrr_trans" is not used.
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:59 2012
FILE NAME: rad_Mars_V1.f90
PROGRAM NAME: rad_mars_v1
TRANSFORMATION LIST

  LINE                   FORTRAN STATEMENT

     1  != 絤ͥǥ Ver. 1
     2  !
     3  != radiation model for the Mars' atmosphere Ver. 1
     4  !
     5  ! Authors::   Yoshiyuki O. Takahashi
     6  ! Version::   $Id: rad_Mars_V1.f90,v 1.5 2012-09-17 10:59:31 yot Exp $
     7  ! Tag Name::  $Name: dcpam5-20120921 $
     8  ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9  ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10  !
    11  module rad_Mars_V1
    12    !
    13    != 絤ͥǥ Ver. 1
    14    !
    15    != radiation model for the Mars' atmosphere Ver. 1
    16    !
    17    ! <b>Note that Japanese and English are described in parallel.</b>
    18    !
    19    ! ϵ絤ͥǥ.
    20    !
    21    ! This is a radiation model for the Mars' atmospehre.
    22    !
    23    ! Radiation in the wavenumber range from   40 to  2600 cm-1
    24    ! is calculated in the routine of long wave radiation.
    25    ! Radiation in the wavenumber range from 2600 to 66667 cm-1 (0.15 to 3.85 micron)
    26    ! is calculated in the routine of shortwave radiation.
    27    !
    28    !== References
    29    !
    30    !
    31    !== Procedures List
    32    !
    33  !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    34  !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    35  !!$  ! RadiationFluxOutput     :: ͥեåν
    36  !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    37  !!$  ! ------------            :: ------------
    38  !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    39  !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    40  !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    41  !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    42    !
    43    !== NAMELIST
    44    !
    45  !!$  ! NAMELIST#radiation_DennouAGCM_nml
    46    !
    47  
    48    ! USE statements
    49    !
    50  
    51    !
    52    ! Kind type parameter
    53    !
    54    use dc_types, only: DP, &      ! Double precision.
    55      &                 STRING, &  ! Strings.
    56      &                 TOKEN      ! Keywords.
    57  
    58    ! ʻ
    59    ! Grid points settings
    60    !
    61    use gridset, only: imax, & ! ٳʻ.
    62                               ! Number of grid points in longitude
    63      &                jmax, & ! ٳʻ.
    64                               ! Number of grid points in latitude
    65      &                kmax    ! ľؿ.
    66                               ! Number of vertical level
    67  
    68    implicit none
    69  
    70    private
    71  
    72  
    73    ! ѿ
    74    ! Public variables
    75    !
    76    logical, save, public:: rad_Mars_V1_inited = .false.
    77                                ! ե饰.
    78                                ! Initialization flag
    79  
    80    ! Private variables
    81    !
    82  
    83    real(DP), save :: SolarConst   ! Solar radiation at the distance of semi-major axis
    84  
    85    public :: RadMarsV1Init
    86    public :: RadMarsV1Flux
    87  
    88    character(*), parameter:: module_name = 'rad_Mars_V1'
    89                                ! ⥸塼̾.
    90                                ! Module name
    91    character(*), parameter:: version = &
    92      & '$Name: dcpam5-20120921 $' // &
    93      & '$Id: rad_Mars_V1.f90,v 1.5 2012-09-17 10:59:31 yot Exp $'
    94                                ! ⥸塼ΥС
    95                                ! Module version
    96  
    97    !--------------------------------------------------------------------------------------
    98  
    99  contains
   100  
   101    !--------------------------------------------------------------------------------------
   102  
   103    subroutine RadMarsV1Flux(                                   &
   104      & xy_SurfType, xy_SurfMajCompIce,                         &
   105      & xy_SurfAlbedo,                                          &
   106      & xyz_Press, xyr_Press, xyz_Temp, xyr_Temp, xy_SurfTemp,  &
   107      & xyr_RadSUwFlux, xyr_RadSDwFlux,                         &
   108      & xyr_RadLUwFlux, xyr_RadLDwFlux,                         &
   109      & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                  &
   110      & )
   111  
   112      ! USE statements
   113      !
   114  
   115      ! å
   116      ! Message output
   117      !
   118      use dc_message, only: MessageNotify
   119  
   120      ! ʪ
   121      ! Physical and mathematical constants settings
   122      !
   123      use constants0, only: &
   124        & PI                    ! $ \pi $ .
   125                                ! ߼Ψ.  Circular constant
   126  
   127      ! ʪ
   128      ! Physical constants settings
   129      !
   130      use constants, only: &
   131        & Grav, &
   132                              ! $ g $ [m s-2].
   133                              ! ϲ®.
   134                              ! Gravitational acceleration
   135        & GasRDry
   136  
   137      ! ȳɹ
   138      ! Setting constants of snow and sea ice
   139      !
   140      use constants_snowseaice, only: &
   141        & CO2IceThreshold, &
   142        & CO2IceEmisS,     &
   143        & CO2IceEmisN
   144  
   145      ! ɸǡ
   146      ! Axes data settings
   147      !
   148      use axesset, only: y_Lat
   149  
   150      ! 
   151      ! Time control
   152      !
   153      use timeset, only: &
   154        & TimeN, &              ! ƥå $ t $ λ.
   155                                ! Time of step $ t $.
   156        & DelTime, &            ! $ \Delta t $
   157        & TimesetClockStart, TimesetClockStop
   158  
   159      ! û ()
   160      ! Short wave (insolation) incoming
   161      !
   162      use rad_short_income, only : RadShortIncome
   163  
   164      use rad_Mars_15m, only : rad15m_main
   165  
   166      use set_Mars_dust, only : &
   167        & SetMarsDustSetDOD067, &
   168        & SetMarsDustCalcDOD067
   169  
   170      ! ̵뤷ã
   171      ! Radiative transfer equation without considering scattering
   172      !
   173      use rad_rte_nonscat, only : RadRTENonScatWrapper
   174  
   175      !
   176      ! Solve radiative transfer equation in two stream approximation
   177      !
   178      use rad_rte_two_stream_app, only: RadRTETwoStreamAppHomogAtm, RadRTETwoStreamAppLW
   179  
   180      ! ץ󥯴ؿη׻
   181      ! Calculate Planck function
   182      !
   183      use planck_func, only :                            &
   184        & Integ_PF_GQ_Array3D, Integ_PF_GQ_Array2D, Integ_DPFDT_GQ_Array2D
   185  
   186      ! ҥȥǡ
   187      ! History data output
   188      !
   189      use gtool_historyauto, only: HistoryAutoPut
   190  
   191  
   192      integer , intent(in ) :: xy_SurfType       (0:imax-1, 1:jmax)
   193      real(DP), intent(in ) :: xy_SurfMajCompIce (0:imax-1, 1:jmax)
   194      real(DP), intent(in ) :: xy_SurfAlbedo     (0:imax-1, 1:jmax)
   195      real(DP), intent(in ) :: xyz_Press         (0:imax-1, 1:jmax, 1:kmax)
   196      real(DP), intent(in ) :: xyr_Press         (0:imax-1, 1:jmax, 0:kmax)
   197      real(DP), intent(in ) :: xyz_Temp          (0:imax-1, 1:jmax, 1:kmax)
   198      real(DP), intent(in ) :: xyr_Temp          (0:imax-1, 1:jmax, 0:kmax)
   199      real(DP), intent(in ) :: xy_SurfTemp       (0:imax-1, 1:jmax)
   200      real(DP), intent(out) :: xyr_RadSUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   201      real(DP), intent(out) :: xyr_RadSDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   202      real(DP), intent(out) :: xyr_RadLUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   203      real(DP), intent(out) :: xyr_RadLDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   204      real(DP), intent(out) :: xyra_DelRadLUwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   205      real(DP), intent(out) :: xyra_DelRadLDwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   206  
   207  
   208  
   209      real(DP), parameter :: DiffFact = 1.66_DP
   210  
   211      real(DP) :: PlanetLonFromVE
   212      real(DP) :: xyr_DOD067  (0:imax-1, 1:jmax, 0:kmax)
   213      real(DP) :: xyr_DOD     (0:imax-1, 1:jmax, 0:kmax)
   214      real(DP) :: xyz_DelTrans(0:imax-1, 1:jmax, 1:kmax)
   215      real(DP) :: xyrr_Trans  (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   216  
   217      real(DP) :: QeRat
   218      real(DP) :: SSA
   219      real(DP) :: AF
   220      real(DP) :: xyz_SSA(0:imax-1, 1:jmax, 1:kmax)
   221      real(DP) :: xyz_AF (0:imax-1, 1:jmax, 1:kmax)
   222  
   223      real(DP) :: xy_LWSurfAlbedo(0:imax-1, 1:jmax)
   224  
   225      real(DP) :: xyr_IntPF      (0:imax-1, 1:jmax, 0:kmax)
   226      real(DP) :: xy_SurfIntPF   (0:imax-1, 1:jmax)
   227      real(DP) :: xy_SurfIntDPFDT(0:imax-1, 1:jmax)
   228  
   229      real(DP) :: xyr_RadLUwFluxComp    (0:imax-1, 1:jmax, 0:kmax)
   230      real(DP) :: xyr_RadLDwFluxComp    (0:imax-1, 1:jmax, 0:kmax)
   231      real(DP) :: xyra_DelRadLUwFluxComp(0:imax-1, 1:jmax, 0:kmax, 0:1)
   232      real(DP) :: xyra_DelRadLDwFluxComp(0:imax-1, 1:jmax, 0:kmax, 0:1)
   233  
   234  
   235      real(DP) :: MajCompIceThreshold
   236      real(DP) :: MajCompIceEmis
   237      real(DP) :: xy_SurfEmis(0:imax-1, 1:jmax)
   238  
   239      real(DP) :: xy_InAngle (0:imax-1, 1:jmax)
   240      real(DP) :: DistFromStarScld
   241      real(DP) :: DiurnalMeanFactor
   242      real(DP) :: SolarFluxTOA
   243  
   244      real(DP) :: xyz_DustDensScledOptDep(0:imax-1, 1:jmax, 1:kmax)
   245  
   246      real(DP)           :: WNs
   247      real(DP)           :: WNe
   248      integer, parameter :: NumGaussNode = 5
   249  
   250      integer :: i
   251      integer :: j
   252      integer :: k
   253      integer :: kk
   254  
   255  
   256  !!$    real(DP) :: MaxError
   257  
   258  
   259  
   260      ! 
   261      ! Initialization
   262      !
   263      if ( .not. rad_Mars_V1_inited ) then
   264        call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   265      end if
   266  
   267  
   268      call RadShortIncome(                        &
   269        & xy_InAngle         = xy_InAngle,        & ! (out) optional
   270        & DistFromStarScld   = DistFromStarScld,  & ! (out) optional
   271        & DiurnalMeanFactor  = DiurnalMeanFactor, & ! (out) optional
   272        & PlanetLonFromVE    = PlanetLonFromVE    & ! (out) optional
   273        & )
   274      SolarFluxTOA = SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   275      PlanetLonFromVE = PlanetLonFromVE * 180.0_DP / PI
   276  
   277      !  Dust optical depth
   278      !
   279      call SetMarsDustSetDOD067(                  &
   280        & PlanetLonFromVE, xyr_Press, xyz_Press,  & ! (in)
   281        & xyr_DOD067                              & ! (out)
   282        & )
   283  !!$    call SetMarsDustCalcDOD067( &
   284  !!$      & xyr_Press, xyz_QDust,   & ! (in)
   285  !!$      & xyr_DOD067              & ! (out)
   286  !!$      & )
   287  
   288  
   289      ! û
   290      ! Short wave radiation
   291      !
   292  
   293  
   294  !!$    QeRat   = 0.9837_DP    !   Ockert-Bell et al. (1997)
   295  !!$    xyz_SSA = 0.86_DP
   296  !!$    xyz_AF  = 0.68_DP
   297  !!$    QeRat   = 1.0_DP       !   Clancy and Lee (1991)
   298      SSA = 0.92_DP
   299      AF  = 0.55_DP
   300  
   301  
   302      call RadRTETwoStreamAppHomogAtm(                                   &
   303        & xy_SurfAlbedo, SolarFluxTOA, xy_InAngle, SSA, AF, xyr_DOD067,  & ! (in )
   304        & xyr_RadSUwFlux, xyr_RadSDwFlux                                 & ! (out)
   305        & )
   306  
   307  
   308  !!$      MaxError = 0.0_DP
   309  !!$      do k = 0, kmax
   310  !!$        do j = 1, jmax
   311  !!$          do i = 0, imax-1
   312  !!$            MaxError = max( MaxError, &
   313  !!$              & abs( OLD_xyr_RadSFlux(i,j,k) - xyr_RadSFlux(i,j,k) ) )
   314  !!$            MaxError = max( MaxError, &
   315  !!$              & abs( OLD_xyr_RadSFlux(i,j,k) - ( xyr_RadSUwFlux(i,j,k) - xyr_RadSDwFlux(i,j,k) ) ) )
   316  !!$          end do
   317  !!$        end do
   318  !!$      end do
   319  !!$      write( 6, * ) MaxError
   320  !!$      write( 6, * ) MaxError, xyr_RadSUwFlux(0,jmax/2+1,kmax)
   321  
   322  !!$      MaxError = 0.0_DP
   323  !!$      do k = 0, kmax
   324  !!$        do j = 1, jmax
   325  !!$          do i = 0, imax-1
   326  !!$            MaxError = max( MaxError, &
   327  !!$              & abs( OLD_xyr_RadLFlux(i,j,k) - xyr_RadLFlux(i,j,k) ) )
   328  !!$            MaxError = max( MaxError, &
   329  !!$              & abs( OLD_xyra_DelRadLFlux(i,j,k,0) - xyra_DelRadLFlux(i,j,k,0) ) )
   330  !!$            MaxError = max( MaxError, &
   331  !!$              & abs( OLD_xyra_DelRadLFlux(i,j,k,1) - xyra_DelRadLFlux(i,j,k,1) ) )
   332  !!$          end do
   333  !!$        end do
   334  !!$      end do
   335  !!$      write( 6, * ) MaxError
   336  !!$      !
   337  !!$      xyr_RadSFlux     = OLD_xyr_RadSFlux
   338  !!$      xyr_RadLFlux     = OLD_xyr_RadLFlux
   339  !!$      xyra_DelRadLFlux = OLD_xyra_DelRadLFlux
   340  
   341  !!$      xyr_RadSUwFlux     = OLD_xyr_RadSFlux
   342  !!$      xyr_RadSDwFlux     = 0.0_DP
   343  
   344  
   345      ! Ĺ
   346      ! Long wave radiation
   347      !
   348  
   349      !   Surface albedo for long wave is set.
   350      !
   351      xy_LWSurfAlbedo = 0.0_DP
     .        if (xy_lwsurfalbedo.DSC.U2 .gt. 0) then                           
     .           J1 = and(xy_lwsurfalbedo.DSC.U2,3)                             
     .  !CDIR    NODEP                                                          
     .           do t770 = 1, J1                                                
     .  !CDIR       NODEP                                                       
     .              do t772 = 1, xy_lwsurfalbedo.DSC.U1 + 1                     
     .                 xy_lwsurfalbedo(t772-1,t770) = 0.0000000000000000e+000   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t770 = J1 + 1, xy_lwsurfalbedo.DSC.U2, 4                    
     .  !CDIR       NODEP                                                       
     .              do t772 = 1, xy_lwsurfalbedo.DSC.U1 + 1                     
     .                 xy_lwsurfalbedo(t772-1,t770) = 0.0000000000000000e+000   
     .                 xy_lwsurfalbedo(t772-1,t770+1) = 0.0000000000000000e+000 
     .                 xy_lwsurfalbedo(t772-1,t770+2) = 0.0000000000000000e+000 
     .                 xy_lwsurfalbedo(t772-1,t770+3) = 0.0000000000000000e+000 
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   352  
   353      xyr_RadLUwFlux     = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t776 = 1, jmax*(kmax + 1)*imax                                 
     .           xyr_radluwflux(t776-1,1,0) = 0.0000000000000000e+000           
     .           xyr_radldwflux(t776-1,1,0) = 0.0000000000000000e+000           
     .        end do                                                            
   354      xyr_RadLDwFlux     = 0.0_DP
   355      xyra_DelRadLUwFlux = 0.0_DP
     .  !CDIR NODEP                                                             
     .  !CDIR NOASSUME                                                          
     .        do t790 = 1, jmax*(kmax + 1)*imax                                 
     .           xyra_delradluwflux(t790-1,1,0,0) = 0.0000000000000000e+000     
     .           xyra_delradldwflux(t790-1,1,0,0) = 0.0000000000000000e+000     
     .           xyra_delradluwflux(t790-1,1,0,1) = 0.0000000000000000e+000     
     .           xyra_delradldwflux(t790-1,1,0,1) = 0.0000000000000000e+000     
     .        end do                                                            
   356      xyra_DelRadLDwFlux = 0.0_DP
   357  
   358  
   359      !  Surface emissivity
   360      !
   361      xy_SurfEmis = 1.0_DP
     .        if (xy_surfemis.DSC.U2 .gt. 0) then                               
     .           J2 = and(xy_surfemis.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t804 = 1, J2                                                
     .  !CDIR       NODEP                                                       
     .              do t806 = 1, xy_surfemis.DSC.U1 + 1                         
     .                 xy_surfemis(t806-1,t804) = 1.00000000000000e+000         
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t804 = J2 + 1, xy_surfemis.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t806 = 1, xy_surfemis.DSC.U1 + 1                         
     .                 xy_surfemis(t806-1,t804) = 1.00000000000000e+000         
     .                 xy_surfemis(t806-1,t804+1) = 1.00000000000000e+000       
     .                 xy_surfemis(t806-1,t804+2) = 1.00000000000000e+000       
     .                 xy_surfemis(t806-1,t804+3) = 1.00000000000000e+000       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   362  
   363      MajCompIceThreshold = CO2IceThreshold
   364      do j = 1, jmax
   365        if ( y_Lat(j) < 0.0_DP ) then
   366          MajCompIceEmis = CO2IceEmisS
   367        else
   368          MajCompIceEmis = CO2IceEmisN
   369        end if
   370        do i = 0, imax-1
   371          if ( xy_SurfType(i,j) > 0 ) then
   372            if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
   373              xy_SurfEmis(i,j) = MajCompIceEmis
   374            else if ( xy_SurfMajCompIce(i,j) < 0.0_DP ) then
   375              xy_SurfEmis(i,j) = xy_SurfEmis(i,j)
   376            else
   377              xy_SurfEmis(i,j) =                                    &
   378                &   ( MajCompIceEmis         - xy_SurfEmis(i,j) )   &
   379                & / ( MajCompIceThreshold    - 0.0_DP           )   &
   380                & * ( xy_SurfMajCompIce(i,j) - 0.0_DP           )   &
   381                & + xy_SurfEmis(i,j)
   382            end if
   383          end if
   384        end do
     .  !CDIR NODEP                                                             
     .        do i = 1, imax                                                    
     .           if (xy_surftype(i-1,j) .gt. 0) then                            
     .              if (xy_surfmajcompice(i-1,j) .gt. majcompicethreshold) then 
     .                 xy_surfemis(i-1,j) = majcompiceemis                      
     .              else                                                        
     .                 if (xy_surfmajcompice(i-1,j) .ge. 0.0000000000000000e+000
     .       1            ) then                                                
     .                    xy_surfemis(i-1,j) = (majcompiceemis - xy_surfemis(i-1
     .       1               ,j))/(majcompicethreshold - 0.0000000000000000e+000
     .       2               )*(xy_surfmajcompice(i-1,j)-0.0000000000000000e+000
     .       3               ) + xy_surfemis(i-1,j)                             
     .                 endif                                                    
     .              endif                                                       
     .           endif                                                          
     .        end do                                                            
   385      end do
   386  
   387  
   388      !    Flux from 0 to 500 cm-1
   389      !
   390      WNs     =   0.0d2
   391      WNe     = 500.0d2
   392      QeRat   = 0.17_DP                       ! Wavenumber averaged extinction coefficient
   393      SSA     = 0.35_DP
   394      AF      = 0.36_DP
   395  
   396      xyz_SSA = SSA
     .        if (xyz_ssa.DSC.U2 .gt. 0) then                                   
     .           J3 = and(xyz_ssa.DSC.U2,1)                                     
     .  !CDIR    NODEP                                                          
     .           do t812 = 1, J3                                                
     .  !CDIR       NODEP                                                       
     .              do t814 = 1, xyz_ssa.DSC.U1 + 1                             
     .                 xyz_ssa(t814-1,t812,t810+1) = ssa                        
     .                 xyz_af(t814-1,t812,t810+1) = af                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t812 = J3 + 1, xyz_ssa.DSC.U2, 2                            
     .  !CDIR       NODEP                                                       
     .              do t814 = 1, xyz_ssa.DSC.U1 + 1                             
     .                 xyz_ssa(t814-1,t812,t810+1) = ssa                        
     .                 xyz_ssa(t814-1,t812+1,t810+1) = ssa                      
     .                 xyz_af(t814-1,t812,t810+1) = af                          
     .                 xyz_af(t814-1,t812+1,t810+1) = af                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   397      xyz_AF  = AF
   398  
   399      xyr_DOD = QeRat * xyr_DOD067
     .        if (xyr_dod067.DSC.U2 .gt. 0) then                                
     .           J4 = and(xyr_dod067.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t824 = 1, J4                                                
     .  !CDIR       NODEP                                                       
     .              do t826 = 1, xyr_dod067.DSC.U1 + 1                          
     .                 xyr_dod(t826-1,t824,t822) = qerat*xyr_dod067(t826-1,t824,
     .       1            t822)                                                 
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t824 = J4 + 1, xyr_dod067.DSC.U2, 4                         
     .  !CDIR       NODEP                                                       
     .              do t826 = 1, xyr_dod067.DSC.U1 + 1                          
     .                 xyr_dod(t826-1,t824,t822) = qerat*xyr_dod067(t826-1,t824,
     .       1            t822)                                                 
     .                 xyr_dod(t826-1,t824+1,t822) = qerat*xyr_dod067(t826-1,   
     .       1            t824+1,t822)                                          
     .                 xyr_dod(t826-1,t824+2,t822) = qerat*xyr_dod067(t826-1,   
     .       1            t824+2,t822)                                          
     .                 xyr_dod(t826-1,t824+3,t822) = qerat*xyr_dod067(t826-1,   
     .       1            t824+3,t822)                                          
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   400  
   401      !----------
   402      !    Modification of dust optical depth for use in non-scattering calculation
   403  !!$    xyr_DOD = ( 1.0_DP - SSA ) * xyr_DOD
   404      !
   405  !!$    do k = 1, kmax
   406  !!$      xyz_DelTrans(:,:,k) = exp( - DiffFact * ( xyr_DOD(:,:,k-1) - xyr_DOD(:,:,k) ) )
   407  !!$    end do
   408  !!$    !
   409  !!$    do k = 0, kmax
   410  !!$      do kk = k, k
   411  !!$        xyrr_Trans(:,:,k,kk) = 1.0_DP
   412  !!$      end do
   413  !!$      do kk = k+1, kmax
   414  !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   415  !!$      end do
   416  !!$    end do
   417  !!$    do k = 0, kmax
   418  !!$      do kk = 0, k-1
   419  !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   420  !!$      end do
   421  !!$    end do
   422  !!$    !
   423  !!$    call RadRTENonScatWrapper(                          &
   424  !!$      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyrr_Trans, & ! (in )
   425  !!$      & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   426  !!$      & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp, & ! (out)
   427  !!$      & WNs, WNe, NumGaussNode                          & ! (in ) optional
   428  !!$      & )
   429  
   430      !----------
   431  
   432  !!$    i = 0
   433  !!$    j = jmax/2+1
   434  !!$    do k = 0, kmax
   435  !!$      write( 70, * ) k, &
   436  !!$        & xyr_RadLUwFluxComp(i,j,k), &
   437  !!$        & xyr_RadLDwFluxComp(i,j,k), &
   438  !!$        & xyra_DelRadLUwFluxComp(i,j,k,0), &
   439  !!$        & xyra_DelRadLUwFluxComp(i,j,k,1), &
   440  !!$        & xyra_DelRadLDwFluxComp(i,j,k,0), &
   441  !!$        & xyra_DelRadLDwFluxComp(i,j,k,1)
   442  !!$    end do
   443  !!$    call flush( 70 )
   444  
   445  
   446      ! Integrate Planck function and temperature derivative of it
   447      !
   448      call Integ_PF_GQ_Array3D(        &
   449        & WNs, WNe, NumGaussNode,      &
   450        & 0, imax-1, 1, jmax, 0, kmax, &
   451        & xyr_Temp,                    &
   452        & xyr_IntPF                    &
   453        & )
   454      call Integ_PF_GQ_Array2D(        &
   455        & WNs, WNe, NumGaussNode,      &
   456        & 0, imax-1, 1, jmax,          &
   457        & xy_SurfTemp,                 &
   458        & xy_SurfIntPF                 &
   459        & )
   460  !    call Integ_DPFDT_GQ_Array2D(             &
   461  !      & WNs, WNe, NumGaussNode,              & ! (in )
   462  !      & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   463  !      & xy_IntDPFDT1                         & ! (out)
   464  !      & )
   465      call Integ_DPFDT_GQ_Array2D(         &
   466        & WNs, WNe, NumGaussNode,          & ! (in )
   467        & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   468        & xy_SurfIntDPFDT                  & ! (out)
   469        & )
   470      !
   471      xyr_IntPF       =               PI * xyr_IntPF
     .        if (xyr_intpf.DSC.U2 .gt. 0) then                                 
     .           J5 = and(xyr_intpf.DSC.U2,3)                                   
     .  !CDIR    NODEP                                                          
     .           do t836 = 1, J5                                                
     .  !CDIR       NODEP                                                       
     .              do t838 = 1, xyr_intpf.DSC.U1 + 1                           
     .                 xyr_intpf(t838-1,t836,t834) = 3.14159265358979e+000*     
     .       1            xyr_intpf(t838-1,t836,t834)                           
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t836 = J5 + 1, xyr_intpf.DSC.U2, 4                          
     .  !CDIR       NODEP                                                       
     .              do t838 = 1, xyr_intpf.DSC.U1 + 1                           
     .                 xyr_intpf(t838-1,t836,t834) = 3.14159265358979e+000*     
     .       1            xyr_intpf(t838-1,t836,t834)                           
     .                 xyr_intpf(t838-1,t836+1,t834) = 3.14159265358979e+000*   
     .       1            xyr_intpf(t838-1,t836+1,t834)                         
     .                 xyr_intpf(t838-1,t836+2,t834) = 3.14159265358979e+000*   
     .       1            xyr_intpf(t838-1,t836+2,t834)                         
     .                 xyr_intpf(t838-1,t836+3,t834) = 3.14159265358979e+000*   
     .       1            xyr_intpf(t838-1,t836+3,t834)                         
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   472      xy_SurfIntPF    = xy_SurfEmis * PI * xy_SurfIntPF
     .        if (xy_surfemis.DSC.U2 .gt. 0) then                               
     .           J6 = and(xy_surfemis.DSC.U2,1)                                 
     .  !CDIR    NODEP                                                          
     .           do t846 = 1, J6                                                
     .  !CDIR       NODEP                                                       
     .              do t848 = 1, xy_surfemis.DSC.U1 + 1                         
     .                 xy_surfintpf(t848-1,t846) = (xy_surfemis(t848-1,t846)*   
     .       1            3.14159265358979e+000)*xy_surfintpf(t848-1,t846)      
     .                 xy_surfintdpfdt(t848-1,t846) = (xy_surfemis(t848-1,t846)*
     .       1            3.14159265358979e+000)*xy_surfintdpfdt(t848-1,t846)   
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t846 = J6 + 1, xy_surfemis.DSC.U2, 2                        
     .  !CDIR       NODEP                                                       
     .              do t848 = 1, xy_surfemis.DSC.U1 + 1                         
     .                 xy_surfintpf(t848-1,t846) = (xy_surfemis(t848-1,t846)*   
     .       1            3.14159265358979e+000)*xy_surfintpf(t848-1,t846)      
     .                 xy_surfintpf(t848-1,t846+1) = (xy_surfemis(t848-1,t846+1)
     .       1            *3.14159265358979e+000)*xy_surfintpf(t848-1,t846+1)   
     .                 xy_surfintdpfdt(t848-1,t846) = (xy_surfemis(t848-1,t846)*
     .       1            3.14159265358979e+000)*xy_surfintdpfdt(t848-1,t846)   
     .                 xy_surfintdpfdt(t848-1,t846+1) = (xy_surfemis(t848-1,t846
     .       1            +1)*3.14159265358979e+000)*xy_surfintdpfdt(t848-1,t846
     .       2            +1)                                                   
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   473  !    xy_IntDPFDT1    =               PI * xy_IntDPFDT1
   474      xy_SurfIntDPFDT = xy_SurfEmis * PI * xy_SurfIntDPFDT
   475      !
   476      call RadRTETwoStreamAppLW(                          &
   477        & xyz_SSA, xyz_AF,                                & ! (in)
   478        & xyr_DOD,                                        & ! (in)
   479        & xy_LWSurfAlbedo,                                & ! (in)
   480        & xyr_IntPF, xy_SurfIntPF, xy_SurfIntDPFDT,       & ! (in)
   481        & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   482        & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp  & ! (out)
   483        & )
   484  
   485  !!$    i = 0
   486  !!$    j = jmax/2+1
   487  !!$    do k = 0, kmax
   488  !!$      write( 80, * ) k, &
   489  !!$        & xyr_RadLUwFluxComp(i,j,k), &
   490  !!$        & xyr_RadLDwFluxComp(i,j,k), &
   491  !!$        & xyra_DelRadLUwFluxComp(i,j,k,0), &
   492  !!$        & xyra_DelRadLUwFluxComp(i,j,k,1), &
   493  !!$        & xyra_DelRadLDwFluxComp(i,j,k,0), &
   494  !!$        & xyra_DelRadLDwFluxComp(i,j,k,1)
   495  !!$    end do
   496  !!$    call flush( 80 )
   497  !!$    stop
   498  
   499      !----------
   500  
   501      xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadLUwFluxComp
     .        if (t181 .gt. 0) then                                             
     .           J7 = and(t181,1)                                               
     .  !CDIR    NODEP                                                          
     .           do t864 = 1, J7                                                
     .  !CDIR       NODEP                                                       
     .              do t866 = 1, t180 + 1                                       
     .                 xyr_radluwflux(t866-1,t864,t862) = xyr_radluwflux(t866-1,
     .       1            t864,t862) + xyr_radluwfluxcomp(t866-1,t864,t862)     
     .                 xyr_radldwflux(t866-1,t864,t862) = xyr_radldwflux(t866-1,
     .       1            t864,t862) + xyr_radldwfluxcomp(t866-1,t864,t862)     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t864 = J7 + 1, t181, 2                                      
     .  !CDIR       NODEP                                                       
     .              do t866 = 1, t180 + 1                                       
     .                 xyr_radluwflux(t866-1,t864,t862) = xyr_radluwflux(t866-1,
     .       1            t864,t862) + xyr_radluwfluxcomp(t866-1,t864,t862)     
     .                 xyr_radluwflux(t866-1,t864+1,t862) = xyr_radluwflux(t866-
     .       1            1,t864+1,t862) + xyr_radluwfluxcomp(t866-1,t864+1,t862
     .       2            )                                                     
     .                 xyr_radldwflux(t866-1,t864,t862) = xyr_radldwflux(t866-1,
     .       1            t864,t862) + xyr_radldwfluxcomp(t866-1,t864,t862)     
     .                 xyr_radldwflux(t866-1,t864+1,t862) = xyr_radldwflux(t866-
     .       1            1,t864+1,t862) + xyr_radldwfluxcomp(t866-1,t864+1,t862
     .       2            )                                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   502      xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadLDwFluxComp
   503      xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadLUwFluxComp
     .  !CDIR NODEP                                                             
     .        do t888 = 1, t196 + 1                                             
     .  !CDIR    NODEP                                                          
     .           do t890 = 1, t195                                              
     .  !CDIR       NODEP                                                       
     .              do t892 = 1, t194 + 1                                       
     .                 xyra_delradluwflux(t892-1,t890,t888-1,0) =               
     .       1            xyra_delradluwflux(t892-1,t890,t888-1,0) +            
     .       2            xyra_delradluwfluxcomp(t892-1,t890,t888-1,0)          
     .                 xyra_delradldwflux(t892-1,t890,t888-1,0) =               
     .       1            xyra_delradldwflux(t892-1,t890,t888-1,0) +            
     .       2            xyra_delradldwfluxcomp(t892-1,t890,t888-1,0)          
     .                 xyra_delradluwflux(t892-1,t890,t888-1,1) =               
     .       1            xyra_delradluwflux(t892-1,t890,t888-1,1) +            
     .       2            xyra_delradluwfluxcomp(t892-1,t890,t888-1,1)          
     .                 xyra_delradldwflux(t892-1,t890,t888-1,1) =               
     .       1            xyra_delradldwflux(t892-1,t890,t888-1,1) +            
     .       2            xyra_delradldwfluxcomp(t892-1,t890,t888-1,1)          
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
   504      xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadLDwFluxComp
   505  
   506  
   507  
   508      !    Flux from 500 to 850 cm-1
   509      !
   510  
   511      QeRat = 0.25_DP                      ! Wavenumber averaged extinction coefficient
   512      SSA   = 0.45_DP                      ! Wavenumber averaged single scattering albedo
   513  
   514      call rad15m_main( TimeN, DelTime, &
   515        & xyz_Temp, xyr_Press, xyz_Press, xy_SurfTemp, &
   516        & xyr_DOD067, QeRat, SSA, xy_SurfEmis, &
   517        & xyr_RadLUwFluxComp, xyra_DelRadLUwFluxComp &
   518        & )
   519      xyr_RadLDwFluxComp     = 0.0_DP
     .        if (xyr_radldwfluxcomp.DSC.U2 .gt. 0) then                        
     .           J8 = and(xyr_radldwfluxcomp.DSC.U2,3)                          
     .  !CDIR    NODEP                                                          
     .           do t920 = 1, J8                                                
     .  !CDIR       NODEP                                                       
     .              do t922 = 1, xyr_radldwfluxcomp.DSC.U1 + 1                  
     .                 xyr_radldwfluxcomp(t922-1,t920,t918) =                   
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t920 = J8 + 1, xyr_radldwfluxcomp.DSC.U2, 4                 
     .  !CDIR       NODEP                                                       
     .              do t922 = 1, xyr_radldwfluxcomp.DSC.U1 + 1                  
     .                 xyr_radldwfluxcomp(t922-1,t920,t918) =                   
     .       1            0.0000000000000000e+000                               
     .                 xyr_radldwfluxcomp(t922-1,t920+1,t918) =                 
     .       1            0.0000000000000000e+000                               
     .                 xyr_radldwfluxcomp(t922-1,t920+2,t918) =                 
     .       1            0.0000000000000000e+000                               
     .                 xyr_radldwfluxcomp(t922-1,t920+3,t918) =                 
     .       1            0.0000000000000000e+000                               
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   520      xyra_DelRadLDwFluxComp = 0.0_DP
     .  !CDIR NODEP                                                             
     .        do t929 = 1, xyra_delradldwfluxcomp.DSC.U3 + 1                    
     .           if (xyra_delradldwfluxcomp.DSC.U2 .gt. 0) then                 
     .              J9 = and(xyra_delradldwfluxcomp.DSC.U2,1)                   
     .  !CDIR       NODEP                                                       
     .              do t931 = 1, J9                                             
     .  !CDIR          NODEP                                                    
     .                 do t933 = 1, xyra_delradldwfluxcomp.DSC.U1 + 1           
     .                    xyra_delradldwfluxcomp(t933-1,t931,t929-1,0) =        
     .       1               0.0000000000000000e+000                            
     .                    xyra_delradldwfluxcomp(t933-1,t931,t929-1,1) =        
     .       1               0.0000000000000000e+000                            
     .                 end do                                                   
     .              end do                                                      
     .  !CDIR       NODEP                                                       
     .              do t931 = J9 + 1, xyra_delradldwfluxcomp.DSC.U2, 2          
     .  !CDIR          NODEP                                                    
     .                 do t933 = 1, xyra_delradldwfluxcomp.DSC.U1 + 1           
     .                    xyra_delradldwfluxcomp(t933-1,t931,t929-1,0) =        
     .       1               0.0000000000000000e+000                            
     .                    xyra_delradldwfluxcomp(t933-1,t931+1,t929-1,0) =      
     .       1               0.0000000000000000e+000                            
     .                    xyra_delradldwfluxcomp(t933-1,t931,t929-1,1) =        
     .       1               0.0000000000000000e+000                            
     .                    xyra_delradldwfluxcomp(t933-1,t931+1,t929-1,1) =      
     .       1               0.0000000000000000e+000                            
     .                 end do                                                   
     .              end do                                                      
     .           endif                                                          
     .        end do                                                            
   521  
   522      xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadLUwFluxComp
     .        if (t181 .gt. 0) then                                             
     .           J10 = and(t181,1)                                              
     .  !CDIR    NODEP                                                          
     .           do t941 = 1, J10                                               
     .  !CDIR       NODEP                                                       
     .              do t943 = 1, t180 + 1                                       
     .                 xyr_radluwflux(t943-1,t941,t939) = xyr_radluwflux(t943-1,
     .       1            t941,t939) + xyr_radluwfluxcomp(t943-1,t941,t939)     
     .                 xyr_radldwflux(t943-1,t941,t939) = xyr_radldwflux(t943-1,
     .       1            t941,t939) + xyr_radldwfluxcomp(t943-1,t941,t939)     
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t941 = J10 + 1, t181, 2                                     
     .  !CDIR       NODEP                                                       
     .              do t943 = 1, t180 + 1                                       
     .                 xyr_radluwflux(t943-1,t941,t939) = xyr_radluwflux(t943-1,
     .       1            t941,t939) + xyr_radluwfluxcomp(t943-1,t941,t939)     
     .                 xyr_radluwflux(t943-1,t941+1,t939) = xyr_radluwflux(t943-
     .       1            1,t941+1,t939) + xyr_radluwfluxcomp(t943-1,t941+1,t939
     .       2            )                                                     
     .                 xyr_radldwflux(t943-1,t941,t939) = xyr_radldwflux(t943-1,
     .       1            t941,t939) + xyr_radldwfluxcomp(t943-1,t941,t939)     
     .                 xyr_radldwflux(t943-1,t941+1,t939) = xyr_radldwflux(t943-
     .       1            1,t941+1,t939) + xyr_radldwfluxcomp(t943-1,t941+1,t939
     .       2            )                                                     
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   523      xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadLDwFluxComp
   524      xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadLUwFluxComp
     .  !CDIR NODEP                                                             
     .        do t965 = 1, t196 + 1                                             
     .  !CDIR    NODEP                                                          
     .           do t967 = 1, t195                                              
     .  !CDIR       NODEP                                                       
     .              do t969 = 1, t194 + 1                                       
     .                 xyra_delradluwflux(t969-1,t967,t965-1,0) =               
     .       1            xyra_delradluwflux(t969-1,t967,t965-1,0) +            
     .       2            xyra_delradluwfluxcomp(t969-1,t967,t965-1,0)          
     .                 xyra_delradldwflux(t969-1,t967,t965-1,0) =               
     .       1            xyra_delradldwflux(t969-1,t967,t965-1,0) +            
     .       2            xyra_delradldwfluxcomp(t969-1,t967,t965-1,0)          
     .                 xyra_delradluwflux(t969-1,t967,t965-1,1) =               
     .       1            xyra_delradluwflux(t969-1,t967,t965-1,1) +            
     .       2            xyra_delradluwfluxcomp(t969-1,t967,t965-1,1)          
     .                 xyra_delradldwflux(t969-1,t967,t965-1,1) =               
     .       1            xyra_delradldwflux(t969-1,t967,t965-1,1) +            
     .       2            xyra_delradldwfluxcomp(t969-1,t967,t965-1,1)          
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
   525      xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadLDwFluxComp
   526  
   527  
   528  
   529      !    Flux from 850 to 2000 cm-1
   530      !
   531      WNs     =  850.0d2
   532      WNe     = 2000.0d2
   533      QeRat   =    0.41_DP                    ! Wavenumber averaged extinction coefficient
   534      SSA     = 0.55_DP
   535      AF      = 0.55_DP
   536  
   537      xyz_SSA = SSA
     .        if (xyz_ssa.DSC.U2 .gt. 0) then                                   
     .           J11 = and(xyz_ssa.DSC.U2,1)                                    
     .  !CDIR    NODEP                                                          
     .           do t997 = 1, J11                                               
     .  !CDIR       NODEP                                                       
     .              do t999 = 1, xyz_ssa.DSC.U1 + 1                             
     .                 xyz_ssa(t999-1,t997,t995+1) = ssa                        
     .                 xyz_af(t999-1,t997,t995+1) = af                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t997 = J11 + 1, xyz_ssa.DSC.U2, 2                           
     .  !CDIR       NODEP                                                       
     .              do t999 = 1, xyz_ssa.DSC.U1 + 1                             
     .                 xyz_ssa(t999-1,t997,t995+1) = ssa                        
     .                 xyz_ssa(t999-1,t997+1,t995+1) = ssa                      
     .                 xyz_af(t999-1,t997,t995+1) = af                          
     .                 xyz_af(t999-1,t997+1,t995+1) = af                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   538      xyz_AF  = AF
   539  
   540      xyr_DOD = QeRat * xyr_DOD067
     .        if (xyr_dod067.DSC.U2 .gt. 0) then                                
     .           J12 = and(xyr_dod067.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t1009 = 1, J12                                              
     .  !CDIR       NODEP                                                       
     .              do t1011 = 1, xyr_dod067.DSC.U1 + 1                         
     .                 xyr_dod(t1011-1,t1009,t1007) = qerat*xyr_dod067(t1011-1, 
     .       1            t1009,t1007)                                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1009 = J12 + 1, xyr_dod067.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t1011 = 1, xyr_dod067.DSC.U1 + 1                         
     .                 xyr_dod(t1011-1,t1009,t1007) = qerat*xyr_dod067(t1011-1, 
     .       1            t1009,t1007)                                          
     .                 xyr_dod(t1011-1,t1009+1,t1007) = qerat*xyr_dod067(t1011-1
     .       1            ,t1009+1,t1007)                                       
     .                 xyr_dod(t1011-1,t1009+2,t1007) = qerat*xyr_dod067(t1011-1
     .       1            ,t1009+2,t1007)                                       
     .                 xyr_dod(t1011-1,t1009+3,t1007) = qerat*xyr_dod067(t1011-1
     .       1            ,t1009+3,t1007)                                       
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   541  
   542      !----------
   543      !    Modification of dust optical depth for use in non-scattering calculation
   544  !!$    xyr_DOD = ( 1.0_DP - SSA ) * xyr_DOD
   545      !
   546  !!$    do k = 1, kmax
   547  !!$      xyz_DelTrans(:,:,k) = exp( - DiffFact * ( xyr_DOD(:,:,k-1) - xyr_DOD(:,:,k) ) )
   548  !!$    end do
   549  !!$    !
   550  !!$    do k = 0, kmax
   551  !!$      do kk = k, k
   552  !!$        xyrr_Trans(:,:,k,kk) = 1.0_DP
   553  !!$      end do
   554  !!$      do kk = k+1, kmax
   555  !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   556  !!$      end do
   557  !!$    end do
   558  !!$    do k = 0, kmax
   559  !!$      do kk = 0, k-1
   560  !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   561  !!$      end do
   562  !!$    end do
   563  !!$    !
   564  !!$    call RadRTENonScatWrapper(                          &
   565  !!$      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyrr_Trans, & ! (in )
   566  !!$      & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   567  !!$      & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp, & ! (out)
   568  !!$      & WNs, WNe, NumGaussNode                          & ! (in ) optional
   569  !!$      & )
   570      !----------
   571  
   572  
   573      ! Integrate Planck function and temperature derivative of it
   574      !
   575      call Integ_PF_GQ_Array3D(        &
   576        & WNs, WNe, NumGaussNode,      &
   577        & 0, imax-1, 1, jmax, 0, kmax, &
   578        & xyr_Temp,                    &
   579        & xyr_IntPF                    &
   580        & )
   581      call Integ_PF_GQ_Array2D(        &
   582        & WNs, WNe, NumGaussNode,      &
   583        & 0, imax-1, 1, jmax,          &
   584        & xy_SurfTemp,                 &
   585        & xy_SurfIntPF                 &
   586        & )
   587  !    call Integ_DPFDT_GQ_Array2D(             &
   588  !      & WNs, WNe, NumGaussNode,              & ! (in )
   589  !      & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   590  !      & xy_IntDPFDT1                         & ! (out)
   591  !      & )
   592      call Integ_DPFDT_GQ_Array2D(         &
   593        & WNs, WNe, NumGaussNode,          & ! (in )
   594        & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   595        & xy_SurfIntDPFDT                  & ! (out)
   596        & )
   597      !
   598      xyr_IntPF       =               PI * xyr_IntPF
     .        if (xyr_intpf.DSC.U2 .gt. 0) then                                 
     .           J13 = and(xyr_intpf.DSC.U2,3)                                  
     .  !CDIR    NODEP                                                          
     .           do t1021 = 1, J13                                              
     .  !CDIR       NODEP                                                       
     .              do t1023 = 1, xyr_intpf.DSC.U1 + 1                          
     .                 xyr_intpf(t1023-1,t1021,t1019) = 3.14159265358979e+000*  
     .       1            xyr_intpf(t1023-1,t1021,t1019)                        
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1021 = J13 + 1, xyr_intpf.DSC.U2, 4                        
     .  !CDIR       NODEP                                                       
     .              do t1023 = 1, xyr_intpf.DSC.U1 + 1                          
     .                 xyr_intpf(t1023-1,t1021,t1019) = 3.14159265358979e+000*  
     .       1            xyr_intpf(t1023-1,t1021,t1019)                        
     .                 xyr_intpf(t1023-1,t1021+1,t1019) = 3.14159265358979e+000*
     .       1            xyr_intpf(t1023-1,t1021+1,t1019)                      
     .                 xyr_intpf(t1023-1,t1021+2,t1019) = 3.14159265358979e+000*
     .       1            xyr_intpf(t1023-1,t1021+2,t1019)                      
     .                 xyr_intpf(t1023-1,t1021+3,t1019) = 3.14159265358979e+000*
     .       1            xyr_intpf(t1023-1,t1021+3,t1019)                      
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   599      xy_SurfIntPF    = xy_SurfEmis * PI * xy_SurfIntPF
     .        if (xy_surfemis.DSC.U2 .gt. 0) then                               
     .           J14 = and(xy_surfemis.DSC.U2,1)                                
     .  !CDIR    NODEP                                                          
     .           do t1031 = 1, J14                                              
     .  !CDIR       NODEP                                                       
     .              do t1033 = 1, xy_surfemis.DSC.U1 + 1                        
     .                 xy_surfintpf(t1033-1,t1031) = (xy_surfemis(t1033-1,t1031)
     .       1            *3.14159265358979e+000)*xy_surfintpf(t1033-1,t1031)   
     .                 xy_surfintdpfdt(t1033-1,t1031) = (xy_surfemis(t1033-1,   
     .       1            t1031)*3.14159265358979e+000)*xy_surfintdpfdt(t1033-1,
     .       2            t1031)                                                
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1031 = J14 + 1, xy_surfemis.DSC.U2, 2                      
     .  !CDIR       NODEP                                                       
     .              do t1033 = 1, xy_surfemis.DSC.U1 + 1                        
     .                 xy_surfintpf(t1033-1,t1031) = (xy_surfemis(t1033-1,t1031)
     .       1            *3.14159265358979e+000)*xy_surfintpf(t1033-1,t1031)   
     .                 xy_surfintpf(t1033-1,t1031+1) = (xy_surfemis(t1033-1,    
     .       1            t1031+1)*3.14159265358979e+000)*xy_surfintpf(t1033-1, 
     .       2            t1031+1)                                              
     .                 xy_surfintdpfdt(t1033-1,t1031) = (xy_surfemis(t1033-1,   
     .       1            t1031)*3.14159265358979e+000)*xy_surfintdpfdt(t1033-1,
     .       2            t1031)                                                
     .                 xy_surfintdpfdt(t1033-1,t1031+1) = (xy_surfemis(t1033-1, 
     .       1            t1031+1)*3.14159265358979e+000)*xy_surfintdpfdt(t1033-
     .       2            1,t1031+1)                                            
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   600  !    xy_IntDPFDT1    =               PI * xy_IntDPFDT1
   601      xy_SurfIntDPFDT = xy_SurfEmis * PI * xy_SurfIntDPFDT
   602      !
   603      call RadRTETwoStreamAppLW(                          &
   604        & xyz_SSA, xyz_AF,                                & ! (in)
   605        & xyr_DOD,                                        & ! (in)
   606        & xy_LWSurfAlbedo,                                & ! (in)
   607        & xyr_IntPF, xy_SurfIntPF, xy_SurfIntDPFDT,       & ! (in)
   608        & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   609        & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp  & ! (out)
   610        & )
   611  
   612      !----------
   613  
   614      xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadLUwFluxComp
     .        if (t181 .gt. 0) then                                             
     .           J15 = and(t181,1)                                              
     .  !CDIR    NODEP                                                          
     .           do t1049 = 1, J15                                              
     .  !CDIR       NODEP                                                       
     .              do t1051 = 1, t180 + 1                                      
     .                 xyr_radluwflux(t1051-1,t1049,t1047) = xyr_radluwflux(    
     .       1            t1051-1,t1049,t1047) + xyr_radluwfluxcomp(t1051-1,    
     .       2            t1049,t1047)                                          
     .                 xyr_radldwflux(t1051-1,t1049,t1047) = xyr_radldwflux(    
     .       1            t1051-1,t1049,t1047) + xyr_radldwfluxcomp(t1051-1,    
     .       2            t1049,t1047)                                          
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1049 = J15 + 1, t181, 2                                    
     .  !CDIR       NODEP                                                       
     .              do t1051 = 1, t180 + 1                                      
     .                 xyr_radluwflux(t1051-1,t1049,t1047) = xyr_radluwflux(    
     .       1            t1051-1,t1049,t1047) + xyr_radluwfluxcomp(t1051-1,    
     .       2            t1049,t1047)                                          
     .                 xyr_radluwflux(t1051-1,t1049+1,t1047) = xyr_radluwflux(  
     .       1            t1051-1,t1049+1,t1047) + xyr_radluwfluxcomp(t1051-1,  
     .       2            t1049+1,t1047)                                        
     .                 xyr_radldwflux(t1051-1,t1049,t1047) = xyr_radldwflux(    
     .       1            t1051-1,t1049,t1047) + xyr_radldwfluxcomp(t1051-1,    
     .       2            t1049,t1047)                                          
     .                 xyr_radldwflux(t1051-1,t1049+1,t1047) = xyr_radldwflux(  
     .       1            t1051-1,t1049+1,t1047) + xyr_radldwfluxcomp(t1051-1,  
     .       2            t1049+1,t1047)                                        
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   615      xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadLDwFluxComp
   616      xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadLUwFluxComp
     .  !CDIR NODEP                                                             
     .        do t1073 = 1, t196 + 1                                            
     .  !CDIR    NODEP                                                          
     .           do t1075 = 1, t195                                             
     .  !CDIR       NODEP                                                       
     .              do t1077 = 1, t194 + 1                                      
     .                 xyra_delradluwflux(t1077-1,t1075,t1073-1,0) =            
     .       1            xyra_delradluwflux(t1077-1,t1075,t1073-1,0) +         
     .       2            xyra_delradluwfluxcomp(t1077-1,t1075,t1073-1,0)       
     .                 xyra_delradldwflux(t1077-1,t1075,t1073-1,0) =            
     .       1            xyra_delradldwflux(t1077-1,t1075,t1073-1,0) +         
     .       2            xyra_delradldwfluxcomp(t1077-1,t1075,t1073-1,0)       
     .                 xyra_delradluwflux(t1077-1,t1075,t1073-1,1) =            
     .       1            xyra_delradluwflux(t1077-1,t1075,t1073-1,1) +         
     .       2            xyra_delradluwfluxcomp(t1077-1,t1075,t1073-1,1)       
     .                 xyra_delradldwflux(t1077-1,t1075,t1073-1,1) =            
     .       1            xyra_delradldwflux(t1077-1,t1075,t1073-1,1) +         
     .       2            xyra_delradldwfluxcomp(t1077-1,t1075,t1073-1,1)       
     .              end do                                                      
     .           end do                                                         
     .        end do                                                            
   617      xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadLDwFluxComp
   618  
   619  
   620  
   621      ! Output variables
   622      !
   623      call HistoryAutoPut( TimeN, 'DOD067', xyr_DOD067 )
   624      do k = 1, kmax
   625        xyz_DustDensScledOptDep(:,:,k) =                  &
     .        if (xyr_dod067.DSC.U2 .gt. 0) then                                
     .           J16 = and(xyr_dod067.DSC.U2,3)                                 
     .  !CDIR    NODEP                                                          
     .           do t1103 = 1, J16                                              
     .  !CDIR       NODEP                                                       
     .              do t1105 = 1, xyr_dod067.DSC.U1 + 1                         
     .                 xyz_dustdensscledoptdep(t1105-1,t1103,k) = (xyr_dod067(  
     .       1            t1105-1,t1103,k-1)-xyr_dod067(t1105-1,t1103,k))/(     
     .       2            xyr_press(t1105-1,t1103,k-1)-xyr_press(t1105-1,t1103,k
     .       3            ))*grav                                               
     .              end do                                                      
     .           end do                                                         
     .  !CDIR    NODEP                                                          
     .           do t1103 = J16 + 1, xyr_dod067.DSC.U2, 4                       
     .  !CDIR       NODEP                                                       
     .              do t1105 = 1, xyr_dod067.DSC.U1 + 1                         
     .                 xyz_dustdensscledoptdep(t1105-1,t1103,k) = (xyr_dod067(  
     .       1            t1105-1,t1103,k-1)-xyr_dod067(t1105-1,t1103,k))/(     
     .       2            xyr_press(t1105-1,t1103,k-1)-xyr_press(t1105-1,t1103,k
     .       3            ))*grav                                               
     .                 xyz_dustdensscledoptdep(t1105-1,t1103+1,k) = (xyr_dod067(
     .       1            t1105-1,t1103+1,k-1)-xyr_dod067(t1105-1,t1103+1,k))/( 
     .       2            xyr_press(t1105-1,t1103+1,k-1)-xyr_press(t1105-1,t1103
     .       3            +1,k))*grav                                           
     .                 xyz_dustdensscledoptdep(t1105-1,t1103+2,k) = (xyr_dod067(
     .       1            t1105-1,t1103+2,k-1)-xyr_dod067(t1105-1,t1103+2,k))/( 
     .       2            xyr_press(t1105-1,t1103+2,k-1)-xyr_press(t1105-1,t1103
     .       3            +2,k))*grav                                           
     .                 xyz_dustdensscledoptdep(t1105-1,t1103+3,k) = (xyr_dod067(
     .       1            t1105-1,t1103+3,k-1)-xyr_dod067(t1105-1,t1103+3,k))/( 
     .       2            xyr_press(t1105-1,t1103+3,k-1)-xyr_press(t1105-1,t1103
     .       3            +3,k))*grav                                           
     .              end do                                                      
     .           end do                                                         
     .        endif                                                             
   626          &   ( xyr_DOD067(:,:,k-1) - xyr_DOD067(:,:,k) ) &
   627          & / ( xyr_Press (:,:,k-1) - xyr_Press (:,:,k) ) &
   628          & * Grav
   629      end do
   630      call HistoryAutoPut( TimeN, 'DustDensScledOptDep', xyz_DustDensScledOptDep )
   631  
   632  
   633    end subroutine RadMarsV1Flux
   634  
   635    !-------------------------------------------------------------------
   636    ! This subroutine will be deleted in future.
   637    !
   638  !!$
   639  !!$  subroutine RadiationRTEQNonScat(                    &
   640  !!$    & WNs, WNe, NumGaussNode,                         & ! (in)
   641  !!$    & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyr_OptDep, & ! (in)
   642  !!$    & xyr_RadLFlux, xyra_DelRadLFlux                  & ! (out)
   643  !!$    & )
   644  !!$    !
   645  !!$    ! ʤξãη׻
   646  !!$    !
   647  !!$    ! Integrate radiative transfer equation without scattering
   648  !!$    !
   649  !!$
   650  !!$    ! ⥸塼 ; USE statements
   651  !!$    !
   652  !!$
   653  !!$    ! ʪ
   654  !!$    ! Physical constants settings
   655  !!$    !
   656  !!$    use constants, only: PI
   657  !!$
   658  !!$    ! ץ󥯴ؿη׻
   659  !!$    ! Calculate Planck function
   660  !!$    !
   661  !!$    use planck_func, only :                            &
   662  !!$      & Integ_PF_GQ_Array3D   , Integ_PF_GQ_Array2D,   &
   663  !!$      & Integ_DPFDT_GQ_Array3D, Integ_DPFDT_GQ_Array2D
   664  !!$
   665  !!$    ! ʸ ; Declaration statements
   666  !!$    !
   667  !!$
   668  !!$    real(DP), intent(in ):: WNs
   669  !!$    real(DP), intent(in ):: WNe
   670  !!$    integer,  intent(in ):: NumGaussNode
   671  !!$    real(DP), intent(in ):: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   672  !!$                              ! $ T $ .     . Temperature
   673  !!$    real(DP), intent(in ):: xy_SurfTemp (0:imax-1, 1:jmax)
   674  !!$                              ! ɽ̲.
   675  !!$                              ! Surface temperature
   676  !!$    real(DP), intent(in ):: xy_SurfEmis (0:imax-1, 1:jmax)
   677  !!$                              ! ɽ̼ͽΨ.
   678  !!$                              ! Surface emissivity
   679  !!$    real(DP), intent(in ):: xyr_OptDep  (0:imax-1, 1:jmax, 0:kmax)
   680  !!$                              ! Optical depth
   681  !!$    real(DP), intent(out):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   682  !!$                              ! Ĺȥեå.
   683  !!$                              ! Longwave flux
   684  !!$    real(DP), intent(out):: xyra_DelRadLFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   685  !!$                              ! ĹɽѲ.
   686  !!$                              ! Surface temperature tendency with longwave
   687  !!$
   688  !!$    ! ѿ
   689  !!$    ! Work variables
   690  !!$    !
   691  !!$    real(DP), parameter :: DiffFact = 1.66_DP
   692  !!$
   693  !!$    real(DP):: xyz_DelTrans (0:imax-1, 1:jmax, 1:kmax)
   694  !!$    real(DP):: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   695  !!$                              ! Ʃ᷸.
   696  !!$                              ! Transmission coefficient
   697  !!$    real(DP):: xyz_IntPF      (0:imax-1, 1:jmax, 1:kmax)
   698  !!$                              ! Integrated Planck function
   699  !!$    real(DP):: xy_SurfIntPF   (0:imax-1, 1:jmax)
   700  !!$                              ! Integrated Planck function with surface temperature
   701  !!$    real(DP):: xyz_IntDPFDT   (0:imax-1, 1:jmax, 1:kmax)
   702  !!$                              ! Integrated temperature derivative of Planck function
   703  !!$    real(DP):: xy_SurfIntDPFDT(0:imax-1, 1:jmax)
   704  !!$                              ! Integrated temperature derivative of Planck function
   705  !!$                              ! with surface temperature
   706  !!$
   707  !!$    integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   708  !!$                              ! Work variables for DO loop in vertical direction
   709  !!$
   710  !!$    ! ¹ʸ ; Executable statement
   711  !!$    !
   712  !!$
   713  !!$    ! 
   714  !!$    ! Initialization
   715  !!$    !
   716  !!$    if ( .not. radiation_dcpam_M_V1_inited ) call RadiationDcpamMV1Init
   717  !!$
   718  !!$    ! Integrate Planck function and temperature derivative of it
   719  !!$    !
   720  !!$    call Integ_PF_GQ_Array3D( &
   721  !!$      & WNs, WNe, NumGaussNode, &
   722  !!$      & 0, imax-1, 1, jmax, 1, kmax, &
   723  !!$      & xyz_Temp, &
   724  !!$      & xyz_IntPF &
   725  !!$      & )
   726  !!$    call Integ_PF_GQ_Array2D( &
   727  !!$      & WNs, WNe, NumGaussNode, &
   728  !!$      & 0, imax-1, 1, jmax, &
   729  !!$      & xy_SurfTemp, &
   730  !!$      & xy_SurfIntPF &
   731  !!$      & )
   732  !!$    call Integ_DPFDT_GQ_Array3D( &
   733  !!$      & 0, imax-1, 1, jmax, 1, kmax, &
   734  !!$      & WNs, WNe, NumGaussNode, xyz_Temp, & ! (in )
   735  !!$      & xyz_IntDPFDT          & ! (out)
   736  !!$      & )
   737  !!$    call Integ_DPFDT_GQ_Array2D( &
   738  !!$      & 0, imax-1, 1, jmax, &
   739  !!$      & WNs, WNe, NumGaussNode, xy_SurfTemp, & ! (in )
   740  !!$      & xy_SurfIntDPFDT           & ! (out)
   741  !!$      & )
   742  !!$
   743  !!$
   744  !!$    ! Ʃؿ׻
   745  !!$    ! Calculate transmission functions
   746  !!$    !
   747  !!$    do k = 1, kmax
   748  !!$      xyz_DelTrans(:,:,k) = &
   749  !!$        & exp( - DiffFact * ( xyr_OptDep(:,:,k-1) - xyr_OptDep(:,:,k) ) )
   750  !!$    end do
   751  !!$    !
   752  !!$    do k = 0, kmax
   753  !!$      do kk = k, k
   754  !!$        xyrr_Trans(:,:,k,kk) = 1.0_DP
   755  !!$      end do
   756  !!$      do kk = k+1, kmax
   757  !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   758  !!$      end do
   759  !!$    end do
   760  !!$    do k = 0, kmax
   761  !!$      do kk = 0, k-1
   762  !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   763  !!$      end do
   764  !!$    end do
   765  !!$
   766  !!$
   767  !!$    ! ͥեå׻
   768  !!$    ! Calculate radiation flux
   769  !!$    !
   770  !!$    do k = 0, kmax
   771  !!$
   772  !!$      xyr_RadLFlux(:,:,k) = xy_SurfEmis * PI * xy_SurfIntPF * xyrr_Trans(:,:,k,0)
   773  !!$
   774  !!$      do kk = 0, kmax-1
   775  !!$        xyr_RadLFlux(:,:,k) = xyr_RadLFlux(:,:,k)                &
   776  !!$          & - PI * xyz_IntPF(:,:,kk+1)                           &
   777  !!$          & * ( xyrr_Trans(:,:,k,kk) - xyrr_Trans(:,:,k,kk+1) )
   778  !!$      end do
   779  !!$
   780  !!$    end do
   781  !!$
   782  !!$
   783  !!$    ! ͥեåѲΨη׻
   784  !!$    ! Calculate rate of change of radiative flux
   785  !!$    !
   786  !!$    do k = 0, kmax
   787  !!$      xyra_DelRadLFlux(:,:,k,0) =                           &
   788  !!$        & xy_SurfEmis * xy_SurfIntDPFDT * xyrr_Trans(:,:,k,0)
   789  !!$
   790  !!$      xyra_DelRadLFlux(:,:,k,1) =                           &
   791  !!$        & xyz_IntDPFDT(:,:,1)                               &
   792  !!$        &   * ( xyrr_Trans(:,:,k,1) - xyrr_Trans(:,:,k,0) )
   793  !!$    end do
   794  !!$
   795  !!$
   796  !!$  end subroutine RadiationRTEQNonScat
   797  !!$
   798    !-------------------------------------------------------------------
   799  
   800    subroutine RadMarsV1Init
   801  
   802      ! ե
   803      ! File I/O support
   804      !
   805      use dc_iounit, only: FileOpen
   806  
   807      ! NAMELIST եϤ˴ؤ桼ƥƥ
   808      ! Utilities for NAMELIST file input
   809      !
   810      use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   811  
   812      ! å
   813      ! Message output
   814      !
   815      use dc_message, only: MessageNotify
   816  
   817      ! ҥȥǡ
   818      ! History data output
   819      !
   820      use gtool_historyauto, only: HistoryAutoAddVariable
   821  
   822      ! û ()
   823      ! Short wave (insolation) incoming
   824      !
   825      use rad_short_income, only : RadShortIncomeInit
   826  
   827      ! ̵뤷ã
   828      ! Radiative transfer equation without considering scattering
   829      !
   830      use rad_rte_nonscat, only : RadRTENonScatInit
   831  
   832      !
   833      ! Solve radiative transfer equation in two stream approximation
   834      !
   835      use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   836  
   837      use rad_Mars_15m, only : rad15m_init
   838  
   839      use set_Mars_dust, only : SetMarsDustInit
   840  
   841      ! ʸ ; Declaration statements
   842      !
   843  
   844      integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   845                                ! Unit number for NAMELIST file open
   846      integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   847                                ! IOSTAT of NAMELIST read
   848  
   849      ! NAMELIST ѿ
   850      ! NAMELIST group name
   851      !
   852      namelist /rad_Mars_V1_nml/ &
   853        & SolarConst
   854            !
   855            ! ǥեͤˤĤƤϽ³ "rad_Mars_V1#RadMarsV1Init"
   856            ! Υɤ򻲾ȤΤ.
   857            !
   858            ! Refer to source codes in the initialization procedure
   859            ! "rad_Mars_V1#RadMarsV1Init" for the default values.
   860            !
   861  
   862      if ( rad_Mars_V1_inited ) return
   863  
   864      ! ǥեͤ
   865      ! Default values settings
   866      !
   867      SolarConst      = 1380.0_DP / 1.52_DP**2
   868  
   869      ! NAMELIST ɤ߹
   870      ! NAMELIST is input
   871      !
   872      if ( trim(namelist_filename) /= '' ) then
   873        call FileOpen( unit_nml, &          ! (out)
   874          & namelist_filename, mode = 'r' ) ! (in)
   875  
   876        rewind( unit_nml )
   877        read( unit_nml,                     & ! (in)
   878          & nml = rad_Mars_V1_nml,          & ! (out)
   879          & iostat = iostat_nml )             ! (out)
   880        close( unit_nml )
   881  
   882        call NmlutilMsg( iostat_nml, module_name ) ! (in)
   883      end if
   884  
   885  
   886      ! Initialization of modules used in this module
   887      !
   888  
   889      ! û ()
   890      ! Short wave (insolation) incoming
   891      !
   892      call RadShortIncomeInit
   893  
   894      ! ̵뤷ã
   895      ! Radiative transfer equation without considering scattering
   896      !
   897      call RadRTENonScatInit
   898  
   899      !
   900      ! Solve radiative transfer equation in two stream approximation
   901      !
   902      call RadRTETwoStreamAppInit
   903  
   904      call rad15m_init
   905  
   906      call SetMarsDustInit
   907  
   908      ! ҥȥǡϤΤΤؤѿϿ
   909      ! Register of variables for history data output
   910      !
   911      call HistoryAutoAddVariable( 'DOD067',             &
   912        & (/ 'lon ', 'lat ', 'sigm', 'time' /),         &
   913        & 'dust optical depth at 0.67 micron meter at the surface', '1' )
   914      call HistoryAutoAddVariable( 'DustDensScledOptDep',    &
   915        & (/ 'lon ', 'lat ', 'sig ', 'time' /),         &
   916        & 'dust density-scaled optical depth at 0.67 micron meter', 'm2 kg-1' )
   917  
   918  
   919      !  ; Print
   920      !
   921      call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   922      call MessageNotify( 'M', module_name, 'SolarConst = %f', d = (/ SolarConst /) )
   923      call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   924  
   925  
   926      rad_Mars_V1_inited = .true.
   927  
   928    end subroutine RadMarsV1Init
   929  
   930    !--------------------------------------------------------------------------------------
   931  
   932  end module rad_Mars_V1
Linux  R2.6.5-7.282-sn2 FORTRAN90/SX         Rev.360        Mon Oct  1 21:50:59 2012
FILE NAME: rad_Mars_V1.f90
PROGRAM NAME: rad_mars_v1
FORMAT LIST

  LINE    LOOP     FORTRAN STATEMENT

     1:            != 絤ͥǥ Ver. 1
     2:            !
     3:            != radiation model for the Mars' atmosphere Ver. 1
     4:            !
     5:            ! Authors::   Yoshiyuki O. Takahashi
     6:            ! Version::   $Id: rad_Mars_V1.f90,v 1.5 2012-09-17 10:59:31 yot Exp $
     7:            ! Tag Name::  $Name: dcpam5-20120921 $
     8:            ! Copyright:: Copyright (C) GFD Dennou Club, 2008. All rights reserved.
     9:            ! License::   See COPYRIGHT[link:../../../COPYRIGHT]
    10:            !
    11:            module rad_Mars_V1
    12:              !
    13:              != 絤ͥǥ Ver. 1
    14:              !
    15:              != radiation model for the Mars' atmosphere Ver. 1
    16:              !
    17:              ! <b>Note that Japanese and English are described in parallel.</b>
    18:              !
    19:              ! ϵ絤ͥǥ.
    20:              !
    21:              ! This is a radiation model for the Mars' atmospehre.
    22:              !
    23:              ! Radiation in the wavenumber range from   40 to  2600 cm-1 
    24:              ! is calculated in the routine of long wave radiation. 
    25:              ! Radiation in the wavenumber range from 2600 to 66667 cm-1 (0.15 to 3.85 micron) 
    26:              ! is calculated in the routine of shortwave radiation. 
    27:              !
    28:              !== References
    29:              !
    30:              !
    31:              !== Procedures List
    32:              !
    33:            !!$  ! RadiationFluxDennouAGCM :: ͥեåη׻
    34:            !!$  ! RadiationDTempDt        :: ͥեåˤ벹Ѳη׻
    35:            !!$  ! RadiationFluxOutput     :: ͥեåν
    36:            !!$  ! RadiationFinalize       :: λ (⥸塼ѿγդ)
    37:            !!$  ! ------------            :: ------------
    38:            !!$  ! RadiationFluxDennouAGCM :: Calculate radiation flux
    39:            !!$  ! RadiationDTempDt        :: Calculate temperature tendency with radiation flux
    40:            !!$  ! RadiationFluxOutput     :: Output radiation fluxes
    41:            !!$  ! RadiationFinalize       :: Termination (deallocate variables in this module)
    42:              !
    43:              !== NAMELIST
    44:              !
    45:            !!$  ! NAMELIST#radiation_DennouAGCM_nml
    46:              !
    47:            
    48:              ! USE statements
    49:              !
    50:            
    51:              !
    52:              ! Kind type parameter
    53:              !
    54:              use dc_types, only: DP, &      ! Double precision.
    55:                &                 STRING, &  ! Strings.
    56:                &                 TOKEN      ! Keywords.
    57:            
    58:              ! ʻ
    59:              ! Grid points settings
    60:              !
    61:              use gridset, only: imax, & ! ٳʻ.
    62:                                         ! Number of grid points in longitude
    63:                &                jmax, & ! ٳʻ.
    64:                                         ! Number of grid points in latitude
    65:                &                kmax    ! ľؿ.
    66:                                         ! Number of vertical level
    67:            
    68:              implicit none
    69:            
    70:              private
    71:            
    72:            
    73:              ! ѿ
    74:              ! Public variables
    75:              !
    76:              logical, save, public:: rad_Mars_V1_inited = .false.
    77:                                          ! ե饰.
    78:                                          ! Initialization flag
    79:            
    80:              ! Private variables
    81:              !
    82:            
    83:              real(DP), save :: SolarConst   ! Solar radiation at the distance of semi-major axis
    84:            
    85:              public :: RadMarsV1Init
    86:              public :: RadMarsV1Flux
    87:            
    88:              character(*), parameter:: module_name = 'rad_Mars_V1'
    89:                                          ! ⥸塼̾.
    90:                                          ! Module name
    91:              character(*), parameter:: version = &
    92:                & '$Name: dcpam5-20120921 $' // &
    93:                & '$Id: rad_Mars_V1.f90,v 1.5 2012-09-17 10:59:31 yot Exp $'
    94:                                          ! ⥸塼ΥС
    95:                                          ! Module version
    96:            
    97:              !--------------------------------------------------------------------------------------
    98:            
    99:            contains
   100:            
   101:              !--------------------------------------------------------------------------------------
   102:            
   103:              subroutine RadMarsV1Flux(                                   &
   104:                & xy_SurfType, xy_SurfMajCompIce,                         &
   105:                & xy_SurfAlbedo,                                          &
   106:                & xyz_Press, xyr_Press, xyz_Temp, xyr_Temp, xy_SurfTemp,  &
   107:                & xyr_RadSUwFlux, xyr_RadSDwFlux,                         &
   108:                & xyr_RadLUwFlux, xyr_RadLDwFlux,                         &
   109:                & xyra_DelRadLUwFlux, xyra_DelRadLDwFlux                  &
   110:                & )
   111:            
   112:                ! USE statements
   113:                !
   114:            
   115:                ! å
   116:                ! Message output
   117:                !
   118:                use dc_message, only: MessageNotify
   119:            
   120:                ! ʪ
   121:                ! Physical and mathematical constants settings
   122:                !
   123:                use constants0, only: &
   124:                  & PI                    ! $ \pi $ .
   125:                                          ! ߼Ψ.  Circular constant
   126:            
   127:                ! ʪ
   128:                ! Physical constants settings
   129:                !
   130:                use constants, only: &
   131:                  & Grav, &
   132:                                        ! $ g $ [m s-2].
   133:                                        ! ϲ®.
   134:                                        ! Gravitational acceleration
   135:                  & GasRDry
   136:            
   137:                ! ȳɹ
   138:                ! Setting constants of snow and sea ice
   139:                !
   140:                use constants_snowseaice, only: &
   141:                  & CO2IceThreshold, &
   142:                  & CO2IceEmisS,     &
   143:                  & CO2IceEmisN
   144:            
   145:                ! ɸǡ
   146:                ! Axes data settings
   147:                !
   148:                use axesset, only: y_Lat
   149:            
   150:                ! 
   151:                ! Time control
   152:                !
   153:                use timeset, only: &
   154:                  & TimeN, &              ! ƥå $ t $ λ.
   155:                                          ! Time of step $ t $.
   156:                  & DelTime, &            ! $ \Delta t $
   157:                  & TimesetClockStart, TimesetClockStop
   158:            
   159:                ! û ()
   160:                ! Short wave (insolation) incoming
   161:                !
   162:                use rad_short_income, only : RadShortIncome
   163:            
   164:                use rad_Mars_15m, only : rad15m_main
   165:            
   166:                use set_Mars_dust, only : &
   167:                  & SetMarsDustSetDOD067, &
   168:                  & SetMarsDustCalcDOD067
   169:            
   170:                ! ̵뤷ã
   171:                ! Radiative transfer equation without considering scattering
   172:                !
   173:                use rad_rte_nonscat, only : RadRTENonScatWrapper
   174:            
   175:                !
   176:                ! Solve radiative transfer equation in two stream approximation
   177:                !
   178:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppHomogAtm, RadRTETwoStreamAppLW
   179:            
   180:                ! ץ󥯴ؿη׻
   181:                ! Calculate Planck function
   182:                !
   183:                use planck_func, only :                            &
   184:                  & Integ_PF_GQ_Array3D, Integ_PF_GQ_Array2D, Integ_DPFDT_GQ_Array2D
   185:            
   186:                ! ҥȥǡ
   187:                ! History data output
   188:                !
   189:                use gtool_historyauto, only: HistoryAutoPut
   190:            
   191:            
   192:                integer , intent(in ) :: xy_SurfType       (0:imax-1, 1:jmax)
   193:                real(DP), intent(in ) :: xy_SurfMajCompIce (0:imax-1, 1:jmax)
   194:                real(DP), intent(in ) :: xy_SurfAlbedo     (0:imax-1, 1:jmax)
   195:                real(DP), intent(in ) :: xyz_Press         (0:imax-1, 1:jmax, 1:kmax)
   196:                real(DP), intent(in ) :: xyr_Press         (0:imax-1, 1:jmax, 0:kmax)
   197:                real(DP), intent(in ) :: xyz_Temp          (0:imax-1, 1:jmax, 1:kmax)
   198:                real(DP), intent(in ) :: xyr_Temp          (0:imax-1, 1:jmax, 0:kmax)
   199:                real(DP), intent(in ) :: xy_SurfTemp       (0:imax-1, 1:jmax)
   200:                real(DP), intent(out) :: xyr_RadSUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   201:                real(DP), intent(out) :: xyr_RadSDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   202:                real(DP), intent(out) :: xyr_RadLUwFlux    (0:imax-1, 1:jmax, 0:kmax)
   203:                real(DP), intent(out) :: xyr_RadLDwFlux    (0:imax-1, 1:jmax, 0:kmax)
   204:                real(DP), intent(out) :: xyra_DelRadLUwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   205:                real(DP), intent(out) :: xyra_DelRadLDwFlux(0:imax-1, 1:jmax, 0:kmax, 0:1)
   206:            
   207:            
   208:            
   209:                real(DP), parameter :: DiffFact = 1.66_DP
   210:            
   211:                real(DP) :: PlanetLonFromVE
   212:                real(DP) :: xyr_DOD067  (0:imax-1, 1:jmax, 0:kmax)
   213:                real(DP) :: xyr_DOD     (0:imax-1, 1:jmax, 0:kmax)
   214:                real(DP) :: xyz_DelTrans(0:imax-1, 1:jmax, 1:kmax)
   215:                real(DP) :: xyrr_Trans  (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   216:            
   217:                real(DP) :: QeRat
   218:                real(DP) :: SSA
   219:                real(DP) :: AF
   220:                real(DP) :: xyz_SSA(0:imax-1, 1:jmax, 1:kmax)
   221:                real(DP) :: xyz_AF (0:imax-1, 1:jmax, 1:kmax)
   222:            
   223:                real(DP) :: xy_LWSurfAlbedo(0:imax-1, 1:jmax)
   224:            
   225:                real(DP) :: xyr_IntPF      (0:imax-1, 1:jmax, 0:kmax)
   226:                real(DP) :: xy_SurfIntPF   (0:imax-1, 1:jmax)
   227:                real(DP) :: xy_SurfIntDPFDT(0:imax-1, 1:jmax)
   228:            
   229:                real(DP) :: xyr_RadLUwFluxComp    (0:imax-1, 1:jmax, 0:kmax)
   230:                real(DP) :: xyr_RadLDwFluxComp    (0:imax-1, 1:jmax, 0:kmax)
   231:                real(DP) :: xyra_DelRadLUwFluxComp(0:imax-1, 1:jmax, 0:kmax, 0:1)
   232:                real(DP) :: xyra_DelRadLDwFluxComp(0:imax-1, 1:jmax, 0:kmax, 0:1)
   233:            
   234:            
   235:                real(DP) :: MajCompIceThreshold
   236:                real(DP) :: MajCompIceEmis
   237:                real(DP) :: xy_SurfEmis(0:imax-1, 1:jmax)
   238:            
   239:                real(DP) :: xy_InAngle (0:imax-1, 1:jmax)
   240:                real(DP) :: DistFromStarScld
   241:                real(DP) :: DiurnalMeanFactor
   242:                real(DP) :: SolarFluxTOA
   243:            
   244:                real(DP) :: xyz_DustDensScledOptDep(0:imax-1, 1:jmax, 1:kmax)
   245:            
   246:                real(DP)           :: WNs
   247:                real(DP)           :: WNe
   248:                integer, parameter :: NumGaussNode = 5
   249:            
   250:                integer :: i
   251:                integer :: j
   252:                integer :: k
   253:                integer :: kk
   254:            
   255:            
   256:            !!$    real(DP) :: MaxError
   257:            
   258:            
   259:            
   260:                ! 
   261:                ! Initialization
   262:                !
   263:                if ( .not. rad_Mars_V1_inited ) then
   264:                  call MessageNotify( 'E', module_name, 'This module has not been initialized.' )
   265:                end if
   266:            
   267:            
   268:                call RadShortIncome(                        &
   269:                  & xy_InAngle         = xy_InAngle,        & ! (out) optional
   270:                  & DistFromStarScld   = DistFromStarScld,  & ! (out) optional
   271:                  & DiurnalMeanFactor  = DiurnalMeanFactor, & ! (out) optional
   272:                  & PlanetLonFromVE    = PlanetLonFromVE    & ! (out) optional
   273:                  & )
   274:                SolarFluxTOA = SolarConst / DistFromStarScld**2 * DiurnalMeanFactor
   275:                PlanetLonFromVE = PlanetLonFromVE * 180.0_DP / PI
   276:            
   277:                !  Dust optical depth
   278:                !
   279:                call SetMarsDustSetDOD067(                  &
   280:                  & PlanetLonFromVE, xyr_Press, xyz_Press,  & ! (in)
   281:                  & xyr_DOD067                              & ! (out)
   282:                  & )
   283:            !!$    call SetMarsDustCalcDOD067( &
   284:            !!$      & xyr_Press, xyz_QDust,   & ! (in)
   285:            !!$      & xyr_DOD067              & ! (out)
   286:            !!$      & )
   287:            
   288:            
   289:                ! û
   290:                ! Short wave radiation
   291:                !
   292:            
   293:            
   294:            !!$    QeRat   = 0.9837_DP    !   Ockert-Bell et al. (1997)
   295:            !!$    xyz_SSA = 0.86_DP
   296:            !!$    xyz_AF  = 0.68_DP
   297:            !!$    QeRat   = 1.0_DP       !   Clancy and Lee (1991)
   298:                SSA = 0.92_DP
   299:                AF  = 0.55_DP
   300:            
   301:            
   302:                call RadRTETwoStreamAppHomogAtm(                                   &
   303:                  & xy_SurfAlbedo, SolarFluxTOA, xy_InAngle, SSA, AF, xyr_DOD067,  & ! (in )
   304:                  & xyr_RadSUwFlux, xyr_RadSDwFlux                                 & ! (out)
   305:                  & )
   306:            
   307:            
   308:            !!$      MaxError = 0.0_DP
   309:            !!$      do k = 0, kmax
   310:            !!$        do j = 1, jmax
   311:            !!$          do i = 0, imax-1
   312:            !!$            MaxError = max( MaxError, &
   313:            !!$              & abs( OLD_xyr_RadSFlux(i,j,k) - xyr_RadSFlux(i,j,k) ) )
   314:            !!$            MaxError = max( MaxError, &
   315:            !!$              & abs( OLD_xyr_RadSFlux(i,j,k) - ( xyr_RadSUwFlux(i,j,k) - xyr_RadSDwFlux(i,j,k) ) ) )
   316:            !!$          end do
   317:            !!$        end do
   318:            !!$      end do
   319:            !!$      write( 6, * ) MaxError
   320:            !!$      write( 6, * ) MaxError, xyr_RadSUwFlux(0,jmax/2+1,kmax)
   321:            
   322:            !!$      MaxError = 0.0_DP
   323:            !!$      do k = 0, kmax
   324:            !!$        do j = 1, jmax
   325:            !!$          do i = 0, imax-1
   326:            !!$            MaxError = max( MaxError, &
   327:            !!$              & abs( OLD_xyr_RadLFlux(i,j,k) - xyr_RadLFlux(i,j,k) ) )
   328:            !!$            MaxError = max( MaxError, &
   329:            !!$              & abs( OLD_xyra_DelRadLFlux(i,j,k,0) - xyra_DelRadLFlux(i,j,k,0) ) )
   330:            !!$            MaxError = max( MaxError, &
   331:            !!$              & abs( OLD_xyra_DelRadLFlux(i,j,k,1) - xyra_DelRadLFlux(i,j,k,1) ) )
   332:            !!$          end do
   333:            !!$        end do
   334:            !!$      end do
   335:            !!$      write( 6, * ) MaxError
   336:            !!$      !
   337:            !!$      xyr_RadSFlux     = OLD_xyr_RadSFlux
   338:            !!$      xyr_RadLFlux     = OLD_xyr_RadLFlux
   339:            !!$      xyra_DelRadLFlux = OLD_xyra_DelRadLFlux
   340:            
   341:            !!$      xyr_RadSUwFlux     = OLD_xyr_RadSFlux
   342:            !!$      xyr_RadSDwFlux     = 0.0_DP
   343:            
   344:            
   345:                ! Ĺ
   346:                ! Long wave radiation
   347:                !
   348:            
   349:                !   Surface albedo for long wave is set.
   350:                !
   351: +V=====        xy_LWSurfAlbedo = 0.0_DP
   352:            
   353: **W---->       xyr_RadLUwFlux     = 0.0_DP
   354: **W----        xyr_RadLDwFlux     = 0.0_DP
   355: ***W--->       xyra_DelRadLUwFlux = 0.0_DP
   356: ***W---        xyra_DelRadLDwFlux = 0.0_DP
   357:            
   358:            
   359:                !  Surface emissivity
   360:                !
   361: +V=====        xy_SurfEmis = 1.0_DP
   362:            
   363:                MajCompIceThreshold = CO2IceThreshold
   364: +------>       do j = 1, jmax
   365: |                if ( y_Lat(j) < 0.0_DP ) then
   366: |                  MajCompIceEmis = CO2IceEmisS
   367: |                else
   368: |                  MajCompIceEmis = CO2IceEmisN
   369: |                end if
   370: |V----->         do i = 0, imax-1
   371: ||                 if ( xy_SurfType(i,j) > 0 ) then
   372: ||                   if ( xy_SurfMajCompIce(i,j) > MajCompIceThreshold ) then
   373: ||                     xy_SurfEmis(i,j) = MajCompIceEmis
   374: ||                   else if ( xy_SurfMajCompIce(i,j) < 0.0_DP ) then
   375: ||                     xy_SurfEmis(i,j) = xy_SurfEmis(i,j)
   376: ||                   else
   377: ||                     xy_SurfEmis(i,j) =                                    &
   378: ||                       &   ( MajCompIceEmis         - xy_SurfEmis(i,j) )   &
   379: ||                       & / ( MajCompIceThreshold    - 0.0_DP           )   &
   380: ||                       & * ( xy_SurfMajCompIce(i,j) - 0.0_DP           )   &
   381: ||                       & + xy_SurfEmis(i,j)
   382: ||                   end if
   383: ||                 end if
   384: |V-----          end do
   385: +------        end do
   386:            
   387:            
   388:                !    Flux from 0 to 500 cm-1
   389:                !
   390:                WNs     =   0.0d2
   391:                WNe     = 500.0d2
   392:                QeRat   = 0.17_DP                       ! Wavenumber averaged extinction coefficient
   393:                SSA     = 0.35_DP
   394:                AF      = 0.36_DP
   395:            
   396: **V---->       xyz_SSA = SSA
   397: **V----        xyz_AF  = AF
   398:            
   399: ++V====        xyr_DOD = QeRat * xyr_DOD067
   400:            
   401:                !----------
   402:                !    Modification of dust optical depth for use in non-scattering calculation
   403:            !!$    xyr_DOD = ( 1.0_DP - SSA ) * xyr_DOD
   404:                !
   405:            !!$    do k = 1, kmax
   406:            !!$      xyz_DelTrans(:,:,k) = exp( - DiffFact * ( xyr_DOD(:,:,k-1) - xyr_DOD(:,:,k) ) )
   407:            !!$    end do
   408:            !!$    !
   409:            !!$    do k = 0, kmax
   410:            !!$      do kk = k, k
   411:            !!$        xyrr_Trans(:,:,k,kk) = 1.0_DP
   412:            !!$      end do
   413:            !!$      do kk = k+1, kmax
   414:            !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   415:            !!$      end do
   416:            !!$    end do
   417:            !!$    do k = 0, kmax
   418:            !!$      do kk = 0, k-1
   419:            !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   420:            !!$      end do
   421:            !!$    end do
   422:            !!$    !
   423:            !!$    call RadRTENonScatWrapper(                          &
   424:            !!$      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyrr_Trans, & ! (in )
   425:            !!$      & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   426:            !!$      & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp, & ! (out)
   427:            !!$      & WNs, WNe, NumGaussNode                          & ! (in ) optional
   428:            !!$      & )
   429:            
   430:                !----------
   431:            
   432:            !!$    i = 0
   433:            !!$    j = jmax/2+1
   434:            !!$    do k = 0, kmax
   435:            !!$      write( 70, * ) k, &
   436:            !!$        & xyr_RadLUwFluxComp(i,j,k), &
   437:            !!$        & xyr_RadLDwFluxComp(i,j,k), &
   438:            !!$        & xyra_DelRadLUwFluxComp(i,j,k,0), &
   439:            !!$        & xyra_DelRadLUwFluxComp(i,j,k,1), &
   440:            !!$        & xyra_DelRadLDwFluxComp(i,j,k,0), &
   441:            !!$        & xyra_DelRadLDwFluxComp(i,j,k,1)
   442:            !!$    end do
   443:            !!$    call flush( 70 )
   444:            
   445:            
   446:                ! Integrate Planck function and temperature derivative of it
   447:                !
   448:                call Integ_PF_GQ_Array3D(        &
   449:                  & WNs, WNe, NumGaussNode,      &
   450:                  & 0, imax-1, 1, jmax, 0, kmax, &
   451:                  & xyr_Temp,                    &
   452:                  & xyr_IntPF                    &
   453:                  & )
   454:                call Integ_PF_GQ_Array2D(        &
   455:                  & WNs, WNe, NumGaussNode,      &
   456:                  & 0, imax-1, 1, jmax,          &
   457:                  & xy_SurfTemp,                 &
   458:                  & xy_SurfIntPF                 &
   459:                  & )
   460:            !    call Integ_DPFDT_GQ_Array2D(             &
   461:            !      & WNs, WNe, NumGaussNode,              & ! (in )
   462:            !      & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   463:            !      & xy_IntDPFDT1                         & ! (out)
   464:            !      & )
   465:                call Integ_DPFDT_GQ_Array2D(         &
   466:                  & WNs, WNe, NumGaussNode,          & ! (in )
   467:                  & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   468:                  & xy_SurfIntDPFDT                  & ! (out)
   469:                  & )
   470:                !
   471: ++V====        xyr_IntPF       =               PI * xyr_IntPF
   472: *V----->       xy_SurfIntPF    = xy_SurfEmis * PI * xy_SurfIntPF
   473: ||         !    xy_IntDPFDT1    =               PI * xy_IntDPFDT1
   474: *V-----        xy_SurfIntDPFDT = xy_SurfEmis * PI * xy_SurfIntDPFDT
   475:                !
   476:                call RadRTETwoStreamAppLW(                          &
   477:                  & xyz_SSA, xyz_AF,                                & ! (in)
   478:                  & xyr_DOD,                                        & ! (in)
   479:                  & xy_LWSurfAlbedo,                                & ! (in)
   480:                  & xyr_IntPF, xy_SurfIntPF, xy_SurfIntDPFDT,       & ! (in)
   481:                  & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   482:                  & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp  & ! (out)
   483:                  & )
   484:            
   485:            !!$    i = 0
   486:            !!$    j = jmax/2+1
   487:            !!$    do k = 0, kmax
   488:            !!$      write( 80, * ) k, &
   489:            !!$        & xyr_RadLUwFluxComp(i,j,k), &
   490:            !!$        & xyr_RadLDwFluxComp(i,j,k), &
   491:            !!$        & xyra_DelRadLUwFluxComp(i,j,k,0), &
   492:            !!$        & xyra_DelRadLUwFluxComp(i,j,k,1), &
   493:            !!$        & xyra_DelRadLDwFluxComp(i,j,k,0), &
   494:            !!$        & xyra_DelRadLDwFluxComp(i,j,k,1)
   495:            !!$    end do
   496:            !!$    call flush( 80 )
   497:            !!$    stop
   498:            
   499:                !----------
   500:            
   501: **V---->       xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadLUwFluxComp
   502: **V----        xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadLDwFluxComp
   503: ***V--->       xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadLUwFluxComp
   504: ***V---        xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadLDwFluxComp
   505:            
   506:            
   507:            
   508:                !    Flux from 500 to 850 cm-1
   509:                !
   510:            
   511:                QeRat = 0.25_DP                      ! Wavenumber averaged extinction coefficient
   512:                SSA   = 0.45_DP                      ! Wavenumber averaged single scattering albedo
   513:            
   514:                call rad15m_main( TimeN, DelTime, &
   515:                  & xyz_Temp, xyr_Press, xyz_Press, xy_SurfTemp, &
   516:                  & xyr_DOD067, QeRat, SSA, xy_SurfEmis, &
   517:                  & xyr_RadLUwFluxComp, xyra_DelRadLUwFluxComp &
   518:                  & )
   519: ++V====        xyr_RadLDwFluxComp     = 0.0_DP
   520: +++V===        xyra_DelRadLDwFluxComp = 0.0_DP
   521:            
   522: **V---->       xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadLUwFluxComp
   523: **V----        xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadLDwFluxComp
   524: ***V--->       xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadLUwFluxComp
   525: ***V---        xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadLDwFluxComp
   526:            
   527:            
   528:            
   529:                !    Flux from 850 to 2000 cm-1
   530:                !
   531:                WNs     =  850.0d2
   532:                WNe     = 2000.0d2
   533:                QeRat   =    0.41_DP                    ! Wavenumber averaged extinction coefficient
   534:                SSA     = 0.55_DP
   535:                AF      = 0.55_DP
   536:            
   537: **V---->       xyz_SSA = SSA
   538: **V----        xyz_AF  = AF
   539:            
   540: ++V====        xyr_DOD = QeRat * xyr_DOD067
   541:            
   542:                !----------
   543:                !    Modification of dust optical depth for use in non-scattering calculation
   544:            !!$    xyr_DOD = ( 1.0_DP - SSA ) * xyr_DOD
   545:                !
   546:            !!$    do k = 1, kmax
   547:            !!$      xyz_DelTrans(:,:,k) = exp( - DiffFact * ( xyr_DOD(:,:,k-1) - xyr_DOD(:,:,k) ) )
   548:            !!$    end do
   549:            !!$    !
   550:            !!$    do k = 0, kmax
   551:            !!$      do kk = k, k
   552:            !!$        xyrr_Trans(:,:,k,kk) = 1.0_DP
   553:            !!$      end do
   554:            !!$      do kk = k+1, kmax
   555:            !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   556:            !!$      end do
   557:            !!$    end do
   558:            !!$    do k = 0, kmax
   559:            !!$      do kk = 0, k-1
   560:            !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   561:            !!$      end do
   562:            !!$    end do
   563:            !!$    !
   564:            !!$    call RadRTENonScatWrapper(                          &
   565:            !!$      & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyrr_Trans, & ! (in )
   566:            !!$      & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   567:            !!$      & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp, & ! (out)
   568:            !!$      & WNs, WNe, NumGaussNode                          & ! (in ) optional
   569:            !!$      & )
   570:                !----------
   571:            
   572:            
   573:                ! Integrate Planck function and temperature derivative of it
   574:                !
   575:                call Integ_PF_GQ_Array3D(        &
   576:                  & WNs, WNe, NumGaussNode,      &
   577:                  & 0, imax-1, 1, jmax, 0, kmax, &
   578:                  & xyr_Temp,                    &
   579:                  & xyr_IntPF                    &
   580:                  & )
   581:                call Integ_PF_GQ_Array2D(        &
   582:                  & WNs, WNe, NumGaussNode,      &
   583:                  & 0, imax-1, 1, jmax,          &
   584:                  & xy_SurfTemp,                 &
   585:                  & xy_SurfIntPF                 &
   586:                  & )
   587:            !    call Integ_DPFDT_GQ_Array2D(             &
   588:            !      & WNs, WNe, NumGaussNode,              & ! (in )
   589:            !      & 0, imax-1, 1, jmax, xyz_Temp(:,:,1), & ! (in )
   590:            !      & xy_IntDPFDT1                         & ! (out)
   591:            !      & )
   592:                call Integ_DPFDT_GQ_Array2D(         &
   593:                  & WNs, WNe, NumGaussNode,          & ! (in )
   594:                  & 0, imax-1, 1, jmax, xy_SurfTemp, & ! (in )
   595:                  & xy_SurfIntDPFDT                  & ! (out)
   596:                  & )
   597:                !
   598: ++V====        xyr_IntPF       =               PI * xyr_IntPF
   599: *V----->       xy_SurfIntPF    = xy_SurfEmis * PI * xy_SurfIntPF
   600: ||         !    xy_IntDPFDT1    =               PI * xy_IntDPFDT1
   601: *V-----        xy_SurfIntDPFDT = xy_SurfEmis * PI * xy_SurfIntDPFDT
   602:                !
   603:                call RadRTETwoStreamAppLW(                          &
   604:                  & xyz_SSA, xyz_AF,                                & ! (in)
   605:                  & xyr_DOD,                                        & ! (in)
   606:                  & xy_LWSurfAlbedo,                                & ! (in)
   607:                  & xyr_IntPF, xy_SurfIntPF, xy_SurfIntDPFDT,       & ! (in)
   608:                  & xyr_RadLUwFluxComp, xyr_RadLDwFluxComp,         & ! (out)
   609:                  & xyra_DelRadLUwFluxComp, xyra_DelRadLDwFluxComp  & ! (out)
   610:                  & )
   611:            
   612:                !----------
   613:            
   614: **V---->       xyr_RadLUwFlux     = xyr_RadLUwFlux     + xyr_RadLUwFluxComp
   615: **V----        xyr_RadLDwFlux     = xyr_RadLDwFlux     + xyr_RadLDwFluxComp
   616: ***V--->       xyra_DelRadLUwFlux = xyra_DelRadLUwFlux + xyra_DelRadLUwFluxComp
   617: ***V---        xyra_DelRadLDwFlux = xyra_DelRadLDwFlux + xyra_DelRadLDwFluxComp
   618:            
   619:            
   620:            
   621:                ! Output variables
   622:                !
   623:                call HistoryAutoPut( TimeN, 'DOD067', xyr_DOD067 )
   624: +------>       do k = 1, kmax
   625: |+V====          xyz_DustDensScledOptDep(:,:,k) =                  &
   626: |                  &   ( xyr_DOD067(:,:,k-1) - xyr_DOD067(:,:,k) ) &
   627: |                  & / ( xyr_Press (:,:,k-1) - xyr_Press (:,:,k) ) &
   628: |                  & * Grav
   629: +------        end do
   630:                call HistoryAutoPut( TimeN, 'DustDensScledOptDep', xyz_DustDensScledOptDep )
   631:            
   632:            
   633:              end subroutine RadMarsV1Flux
   634:            
   635:              !-------------------------------------------------------------------
   636:              ! This subroutine will be deleted in future.
   637:              !
   638:            !!$
   639:            !!$  subroutine RadiationRTEQNonScat(                    &
   640:            !!$    & WNs, WNe, NumGaussNode,                         & ! (in)
   641:            !!$    & xyz_Temp, xy_SurfTemp, xy_SurfEmis, xyr_OptDep, & ! (in)
   642:            !!$    & xyr_RadLFlux, xyra_DelRadLFlux                  & ! (out)
   643:            !!$    & )
   644:            !!$    !
   645:            !!$    ! ʤξãη׻
   646:            !!$    !
   647:            !!$    ! Integrate radiative transfer equation without scattering
   648:            !!$    !
   649:            !!$
   650:            !!$    ! ⥸塼 ; USE statements
   651:            !!$    !
   652:            !!$
   653:            !!$    ! ʪ
   654:            !!$    ! Physical constants settings
   655:            !!$    !
   656:            !!$    use constants, only: PI
   657:            !!$
   658:            !!$    ! ץ󥯴ؿη׻
   659:            !!$    ! Calculate Planck function
   660:            !!$    !
   661:            !!$    use planck_func, only :                            &
   662:            !!$      & Integ_PF_GQ_Array3D   , Integ_PF_GQ_Array2D,   &
   663:            !!$      & Integ_DPFDT_GQ_Array3D, Integ_DPFDT_GQ_Array2D
   664:            !!$
   665:            !!$    ! ʸ ; Declaration statements
   666:            !!$    !
   667:            !!$
   668:            !!$    real(DP), intent(in ):: WNs
   669:            !!$    real(DP), intent(in ):: WNe
   670:            !!$    integer,  intent(in ):: NumGaussNode
   671:            !!$    real(DP), intent(in ):: xyz_Temp    (0:imax-1, 1:jmax, 1:kmax)
   672:            !!$                              ! $ T $ .     . Temperature
   673:            !!$    real(DP), intent(in ):: xy_SurfTemp (0:imax-1, 1:jmax)
   674:            !!$                              ! ɽ̲. 
   675:            !!$                              ! Surface temperature
   676:            !!$    real(DP), intent(in ):: xy_SurfEmis (0:imax-1, 1:jmax)
   677:            !!$                              ! ɽ̼ͽΨ. 
   678:            !!$                              ! Surface emissivity
   679:            !!$    real(DP), intent(in ):: xyr_OptDep  (0:imax-1, 1:jmax, 0:kmax)
   680:            !!$                              ! Optical depth
   681:            !!$    real(DP), intent(out):: xyr_RadLFlux (0:imax-1, 1:jmax, 0:kmax)
   682:            !!$                              ! Ĺȥեå. 
   683:            !!$                              ! Longwave flux
   684:            !!$    real(DP), intent(out):: xyra_DelRadLFlux (0:imax-1, 1:jmax, 0:kmax, 0:1)
   685:            !!$                              ! ĹɽѲ. 
   686:            !!$                              ! Surface temperature tendency with longwave
   687:            !!$
   688:            !!$    ! ѿ
   689:            !!$    ! Work variables
   690:            !!$    !
   691:            !!$    real(DP), parameter :: DiffFact = 1.66_DP
   692:            !!$
   693:            !!$    real(DP):: xyz_DelTrans (0:imax-1, 1:jmax, 1:kmax)
   694:            !!$    real(DP):: xyrr_Trans   (0:imax-1, 1:jmax, 0:kmax, 0:kmax)
   695:            !!$                              ! Ʃ᷸. 
   696:            !!$                              ! Transmission coefficient
   697:            !!$    real(DP):: xyz_IntPF      (0:imax-1, 1:jmax, 1:kmax)
   698:            !!$                              ! Integrated Planck function
   699:            !!$    real(DP):: xy_SurfIntPF   (0:imax-1, 1:jmax)
   700:            !!$                              ! Integrated Planck function with surface temperature
   701:            !!$    real(DP):: xyz_IntDPFDT   (0:imax-1, 1:jmax, 1:kmax)
   702:            !!$                              ! Integrated temperature derivative of Planck function
   703:            !!$    real(DP):: xy_SurfIntDPFDT(0:imax-1, 1:jmax)
   704:            !!$                              ! Integrated temperature derivative of Planck function
   705:            !!$                              ! with surface temperature
   706:            !!$
   707:            !!$    integer:: k, kk           ! ľ˲ DO 롼Ѻѿ
   708:            !!$                              ! Work variables for DO loop in vertical direction
   709:            !!$
   710:            !!$    ! ¹ʸ ; Executable statement
   711:            !!$    !
   712:            !!$
   713:            !!$    ! 
   714:            !!$    ! Initialization
   715:            !!$    !
   716:            !!$    if ( .not. radiation_dcpam_M_V1_inited ) call RadiationDcpamMV1Init
   717:            !!$
   718:            !!$    ! Integrate Planck function and temperature derivative of it
   719:            !!$    !
   720:            !!$    call Integ_PF_GQ_Array3D( &
   721:            !!$      & WNs, WNe, NumGaussNode, &
   722:            !!$      & 0, imax-1, 1, jmax, 1, kmax, &
   723:            !!$      & xyz_Temp, &
   724:            !!$      & xyz_IntPF &
   725:            !!$      & )
   726:            !!$    call Integ_PF_GQ_Array2D( &
   727:            !!$      & WNs, WNe, NumGaussNode, &
   728:            !!$      & 0, imax-1, 1, jmax, &
   729:            !!$      & xy_SurfTemp, &
   730:            !!$      & xy_SurfIntPF &
   731:            !!$      & )
   732:            !!$    call Integ_DPFDT_GQ_Array3D( &
   733:            !!$      & 0, imax-1, 1, jmax, 1, kmax, &
   734:            !!$      & WNs, WNe, NumGaussNode, xyz_Temp, & ! (in )
   735:            !!$      & xyz_IntDPFDT          & ! (out)
   736:            !!$      & )
   737:            !!$    call Integ_DPFDT_GQ_Array2D( &
   738:            !!$      & 0, imax-1, 1, jmax, &
   739:            !!$      & WNs, WNe, NumGaussNode, xy_SurfTemp, & ! (in )
   740:            !!$      & xy_SurfIntDPFDT           & ! (out)
   741:            !!$      & )
   742:            !!$
   743:            !!$
   744:            !!$    ! Ʃؿ׻
   745:            !!$    ! Calculate transmission functions
   746:            !!$    !
   747:            !!$    do k = 1, kmax
   748:            !!$      xyz_DelTrans(:,:,k) = &
   749:            !!$        & exp( - DiffFact * ( xyr_OptDep(:,:,k-1) - xyr_OptDep(:,:,k) ) )
   750:            !!$    end do
   751:            !!$    !
   752:            !!$    do k = 0, kmax
   753:            !!$      do kk = k, k
   754:            !!$        xyrr_Trans(:,:,k,kk) = 1.0_DP
   755:            !!$      end do
   756:            !!$      do kk = k+1, kmax
   757:            !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,k,kk-1) * xyz_DelTrans(:,:,kk)
   758:            !!$      end do
   759:            !!$    end do
   760:            !!$    do k = 0, kmax
   761:            !!$      do kk = 0, k-1
   762:            !!$        xyrr_Trans(:,:,k,kk) = xyrr_Trans(:,:,kk,k)
   763:            !!$      end do
   764:            !!$    end do
   765:            !!$
   766:            !!$
   767:            !!$    ! ͥեå׻
   768:            !!$    ! Calculate radiation flux
   769:            !!$    !
   770:            !!$    do k = 0, kmax
   771:            !!$
   772:            !!$      xyr_RadLFlux(:,:,k) = xy_SurfEmis * PI * xy_SurfIntPF * xyrr_Trans(:,:,k,0)
   773:            !!$
   774:            !!$      do kk = 0, kmax-1
   775:            !!$        xyr_RadLFlux(:,:,k) = xyr_RadLFlux(:,:,k)                &
   776:            !!$          & - PI * xyz_IntPF(:,:,kk+1)                           &
   777:            !!$          & * ( xyrr_Trans(:,:,k,kk) - xyrr_Trans(:,:,k,kk+1) )
   778:            !!$      end do
   779:            !!$
   780:            !!$    end do
   781:            !!$
   782:            !!$
   783:            !!$    ! ͥեåѲΨη׻
   784:            !!$    ! Calculate rate of change of radiative flux
   785:            !!$    !
   786:            !!$    do k = 0, kmax
   787:            !!$      xyra_DelRadLFlux(:,:,k,0) =                           &
   788:            !!$        & xy_SurfEmis * xy_SurfIntDPFDT * xyrr_Trans(:,:,k,0)
   789:            !!$
   790:            !!$      xyra_DelRadLFlux(:,:,k,1) =                           &
   791:            !!$        & xyz_IntDPFDT(:,:,1)                               &
   792:            !!$        &   * ( xyrr_Trans(:,:,k,1) - xyrr_Trans(:,:,k,0) )
   793:            !!$    end do
   794:            !!$
   795:            !!$
   796:            !!$  end subroutine RadiationRTEQNonScat
   797:            !!$
   798:              !-------------------------------------------------------------------
   799:            
   800:              subroutine RadMarsV1Init
   801:            
   802:                ! ե
   803:                ! File I/O support
   804:                !
   805:                use dc_iounit, only: FileOpen
   806:            
   807:                ! NAMELIST եϤ˴ؤ桼ƥƥ
   808:                ! Utilities for NAMELIST file input
   809:                !
   810:                use namelist_util, only: namelist_filename, NmlutilMsg, NmlutilAryValid
   811:            
   812:                ! å
   813:                ! Message output
   814:                !
   815:                use dc_message, only: MessageNotify
   816:            
   817:                ! ҥȥǡ
   818:                ! History data output
   819:                !
   820:                use gtool_historyauto, only: HistoryAutoAddVariable
   821:            
   822:                ! û ()
   823:                ! Short wave (insolation) incoming
   824:                !
   825:                use rad_short_income, only : RadShortIncomeInit
   826:            
   827:                ! ̵뤷ã
   828:                ! Radiative transfer equation without considering scattering
   829:                !
   830:                use rad_rte_nonscat, only : RadRTENonScatInit
   831:            
   832:                !
   833:                ! Solve radiative transfer equation in two stream approximation
   834:                !
   835:                use rad_rte_two_stream_app, only: RadRTETwoStreamAppInit
   836:            
   837:                use rad_Mars_15m, only : rad15m_init
   838:            
   839:                use set_Mars_dust, only : SetMarsDustInit
   840:            
   841:                ! ʸ ; Declaration statements
   842:                !
   843:            
   844:                integer:: unit_nml        ! NAMELIST ե륪ץֹ.
   845:                                          ! Unit number for NAMELIST file open
   846:                integer:: iostat_nml      ! NAMELIST ɤ߹߻ IOSTAT.
   847:                                          ! IOSTAT of NAMELIST read
   848:            
   849:                ! NAMELIST ѿ
   850:                ! NAMELIST group name
   851:                !
   852:                namelist /rad_Mars_V1_nml/ &
   853:                  & SolarConst
   854:                      !
   855:                      ! ǥեͤˤĤƤϽ³ "rad_Mars_V1#RadMarsV1Init"
   856:                      ! Υɤ򻲾ȤΤ.
   857:                      !
   858:                      ! Refer to source codes in the initialization procedure
   859:                      ! "rad_Mars_V1#RadMarsV1Init" for the default values.
   860:                      !
   861:            
   862:                if ( rad_Mars_V1_inited ) return
   863:            
   864:                ! ǥեͤ
   865:                ! Default values settings
   866:                !
   867:                SolarConst      = 1380.0_DP / 1.52_DP**2
   868:            
   869:                ! NAMELIST ɤ߹
   870:                ! NAMELIST is input
   871:                !
   872:                if ( trim(namelist_filename) /= '' ) then
   873:                  call FileOpen( unit_nml, &          ! (out)
   874:                    & namelist_filename, mode = 'r' ) ! (in)
   875:            
   876:                  rewind( unit_nml )
   877:                  read( unit_nml,                     & ! (in)
   878:                    & nml = rad_Mars_V1_nml,          & ! (out)
   879:                    & iostat = iostat_nml )             ! (out)
   880:                  close( unit_nml )
   881:            
   882:                  call NmlutilMsg( iostat_nml, module_name ) ! (in)
   883:                end if
   884:            
   885:            
   886:                ! Initialization of modules used in this module
   887:                !
   888:            
   889:                ! û ()
   890:                ! Short wave (insolation) incoming
   891:                !
   892:                call RadShortIncomeInit
   893:            
   894:                ! ̵뤷ã
   895:                ! Radiative transfer equation without considering scattering
   896:                !
   897:                call RadRTENonScatInit
   898:            
   899:                !
   900:                ! Solve radiative transfer equation in two stream approximation
   901:                !
   902:                call RadRTETwoStreamAppInit
   903:            
   904:                call rad15m_init
   905:            
   906:                call SetMarsDustInit
   907:            
   908:                ! ҥȥǡϤΤΤؤѿϿ
   909:                ! Register of variables for history data output
   910:                !
   911:                call HistoryAutoAddVariable( 'DOD067',             &
   912:                  & (/ 'lon ', 'lat ', 'sigm', 'time' /),         &
   913:                  & 'dust optical depth at 0.67 micron meter at the surface', '1' )
   914:                call HistoryAutoAddVariable( 'DustDensScledOptDep',    &
   915:                  & (/ 'lon ', 'lat ', 'sig ', 'time' /),         &
   916:                  & 'dust density-scaled optical depth at 0.67 micron meter', 'm2 kg-1' )
   917:            
   918:            
   919:                !  ; Print
   920:                !
   921:                call MessageNotify( 'M', module_name, '----- Initialization Messages -----' )
   922:                call MessageNotify( 'M', module_name, 'SolarConst = %f', d = (/ SolarConst /) )
   923:                call MessageNotify( 'M', module_name, '-- version = %c', c1 = trim(version) )
   924:            
   925:            
   926:                rad_Mars_V1_inited = .true.
   927:            
   928:              end subroutine RadMarsV1Init
   929:            
   930:              !--------------------------------------------------------------------------------------
   931:            
   932:            end module rad_Mars_V1
